Package: geoknife
Type: Package
Title: Web-Processing of Large Gridded Datasets
Version: 1.6.11
Authors@R: c( person("Jordan", "Read", role = c("aut"),
    email = "jread@usgs.gov"),
    person("Jordan", "Walker", role = c("aut"),
    email = "jiwalker@usgs.gov"),
    person("Alison", "Appling", role = c("aut"),
    email = "aappling@usgs.gov"),
    person("David", "Blodgett", role = c("aut", "cre"),
    email = "dblodgett@usgs.gov"),
    person("Emily", "Read", role = c("aut"),
    email = "eread@usgs.gov"),
    person("Luke", "Winslow", role = c("aut"),
    email = "lwinslow@usgs.gov"),
    person("Lindsay", "Carr", role = c("aut"),
    email = "lcarr@usgs.gov"),
    person("David", "Watkins", role = c("aut"),
    email = "wwatkins@usgs.gov"))
Description: Processes gridded datasets found on the U.S. Geological Survey
    Geo Data Portal web application or elsewhere, using a web-enabled workflow
    that eliminates the need to download and store large datasets that are reliably
    hosted on the Internet. The package provides access to several data subset and
    summarization algorithms that are available on remote web processing servers (Read et al. (2015) <doi:10.1111/ecog.01880>).
License: CC0
URL: https://github.com/DOI-USGS/geoknife
BugReports: https://github.com/DOI-USGS/geoknife/issues
Copyright: This software is in the public domain because it contains
        materials that originally came from the United States
        Geological Survey, an agency of the United States Department of
        Interior.
Depends: R (>= 3.5)
Imports: whisker, xml2, methods, httr (>= 1.0.0), curl, utils, progress
        (>= 1.1.2), sf
Suggests: testthat, xtable, knitr, rmarkdown, ggmap, dplyr, rasterVis,
        ggplot2, sp, raster
VignetteBuilder: knitr
Encoding: UTF-8
RoxygenNote: 7.2.3
NeedsCompilation: no
Packaged: 2023-07-03 19:46:46 UTC; dblodgett
Author: Jordan Read [aut],
  Jordan Walker [aut],
  Alison Appling [aut],
  David Blodgett [aut, cre],
  Emily Read [aut],
  Luke Winslow [aut],
  Lindsay Carr [aut],
  David Watkins [aut]
Maintainer: David Blodgett <dblodgett@usgs.gov>
Repository: CRAN
Date/Publication: 2023-07-06 08:00:12 UTC

#'@details check is a method for checking the process status of an active (executed)
#' \linkS4class{geojob} object. The method returns \code{process}, which is a list containing
#' two fields: \code{status} and \code{URL}. If the \linkS4class{geojob} object has not been executed
#' (see \code{\link{start}}), this method returns \code{status}='none' and \code{URL}=NULL.
#'
#'@param .Object a \linkS4class{geojob} object with an active GDP process request, 
#' or a \code{character} URL of an existing job
#'@return \code{process}, a list containing
#' \code{status} and \code{URL}. 
#'
#'@description Check status of processing request
#'@title Check status of processing request
#'@aliases check
#'@author Jordan S. Read
#'@seealso \code{\link{start}}
#'@importFrom httr http_error
#'@rdname check-geojob
#'@examples 
#'gj <- geojob() # create geojob object
#'check(gj) # no process for empty geojob object
#'@export            
setGeneric(name="check",def=function(.Object){standardGeneric("check")})

#'@rdname check-geojob
#'@aliases check
setMethod(f = "check",signature(.Object = "geojob"), definition = function(.Object){
	process	<-	list(status=NULL,URL=NULL)
	if (id(.Object) == "<no active job>"){
		process$status <- 'none'
		process$statusType <- 'none'
		process$percentComplete <- 'none'
    return(process)
	} else if (!is.geojobID(id(.Object))) {
	  stop(id(.Object), ' is not a valid geojob ID. Status cannot be checked', call. = FALSE)
	}

	checkForComplete = tryCatch({
    resp <- gGET(url = id(.Object))
    if (httr::http_error(resp)) {
      stop('bad response from server', call. = FALSE)
    }
    resp
    },error = function(e) {
      return(NULL)
      }
    )
  if (is.null(checkForComplete)){
    process$status <- 'unknown'
    process$statusType <- 'unknown'
    process$percentComplete <- 'unknown'
  }
	if (is.null(process$status)){
		checkForCompleteResponse <- gcontent(checkForComplete)
		checkResponseNS <- xml2::xml_ns(checkForCompleteResponse) 
		root <- xml2::xml_root(checkForCompleteResponse)
		status <- xml2::xml_find_all(root,xpath = "//wps:Status", ns = checkResponseNS)
		process$status <- xml2::xml_text(status)
		process$statusType <- xml2::xml_name(xml2::xml_child(status))
		
		if (process$status == "Process successful"){
			root <- xml2::xml_root(checkForCompleteResponse)
			process$percentComplete <- "100"
			process$URL <- xml2::xml_text(xml2::xml_find_all(root, "//@href", ns = checkResponseNS)[[1]])
		} else if (process$status == ""){
		  process$status <- "ProcessStarted"
		} else if (substr(process$status, 1, 34) == "org.n52.wps.server.ExceptionReport"){
		  process$status <- "ProcessFailed"
		} else if (process$status == "Process Started") {
		  process$percentCompleted <- xml2::xml_attr(xml2::xml_find_all(root, "//wps:ProcessStarted"), "percentCompleted", ns = checkResponseNS)
		}
	}
  
  setJobState(process$status)
	return(process)
})

#'@rdname check-geojob
#'@aliases check
setMethod(f = "check",signature(.Object = "character"), definition = function(.Object){
  check(geojob(id = .Object))
})

#' @title Convenience function for GDP process state
#' @rdname successful-methods
#' @aliases
#' successful
#' running
#' error
#' @usage
#' successful(.Object, retry)
#' error(.Object, retry)
#' running(.Object, retry)
#'
#' @param .Object a \linkS4class{geojob} object or geojob ID (character)
#' @param retry logical, attempt to retry again if communication failed with the server
#' @return TRUE/FALSE indicating if process is in the given state (error, processing, successful)
#' @description Simple wrapper to check process status
#'
#' @author Luke Winslow, Jordan S Read
#' @seealso \code{\link{check}}
#'
#' @examples
#' \dontrun{
#' job <- geoknife(stencil = c(-89,42), fabric = 'prism')
#' check(job)
#'
#' running(job)
#' error(job)
#' successful(job)
#' }
#'
#' @export
successful <- function(.Object, retry = FALSE){
  status_is(id(.Object), status = 'successful', retry = retry)
}

#' @rdname successful-methods
#' @aliases running
#' @export
running <- function(.Object, retry = FALSE){
  status_is(id(.Object), status = 'running', retry = retry)
}

#' @rdname successful-methods
#' @aliases error
#' @export
error <- function(.Object, retry = FALSE){
  status_is(id(.Object), status = 'error', retry = retry)
}

status_is <- function(jobID, status, retry){
  
  process = check(jobID)
  if (process$status == 'unknown' && retry){
    Sys.sleep(gconfig('sleep.time'))
    process = check(jobID)
  }
  state <- process$statusType
  switch(status, 
         error = state == "ProcessFailed",
         running = state == "ProcessStarted" | state == "ProcessAccepted",
         successful = state == "ProcessSucceeded")
}

context("Test process input setters")


test_that("process inputs initialize with defaults", {
  testthat::skip_on_cran()
  wp <- readRDS("data/test_webprocess_knife.rds")
  expect_is(wp, 'webprocess')
  expect_is(inputs(wp), 'list')
})

test_that("setting with optional arguments is possible",{
  testthat::skip_on_cran()
  wp <- webprocess(DELIMITER = 'TAB')
  wp2 <- readRDS("data/test_webprocess_knife.rds")
  expect_true(inputs(wp, 'DELIMITER')[[1]] !=  inputs(wp2, 'DELIMITER')[[1]])
  expect_is(inputs(wp), 'list')
  inputs(wp) <- list(DELIMITER = 'COMMA', SUMMARIZE_FEATURE_ATTRIBUTE = 'false')
  expect_equal(inputs(wp, 'DELIMITER'),inputs(wp2, 'DELIMITER'))
})

test_that("get inputs works as expected",{
  testthat::skip_on_cran()
  wp <- readRDS("data/test_webprocess_tab.rds")
  expect_equal(inputs(wp, "DELIMITER")[[1]], 'TAB')
  expect_equal(length(inputs(wp, "DELIMITER")), 1)
  expect_equal(length(inputs(wp, "DELIMITER", "SUMMARIZE_FEATURE_ATTRIBUTE")), 2)
})

test_that("reseting algorithm sets inputs back to defaults",{
  testthat::skip_on_cran()
  wp <- webprocess(DELIMITER = 'TAB', SUMMARIZE_FEATURE_ATTRIBUTE = 'false', wait = TRUE, STATISTICS = "MEAN")
  expect_equal(inputs(wp, 'DELIMITER')[[1]], 'TAB')
  algorithm(wp) <- query(wp, 'algorithms')[1]
  algorithm(wp) <- list('Area Grid Statistics (unweighted)'="gov.usgs.cida.gdp.wps.algorithm.FeatureGridStatisticsAlgorithm")
  expect_equal(inputs(wp), inputs(readRDS("data/test_webprocess_knife.rds"))[names(inputs(wp))])
})

test_that("can use multiple dataset variables",{
  testthat::skip_on_cran()
  fabric <- webdata(url = 'https://cida.usgs.gov/thredds/dodsC/iclus/hc')
  variables(fabric) <- c('housing_classes_iclus_a1_2010', 'housing_classes_iclus_a1_2100')
  cancel()
  knife <- webprocess(algorithm = list('Categorical Coverage Fraction'="gov.usgs.cida.gdp.wps.algorithm.FeatureCategoricalGridCoverageAlgorithm"))
  expect_is(geoknife(stencil = simplegeom(c(-89,45)), 
                     fabric, knife),'geojob')
  cancel()
})

test_that("you can set booleans and they will be lowercase strings for post",{
  testthat::skip_on_cran()
  expect_equal(webprocess(REQUIRE_FULL_COVERAGE = F), webprocess(REQUIRE_FULL_COVERAGE = 'false'))
})

default.sleep <- gconfig("sleep.time")
gconfig('sleep.time' = 1)
test_that("you can set booleans as pass through and that require_full_coverage works",{
  testthat::skip_on_cran()
  cancel()
  fabric <- readRDS("data/test_webdata_fabric.rds")
  job = geoknife(simplegeom(data.frame(point1 = c(-48.6, 45.2), point2=c(-68, 45.2))), fabric, REQUIRE_FULL_COVERAGE = FALSE, wait=TRUE)
  expect_true(all(is.na(result(job)$point1)))
  job = geoknife(simplegeom(data.frame(point1 = c(-48.6, 45.2), point2=c(-88.6, 45.2))), fabric, REQUIRE_FULL_COVERAGE = TRUE, wait=TRUE)
  
  expect_true(error(job))
})
gconfig(sleep.time = default.sleep)

#' the variables of a webdata object
#' 
#' access or set the variables of a webdata object
#' 
#' @param .Object a \code{\link{webdata}} object
#' @param value a character vector for variables
#' @docType methods
#' @usage
#' variables(.Object)
#' variables(.Object) <- value
#' @rdname variables-webdata
#' @aliases 
#' variables<-
#' variables
#' @export
setGeneric(name="variables",def=function(.Object){standardGeneric("variables")})

#'@rdname variables-webdata
#'@docType methods
#'@export
setGeneric(name="variables<-",def=function(.Object, value){standardGeneric("variables<-")})



#'@rdname variables-webdata
#'@export
setMethod(f = "variables",signature(.Object = "webdata"),
          definition = function(.Object){
            return(.Object@variables)
          })


#'@rdname variables-webdata
#'@export
setMethod(f = "variables<-",signature(.Object= "webdata", value = "ANY"),
          definition = function(.Object, value){
            return(initialize(.Object, variables = as.character(value)))
          })

#' parse process output into R environment
#'
#' a \code{geojob} method for loading data into R from a completed processing request
#'
#' @param .Object a \code{\link{geojob}} object with a successful processID,
#' or a \code{character} URL of a completed job.
#' (See \code{\link{check}}).
#' @param ... additional arguments passed to parsers (e.g., with.units = TRUE)
#' @return data.frame of timeseries values. 
#' @rdname result-methods
#' @aliases result
#' @docType methods
#' @keywords methods
#' @importFrom httr GET
#' @author Jordan S. Read
#' @export
#' @examples
#' \dontrun{
#' job <- geoknife(stencil = c(-89,42), fabric = 'prism', wait = TRUE)
#' result(job, with.units = TRUE) # load and print output
#' 
#' # or use the job id:
#' id <- id(job)
#' result(id, with.units = TRUE) # load and print output
#' }
#'
setGeneric(name="result",def=function(.Object, ...){standardGeneric("result")})

#' @rdname result-methods
#' @aliases result
setMethod(f = "result",signature="geojob",
  definition = function(.Object, ...){
    result(id(.Object), ...)
})

#' @rdname result-methods
#' @aliases result
setMethod(f = "result",signature="character",
          definition = function(.Object, ...){
            if (successful(.Object)){
              output <- outputParse(jobID = .Object, ...)
              return(output)
            } else {
              stop('processing is incomplete or has failed. See check(). Processing status: ',
                   check(.Object)$statusType)
            }
})
outputParse = function(jobID, ...){
  funcInfo <- algorithmParseDetails(jobID)
  fileLocation <- check(jobID)$URL
  output <- do.call(funcInfo[['function.name']], args = list(file = fileLocation, 'delim' = funcInfo[['delimiter']], ...))
  return(output)
}

#' @importFrom utils tail
algorithmParseDetails <- function(jobID){
  function.handlers <- list("FeatureWeightedGridStatisticsAlgorithm" = c('function.name'='parseTimeseries'),
                            "FeatureGridStatisticsAlgorithm" = c('function.name'='parseTimeseries'),
                            "FeatureCategoricalGridCoverageAlgorithm" = c('function.name'='parseCategorical'))
  xmlProcess <- gcontent(gGET(jobID))
  algorithm <- xml2::xml_text(xml2::xml_find_all(xmlProcess,
    "/wps:ExecuteResponse/wps:Process/ows:Identifier")[[1]])

  algorithm.name <- tail(strsplit(algorithm, '[.]')[[1]], 1)
  
  if (!algorithm.name %in% names(function.handlers)){
    stop('parser for ',algorithm.name, 
         ' not currently supported. Create an issue to suggest it: https://github.com/DOI-USGS/geoknife/issues/new', call. = FALSE)
  }
  parse.details <- c(function.handlers[[algorithm.name]], 'delimiter'=outputDelimiter(jobID))
  return(parse.details)
}

outputDelimiter <- function(jobID){
  delimiters <- c("text/tab-separated-values" = '\t',
                  "text/csv" = ',',
                  'text/plain' = ' ')
  # find output type
  resp <- rawToChar(GET(jobID)$content)
  doc <-  xml2::read_html(resp)
  type <- xml2::xml_attr(xml2::xml_find_all(doc,"//reference[@mimetype]")[[1]],'mimetype')
  if (!type %in% names(delimiters)){
    stop('output ',type, ' not currently supported. Create an issue to suggest it: https://github.com/DOI-USGS/geoknife/issues/new', call. = FALSE)
  }
  return(delimiters[[type]])
}

#' @rdname wait
#' @aliases wait
#' @title hold up R while GDP is processing
#' 
#' @description keeps R in a loop while GDP works on the request. Checks \code{\link{running}}. 
#' Will drop out of loop whenever !running(geojob)
#' 
#' @param .Object a geojob
#' @param ... other arguments passed to methods
#' @return invisible return of .Object, unaltered
#' @importFrom progress progress_bar
#' @examples
#' \dontrun{
#' job <- geoknife(stencil = c(-89,42), fabric = 'prism')
#' 2+2
#' wait(job, show.progress = TRUE)
#' check(job) # should be complete
#' }
#' @export
setGeneric(name = "wait", 
           def = function(.Object, ...) {
             standardGeneric("wait")
           })

#' @param show.progress logical (optional) show progress bar or not
#' @param sleep.time numeric (optional) a number of seconds to wait in 
#' between checking the process
#' @rdname wait
#' @aliases wait
setMethod(f = "wait", 
          signature(.Object = "geojob"), 
          definition = function(.Object, 
                                sleep.time = gconfig('sleep.time'), 
                                show.progress = gconfig("show.progress")){
            wait(id(.Object), 
                 sleep.time = gconfig('sleep.time'), 
                 show.progress = show.progress)
          })

#' @rdname wait
#' @aliases wait
setMethod(f = "wait", 
          signature(.Object = "character"), 
          definition = function(.Object, 
                                sleep.time = gconfig('sleep.time'), 
                                show.progress = gconfig("show.progress")){
            
            running <- running(.Object, retry = TRUE)
            
            if(show.progress) { 
              pb <- progress_bar$new(total = 100, clear = FALSE)
            }
            
            currentStatus <- 'unknown'
            succeededYet <- FALSE
            currentProgress = 0
            while(running){
              
              Sys.sleep(sleep.time)
              
              running <- running(.Object, retry = TRUE)
              checkResult <- check(.Object)
              
              percentComplete <- checkResult$percentComplete
              
              if(!is.null(percentComplete) && !succeededYet) {
    
                if(show.progress) {
                  
                  if(currentProgress != 100 & as.numeric(percentComplete) <= 100) {

                    pb$update(as.numeric(percentComplete)/100)
                  
                  }
                  
                  currentProgress <- as.numeric(percentComplete)
                  
                }
    
              } else if(checkResult$status != currentStatus) {
                
                message(checkResult$status)
                
              }
              
              currentStatus <- checkResult$status
              if(checkResult$statusType == "ProcessSucceeded" && currentProgress == 100) {
                succeededYet <- TRUE
              }
            }
            invisible(.Object)
          })

#' @importFrom curl curl_version
#' @importFrom utils packageVersion
geoknifeUserAgent <- function() {
  versions <- c(
    libcurl = curl::curl_version()$version,
    `r-curl` = as.character(utils::packageVersion("curl")),
    httr = as.character(utils::packageVersion("httr")),
    geoknife = as.character(utils::packageVersion("geoknife"))
  )
  c(`User-Agent`=paste0(names(versions), "/", versions, collapse = " "))
}
#'@importFrom httr verbose
gverbose <- function(){
  if (gconfig('verbose'))
    httr::verbose()
  else 
    NULL
}

gheaders <- function(){
  httr::add_headers(geoknifeUserAgent())
}

#'@importFrom httr GET add_headers verbose
gGET <- function(url, ...){
  retryVERB(httr::GET, url, ...)
}

#' simple retry for httr VERBs
#' 
#' Useful for intermittent server issues, when a retry will get the job done
#' @param VERB \code{httr} function
#' @param url a url
#' @param \dots additional args passed into VERB
#' @param retries number of times to try before failing
#' @keywords internal
retryVERB <- function(VERB, url, ..., retries = gconfig('retries')){
  response <- simpleError(" ")
  retry <- 0
  while (is(response, 'error') && retry <= retries){
    response <- tryCatch({
      # I don't like doing this, but the GDP response comes back as `content-type`="text/xml" instead of 
      # `content-type`="text/xml; charset=UTF-8" so we get a charset warning message
      suppressWarnings(VERB(url=url, ..., gverbose(), gheaders()))
    }, error=function(e){
      Sys.sleep(gconfig('sleep.time'))
      message('retrying...')
      return(e)
    })
    retry=retry+1
  }
  if (is(response, 'error'))
    stop(response$message, call.=FALSE)
  return(response)
}

#'@importFrom httr POST add_headers
gPOST <- function(url, config = list(), ...){
  retryVERB(httr::POST, url, config=config, ...)
}

#' xml2 version of gcontent
#' 
#' @param response the result of httr::GET(url)
#' @keywords internal
gcontent <- function(response){
  xml2::read_xml(iconv(readBin(response$content, character()), from = "UTF-8", to = "UTF-8"))
}

# takes a web process (knife) and returns a list for use in whisker 
# templating the root element of an execute request.
get_wps_execute_attributes <- function(wp) {
  attribute_list <- list()
  attribute_list["service"] <- "WPS"
  attribute_list["version"] <- version(wp)
  attribute_list["schema_location"] <- paste(c(wp@WPS_NAMESPACE,wp@WPS_SCHEMA_LOCATION),collapse=" ")
  attribute_list["wps"] <- wp@WPS_NAMESPACE
  attribute_list["ows"] <- wp@OWS_NAMESPACE
  attribute_list["ogc"] <- wp@OGC_NAMESPACE
  attribute_list["xlink"] <- wp@XLINK_NAMESPACE
  attribute_list["xsi"] <- wp@XSI_NAMESPACE
  return(attribute_list)
}

algorithmVersion <- function(knife){
  getCaps <- gGET(url(knife), query = list(
    'service' = 'WPS', 'version' = version(knife),'request' = 'DescribeProcess', 
    'identifier'=algorithm(knife)[[1]]))
  doc <- gcontent(getCaps)
  version <- xml2::xml_attrs(xml2::xml_find_all(doc,'//ProcessDescription', 
                                                ns = pkg.env$NAMESPACES)[[1]])[['processVersion']]
  return(version)
}
  

context("geoknife utils")

default.sleep <- geoknife:::gconfig('sleep.time')
geoknife:::gconfig(sleep.time=0.1)

test_that("verbose", {
  testthat::skip_on_cran()
  expect_null(geoknife:::gverbose())
  gconfig(verbose=TRUE)
  expect_is(geoknife:::gverbose(), 'request')
  gconfig(verbose=FALSE)
  
})

test_that("error on url", {
  testthat::skip_on_cran()
  expect_error(geoknife:::retryVERB(httr::GET('bad.url.html')), ".*bad.url.html.*")
})

context("geoknife convienence functions for job state")

test_that("check status of empty job", {
  testthat::skip_on_cran()
  expect_equal(check(geojob())$status, 'none')
  expect_equal(check(geojob())$statusType, 'none')
  expect_equal(check(geojob())$percentComplete, 'none')
})

test_that("check status of an ID that is not valid", {
  testthat::skip_on_cran()
  expect_error(check(geojob(id='bad_id')), 'is not a valid geojob ID. Status cannot be checked')
})

test_that("check status of an ID that is incorrect", {
  testthat::skip_on_cran()
  fake.id <- 'bad_?id=asdf'
  status <- check(geojob(id=fake.id))
  expect_equal(status$status, "unknown")
  expect_equal(status$statusType, "unknown")
})

test_that("check status of an ID that doesn't exist", {
  testthat::skip_on_cran()
  fake.id <- "https://cida.usgs.gov:443/gdp/process/RetrieveResultServlet?id=bad"
  status <- check(geojob(id=fake.id))
  expect_equal(status$status, "unknown")
  expect_equal(status$statusType, "unknown")
})


test_that("check status of an ID that failed", {
  testthat::skip_on_cran()
  fabric <- webdata('prism', variables = 'wrong')
  job <- geoknife(c(-89,43), fabric, wait = TRUE)
  failed.id <- id(job)
  testthat::skip_on_cran()
  status <- check(failed.id)
  expect_equal(status$statusType, "ProcessFailed")
  expect_error(result(failed.id), "processing is incomplete or has failed. See check()")
})

# test_that("percent complete works",{
# Used to test percent complete -- Do Not Run in Continuous Integration!
# fabric <- webdata('prism')
# times(fabric)[2] <- '1990-01-01'
# job <- geoknife(c(-89,43), fabric, wait = F)

# Sys.sleep(5)
# status <- check(job)
# expect_equal(names(status)[4], "percentCompleted")
# expect_true(status$percentComplete != "100")

# Sys.sleep(10)
# status <- check(job)
# expect_true(status$percentComplete == "100")
# })

test_that("can create geojob from xml", {
  xmlLoc <- system.file("extdata", "testjob.xml",
                        package = "geoknife")
  job <- geojob(xml = xmlLoc)
  expect_equal(length(job@url), 0)
  expect_gt(length(job@xml), 0)
  jobWithURL <- geojob(xml = xmlLoc, url = "foo")
  expect_equal(jobWithURL@url, "foo")
})

geoknife:::gconfig(sleep.time=default.sleep)

#' geojob class
#' 
#' contains the information for processing the job, and the versions 
#' of the resources used. 
#' 
#' @slot url URL of web processing endpoint
#' @slot xml XML character for post
#' @slot id job identifier
#' @slot package.version the version of the geoknife package
#' @slot algorithm.version the version of the algorithm used for processing
#' @importFrom utils packageVersion
#' @rdname geojob-class
setClass(
  Class = "geojob",
  representation = representation(
    url = 'character',
    xml = 'character',
    package.version = 'character',
    algorithm.version = 'character',
    id = "character")
)


setMethod(f="initialize",signature="geojob",
          definition=function(
            .Object, 
            id = '<no active job>',
            url = character(0),
            algorithm.version = as.character(NULL),
            xml = as.character(NA)
            ){
            
            .Object@xml <- xml
            .Object@id	<- id
            .Object@url <- url
            .Object@package.version = as.character(package_version(packageVersion(getPackageName())))
            .Object@algorithm.version = algorithm.version
            return(.Object)
          })

#' create geojob object
#' @description A class representing a geoknife job (\code{geojob}).
#'
#' @return the geojob object
#' @author Jordan S Read
#' @rdname geojob-methods
#' @export
setGeneric("geojob", function(xml, ...) {
  standardGeneric("geojob")
})

#'@param ... additional arguments passed to initialize method
#'@rdname geojob-methods
#'@aliases geojob,geojob-method
setMethod("geojob", signature("missing"), function(xml, ...) {
  ## create new geojob object
  geojob <- new("geojob",...)
  return(geojob)
})

setOldClass("xml_document")

#' @rdname geojob-methods
#' @aliases geojob,geojob-method
setMethod("geojob", signature("xml_document"), function(xml, ...) {
  #slots
  xmlText <- toString(xml)
  algorithm.version <- xml2::xml_attrs(xml2::xml_root(xml))[['version']] 
  
  job <- new("geojob", xml = xmlText, 
             algorithm.version = algorithm.version, ...)
  return(job)
})


#'@param xml location of xml (URL or local path) 
#'@rdname geojob-methods
#'@aliases geojob,geojob-method
setMethod("geojob", signature("character"), function(xml, ...) {
  #parse based on xml class
  if(length(xml == 1) && startsWith(x = xml, prefix= "http")){
    response <- gGET(xml)
    doc <- gcontent(response)
  } else {
    doc <- xml2::read_xml(xml)
  }
  
  job <- geojob(xml = doc, ...) 
  return(job)
})





#'@rdname geojob-methods
#'@aliases xml<-,geojob-method
#'@param .Object a \code{\link{geojob}} object
#'@param value a character string of xml 
#'@examples
#'xml <- "<foo> <bar> text <baz/> </bar> </foo>"
#'gj <- geojob()
#'xml(gj) <- xml
#'xml(gj)
#'@export
setGeneric(name="xml<-",def=function(.Object, value){standardGeneric("xml<-")})

setMethod(f = "xml<-",signature = "geojob", definition = function(.Object, value){
    .Object@xml <- value
    return(.Object)
  }
)

#'@rdname geojob-methods
#'@aliases xml,geojob-method
#'@examples
#'xml <- "<foo version=\"1.0.0\"> <bar> text <baz/> </bar> </foo>"
#'gj <- geojob(xml = xml)
#'xml(gj)
#'@export
setGeneric(name="xml",def=function(.Object){standardGeneric("xml")})

setMethod(f = "xml",signature = "geojob", definition = function(.Object){
  value <- .Object@xml
  return(value)
}
)

#'@title process id of geojob
#'@rdname geojob-methods
#'@aliases id,geojob-method
#'@usage
#'id(.Object)
#'id(.Object) <- value
#'@examples
#'id(gj)
#'@export
setGeneric(name="id<-",def=function(.Object, value){standardGeneric("id<-")})

#'@rdname geojob-methods
#'@aliases id,geojob-method
#'@export
setGeneric(name="id",def=function(.Object){standardGeneric("id")})

#'@rdname geojob-methods
#'@aliases id,geojob-method
setMethod(f = "id<-",signature = "geojob", definition = function(.Object, value){
  .Object@id <- value
  return(.Object)
})

#'@rdname geojob-methods
#'@aliases id,geojob-method
setMethod(f = "id",signature = "geojob", definition = function(.Object){
  value <- .Object@id
  return(value)
})

#'@rdname geojob-methods
#'@aliases id,geojob-method
setMethod(f = "id",signature = "character", definition = function(.Object){
  if (is.geojobID(.Object)){
    return(.Object)  
  } else {
    stop(.Object, ' is not a valid geojob id')
  }
  
})

is.geojobID <- function(id){
  grepl('?id=', id)
}

#' webgeom class
#' 
#' The \code{webgeom} class represents a web feature service (WFS) dataset.
#' WFS is an open geospatial consortium standard for spatial data on the web. WFS supports 
#' filtering of spatial elements and this object can support many of those filters. 
#' 
#' @slot url URL of web feature service endpoint. 
#' Can be set or accessed using \code{\link[geoknife]{url}}
#' @slot geom character for geometric feature name. 
#' Can be set or accessed using \code{\link[geoknife]{geom}}
#' @slot attribute character for feature attribute (used for filtering and naming in output)
#' Can be set or accessed using \code{\link[geoknife]{attribute}}
#' @slot values character vector of attribute values to be used in processing (a subset, or all if NA)
#' Can be set or accessed using \code{\link[geoknife]{values}}
#' @slot version a character that specifies the web feature service (WFS) version to use.
#' Can be set or accessed using \code{\link[geoknife]{version}}
#' @slot GML_IDs (_private) IDs that correspond to \code{values}. Used internally for processing. 
#' @slot WFS_NAMESPACE (_private) web location of web feature service namespace
#' @slot GML_NAMESPACE (_private) web location of GML namespace
#' @slot GML_SCHEMA_LOCATION (_private) web location of GML schema location
#' @seealso \code{\link{webgeom}}, \code{\link[geoknife]{url}}, \code{\link[geoknife]{geom}}, 
#' \code{\link[geoknife]{attribute}}, \code{\link[geoknife]{values}}, \code{\link[geoknife]{version}}
#' @rdname webgeom-class
#' @exportClass webgeom
setClass(
  Class = "webgeom",
  prototype = prototype(
    url = paste0(pkg.env$urls$geoserver_base, "/wfs"),
    geom = as.character(NA), 
    attribute = as.character(NA),
    values = as.character(NA), 
    version = '1.1.0'
    ),
  representation = representation(
    url = "character",
    geom = "character",
    attribute = "character",
    values = "character",
    version = "character",
    GML_IDs = "character",
    WFS_NAMESPACE = "character",
    GML_NAMESPACE = "character",
    GML_SCHEMA_LOCATION = "character")
)

setMethod("initialize", signature = "webgeom",
          definition = function(
            .Object, url = .Object@url, geom = .Object@geom, 
            attribute = .Object@attribute,
            values = .Object@values, 
            version = .Object@version
            ){
            .Object@url= url
            .Object@geom = geom
            .Object@attribute = attribute
            .Object@version = version
            .Object@GML_NAMESPACE = pkg.env$NAMESPACES[['gml']]
            .Object@WFS_NAMESPACE   = pkg.env$NAMESPACES[['wfs']]
            .Object@GML_SCHEMA_LOCATION = pkg.env$SCHEMA_LOCATIONS[['GML_SCHEMA_LOCATION']]
            
            values(.Object) = values
            
            
            return(.Object)
          })

#' create webgeom object
#' 
#' A class representing a web available feature geometry.
#'
#' @slot url value of type \code{"character"}, the web location for the web feature service
#' @slot geom value of type \code{"character"}, the feature for webgeom
#' @slot attribute the attribute (e.g., "State")
#' @slot values the values of the attribute, (e.g., "Wisconsin") or NA (all)
#'
#' @details slots can be accessed or set with methods of the same names 
#' (e.g., url(webgeom()))
#' 
#' @seealso \code{\link{url}}, \code{\link{geom}}, \code{\link{attribute}}, \code{\link{values}}
#'
#' @param .Object any object that can be coerced into \linkS4class{webgeom}
#' @param \dots additional arguments passed initialize method (e.g., \code{\link{url}}). See 
#' the named slots above for arguments for \dots
#' @return the webgeom object representing a dataset and parameters
#' @author Jordan S Read
#' @rdname webgeom-methods
#' @examples
#' wg <- webgeom(geom = "sample:CONUS_states", 
#'  attribute = "STATE",
#'  values = "New Hampshire")
#'#-- use available state datasets:
#' wg <- webgeom('state::New Hampshire')
#' wg <- webgeom('state::New Hampshire,Wisconsin,Alabama')
#'#-- use available Level III Ecoregion datasets:
#' wg <- webgeom('ecoregion::Colorado Plateaus,Driftless Area')
#'#-- use available simplified HUC8s:
#' wg <- webgeom('HUC8::09020306,14060009')
#' wg <- webgeom()
#' 
#' \dontrun{
#' ## Steps to find data on Howard County in Texas:
#' #1) locate the \code{geom} for counties by looking at the options for geoms
#' query(webgeom(), 'geoms') # discover sample:Counties
#' #2) locate the \code{attribute} for county names by looking at the options for attributes
#' query(webgeom(geom='sample:Counties'), 'attributes') # discover FIPS
#' #3) find the appropriate fip code for the county:
#' howard.fips <- "48227"
#' #4) create a webgeom for the Howard County in Texas
#' stencil <- webgeom(geom='sample:Counties', attribute='FIPS', values=howard.fips)
#' #5) get data for Howard County
#' fabric <- webdata(url = 'https://cida.usgs.gov/thredds/dodsC/stageiv_combined', 
#' variables = "Total_precipitation_surface_1_Hour_Accumulation", 
#' times = c(as.POSIXct("2016-06-06 05:00:00"), 
#'           as.POSIXct("2016-06-07 05:00:00")))
#' job <- geoknife(stencil, fabric, wait = TRUE)
#' precipData <- result(job)
#' head(precipData)
#' }
#' @export
setGeneric("webgeom", function(.Object, ...) {
  standardGeneric("webgeom")
})

#' @rdname webgeom-methods
#' @aliases webgeom
setMethod("webgeom", signature('missing'), function(.Object, ...) {
  ## create new webgeom object
  webgeom <- new("webgeom", ...)
  return(webgeom)
})

#' @rdname webgeom-methods
#' @aliases webgeom
setMethod("webgeom", signature('ANY'), function(.Object, ...) {
  ## create new webgeom object
  webgeom <- as(.Object, "webgeom")
  if (!missing(...)){
    webgeom <- initialize(webgeom, ...)
  }
  return(webgeom)
})

setAs("character", "webgeom", function(from){
  
  datasets <- list('state' = 
                     list(geom = "sample:CONUS_states",
                          attribute = "STATE"),
                   'ecoregion' = 
                     list(geom = "sample:Ecoregions_Level_III",
                          attribute = "LEVEL3_NAM"),
                   'HUC8' = 
                     list(geom = "sample:simplified_huc8",
                          attribute = "HUC_8"))
                   
  pieces <- strsplit(from, split = '::')[[1]]
  
  if (length(pieces) > 2)
    stop('invalid value for ', from, call.=FALSE)
  
  quickgeom <- match.arg(pieces[1], names(datasets))
  
  values <- strsplit(pieces[2], split = ',')[[1]]

  args <- datasets[[quickgeom]]
  args$values <- values

  return(do.call(webgeom, args))
})

setOldClass("sf")

#' @title simplegeom class
#' @description The \code{simplegeom} class represents geometries that can 
#' be coerced into polygon features. This is one of two \code{stencil} types 
#' accepted by \code{\link{geoknife}} (the other being \linkS4class{webgeom}).
#' @slot sf an sf data.frame object with polygon geometries
#' @slot sp an sp object provided for backward compatibility
#' @slot DRAW_NAMESPACE (_private) web location of draw namespace
#' @slot DRAW_SCHEMA (_private) web location of draw schema
#' @details The difference between \linkS4class{webgeom} and \linkS4class{simplegeom} 
#' is both in the permanence and the location of the data. \linkS4class{webgeom} is 
#' located on a web server that offers geometries using the web feature service (WFS) 
#' specification. \linkS4class{simplegeom} are typically local data that can be accessed 
#' within an R session. Within reason, anything that can be represented as a 
#' \linkS4class{webgeom} (or WFS) can also be represented by a \linkS4class{simplegeom} 
#' For example, a state or watershed can be read in as \code{\link[sf]{read_sf}} 
#' object and turned into a \linkS4class{simplegeom}. IDs of a web geom are the
#' row order of the geometries.
#' 
#' @rdname simplegeom-class
#' @exportClass simplegeom
setClass(
  Class = "simplegeom",
  representation(sf= "sf",
                 sp = "ANY",
                 DRAW_NAMESPACE = "character",
                 DRAW_SCHEMA = "character")
)

#'@importFrom sf st_sf as_Spatial
setMethod("initialize", signature = "simplegeom", 
          definition = function(.Object, ...) {
            .Object@DRAW_NAMESPACE = 'gov.usgs.wma.gdp.draw'
            .Object@DRAW_SCHEMA = pkg.env$urls$draw_schema
            .Object@sf = st_sf(...)
            .Object@sp = as_Spatial(.Object@sf)
            return(.Object)
          })


#' Create simplegeom object
#' 
#' A simple geom is a simple set of geometries specified locally. See 
#' \code{\link{webgeom}} for web features. 
#' 
#' @param .Object any object that can be coerced into \linkS4class{simplegeom}
#' @param ... additional arguments passed to \code{\link[sf]{st_sf}}
#' @return the simplegeom object
#' @examples 
#' 
#' simplegeom(c(-88.6, 45.2))
#' 
#' p1 <- sf::st_polygon(list(cbind(c(-89.0001,-89,-88.9999,-89,-89.0001),
#'                                 c(46,46.0001,46,45.9999,46))))
#' 
#' p2 <- sf::st_polygon(list(cbind(c(-88.6,-88.5999,-88.5999,-88.6,-88.6),
#'                                 c(45.2,45.2,45.1999,45.1999,45.2))))
#' 
#' P <- simplegeom(
#'   sf::st_sf(geo = sf::st_sfc(list(p1, p2), crs = 4326))
#' )
#' 
#' \dontrun{
#' result(geoknife(P, "prism", wait = TRUE))
#' }
#' 
#' simplegeom(data.frame('point1'=c(-89, 46), 'point2'=c(-88.6, 45.2)))
#' 
#' @author Jordan S Read
#' @rdname simplegeom-methods
#' @export
setGeneric("simplegeom", function(.Object, ...) {
  standardGeneric("simplegeom")
})


#' @rdname simplegeom-methods
#' @aliases simplegeom
setMethod("simplegeom", signature("missing"), function(.Object, ...) {
  ## create new simplegeom object
  
  simplegeom <- tryCatch({
    
    new("simplegeom", ...)
    
  }, error = function(e) {
    
    warning("SpatialPolygons support is deprecated.")
    
    if(!requireNamespace("sp")) stop("sp required for spatialpolygons support")
    
    as(sp::SpatialPolygons(...), "simplegeom")
    
  })
  
  return(simplegeom)
})

#' @rdname simplegeom-methods
#' @aliases simplegeom
setMethod("simplegeom", signature("ANY"), function(.Object, ...) {
  ## create new simplegeom object
  # ... are additional arguments passed to sf::st_sf
  simplegeom <- as(.Object, "simplegeom")
  if (!missing(...)){
    simplegeom <- initialize(simplegeom, ...)
  }
  return(simplegeom)
})

setAs("numeric","simplegeom",function(from) {
  
  ## create new simplegeom object based on a lon lat pair
  if (length(from) == 2){
    ring <- data.frame('bufferedPoint' = from)
  } else {
    stop('numeric input to simplegeom needs to be a single lon,lat pair')
  }
  
  # pass to data.frame method
  return(as(ring, 'simplegeom'))
})

#'@importFrom sf st_polygon st_sfc 
setAs("data.frame", "simplegeom", function(from) {
  
  ## create new simplegeom object based on a lon lat pair
  if (nrow(from) == 2){
    ring <- sapply(from, FUN = bufferPoint)
  } else {
    stop('data.frame input to simplegeom needs to be have 2 rows: longitude & latitude')
  }
  
  poly <- apply(ring, 2, function(x) {
    sf::st_polygon(list(matrix(x, ncol = 2, byrow = TRUE)))
  })
  
  poly <- sf::st_sf(ID = names(poly), geom = sf::st_sfc(poly, crs = 4326))
  
  simplegeom <- as(poly, "simplegeom")
  
  return(simplegeom)
})

#' @importFrom sf st_crs st_transform st_geometry_type
setAs("sf", "simplegeom", function(from) {
  
  if(is.na(sf::st_crs(from))) {
    stop("No CRS provided to simplegeom.")
  }
  
  if (sf::st_crs(from) != sf::st_crs(4326)) {
    warning("CRS of input not WGS84 lon/lat -- transformation is being applied")
    
    from <- sf::st_transform(from, 4326)
    
  }  
  
  if(!grepl("polygon", st_geometry_type(from, by_geometry = FALSE), 
            ignore.case = TRUE)) {
    stop("sf data.frame must contain polygon or multipolygon geometries.")
  }
  
  simplegeom <- new("simplegeom", from)
  
  return(simplegeom)
  
})

setAs("SpatialPolygons", "simplegeom", function(from) {
  
  from <- as(sf::st_as_sf(from), "simplegeom")
  
  return(from)
})

setMethod("show", "simplegeom", function(object){
  cat('An object of class "simplegeom":\n')
  print(object@sf)
})

#' datagroup class
#' 
#' contains collections of webdata that can be processed with 
#' \code{\link{geoknife}}
#' 
#' @slot group a list of webdata compatible elements
#' @rdname datagroup-class
setClass(
  Class = "datagroup",
  representation = representation(
    group = 'list')
)


setMethod(f="initialize",signature="datagroup",
          definition=function(
            .Object, 
            group = list()){
            
            .Object@group <- group
            return(.Object)
          })

#' create datagroup object
#' @description A class representing a geoknife job (\code{datagroup}).
#'
#' @return the datagroup object
#' @author Jordan S Read
#' @rdname datagroup-methods
#' @export
setGeneric("datagroup", function(...) {
  standardGeneric("datagroup")
})

#' @param x a datagroup object
#' @param i index specifying elements to extract or replace.
#' @param j not implemented
#' @param drop not implemented
#' @param ... additional arguments passed to initialize method
#' @rdname datagroup-methods
#' @aliases datagroup,datagroup-methods
setMethod("datagroup", signature(), function(...) {
  ## create new geojob object
  datagroup <- new("datagroup",...)
  return(datagroup)
})


setAs('datagroup', 'webdata', function(from){
  if (length(from@group) > 1){
    warning('coercing datagroup into webdata. More than one dataset specified, using the first.')
  }
  .Object <- do.call(what = "webdata", args = list(url = from@group[[1]]$url))
  return(.Object)
})


#' get abstract from a datagroup
#' 
#' extracts the abstract information from a datagroup object
#' 
#' @param .Object a datagroup object
#'@rdname abstract-datagroup
#'@aliases 
#'abstract
#'title
#'@export
setGeneric(name="abstract",def=function(.Object){standardGeneric("abstract")})

#'@rdname abstract-datagroup
#'@aliases abstract
setMethod(f = "abstract",signature(.Object = "datagroup"),
          definition = function(.Object){
            return(sapply(.Object@group, function(x) x$abstract))
          })

#' @rdname abstract-datagroup
#' @aliases 
#' abstract
#' title
#'@export
setGeneric(name="title",def=function(.Object){standardGeneric("title")})

#'@rdname abstract-datagroup
#'@aliases 
#'abstract
#'title
setMethod(f = "title",signature(.Object = "datagroup"),
          definition = function(.Object){
            return(sapply(.Object@group, function(x) x$title))
          })
#'@rdname datagroup-methods
#'@aliases datagroup,datagroup-methods
setMethod(f = "length",signature(x = "datagroup"),
          definition = function(x){
            return(length(x@group))
          })


#'@rdname datagroup-methods
#'@aliases datagroup,datagroup-methods
setMethod("[", signature(x='datagroup',i="ANY",j='ANY'), function(x, i, j, ..., drop = TRUE) {
  if (is.character(i))
    i = which(title(x) %in% i)
  return(datagroup(x@group[i]))
})

#'@rdname datagroup-methods
#'@aliases datagroup,datagroup-methods
setMethod("[[", signature('datagroup',i="ANY",j='ANY'), function(x, i, j, ..., drop = TRUE) {
  
  
  return(x@group[[i]])
})

.setProcessInputs <- function(webprocess, ...){
  processNames <- names(inputs(webprocess))
  for (i in seq_along(processNames)){
    fun <- paste0('.',processNames[i])
    if (exists(fun)){
      inputs(webprocess,processNames[i]) <- do.call(fun, list(...))
    } else if (is.null(inputs(webprocess,processNames[i])[[1]])){
      inputs(webprocess,processNames[i]) <- .defaultWhenNull(processNames[i])
    } else {
      # / skip. will skip and allow NA, which is an optional input.
    }
    
  }
  
  return(webprocess)
}

.defaultWhenNull <- function(varName){
  defaults <- list(GROUP_BY = 'STATISTIC',
                   STATISTICS = 'MEAN')
  return(defaults[[varName]])
  
}


.FEATURE_ATTRIBUTE_NAME <- function(stencil,...){
  if (is(stencil,'webgeom')){
    filterBy <- stencil@attribute
  } else if (is(stencil,'simplegeom')){
    filterBy <- 'ID'
  } else {
    stop('FEATURE_ATTRIBUTE_NAME not supported for class ',class(stencil))
  }
  return(filterBy)
}

.TIME_END <- function(fabric, ...){
  strftime(times(fabric)[2] ,format = "%Y-%m-%dT%H:%M:%S.000Z", tz='UTC')
}
.TIME_START <- function(fabric, ...){
  strftime(times(fabric)[1] ,format = "%Y-%m-%dT%H:%M:%S.000Z", tz='UTC')
}

.DATASET_ID <- function(fabric, ...){
  if(!is.na(variables(fabric)[1])) {
    return(variables(fabric))
  } else {
    stop('variables cannot be NA')
  }
}

.DATASET_URI <- function(fabric, ...){
  dodsReplace(url(fabric))
}

#' @importFrom httr HEAD headers
dodsReplace  <-	function(uri){
  # checks for dods or opendap, and replaces
  
  if (substr(uri, 1, 4) == 'dods')
    return(uri)
  
  dods.serve <- httr::headers(httr::HEAD(uri))$`xdods-server`
  if (!is.null(dods.serve) || grepl('dodsC',uri)){ # catch the case where prism, comes back 400 from HEAD, but is dods
    uri	<-	gsub('http[s]?', 'dods', uri)
  }
  
  return(uri)
}

context("dodsReplace")


test_that("prism is replaced", {
  testthat::skip_on_cran()
  expect_equal(geoknife:::dodsReplace('https://cida.usgs.gov/thredds/dodsC/prism_v2'),'dods://cida.usgs.gov/thredds/dodsC/prism_v2')
})

#'@rdname times_query-method
#'@aliases times_query,webdata-method
#'@export
setGeneric(name="times_query",def=function(fabric, knife){standardGeneric("times_query")})

#' times query
#' 
#' query a webdata object for the time range
#' 
#' @rdname times_query-method
#' @aliases times_query,webdata-method
#' @keywords internal
#' @export
setMethod(f = "times_query",signature = c("webdata","missing"), 
          definition = function(fabric, knife){
            knife <- webprocess()
            times_query(fabric, knife)
          })

#'@rdname times_query-method
#'@aliases times_query,webdata-method
#'@keywords internal
#'@export
setMethod(f = "times_query",signature = c("webdata","webprocess"), 
          definition = function(fabric, knife){
            
            if (any(is.na(variables(fabric)))){
              stop('variables cannot be NA for fabric argument when querying for available time range', call. = FALSE)
            } 
            if (length(variables(fabric)) > 1) {
              warning('variables is > 1, using ', variables(fabric)[1], 
                      ' only when querying for available time range', call. = FALSE)    
            }
            
            response <- genericExecute(knife@UTILITY_URL,
                                       make_getgridtimerange_execute_xml(fabric, knife))
            values <- tryCatch({
              nodes <- xml2::xml_find_all(gcontent(response),'//gdp:availabletimes/gdp:time')
              as.POSIXct(xml2::xml_text(nodes), tz = 'UTC')
            }, error = function(err) {
              return(as.POSIXct(c(NA,NA)))
            })
            
            return(values)
          })

make_getgridtimerange_execute_xml <- function(fabric, knife) {
  getgtr_list <- get_wps_execute_attributes(knife)
  getgtr_list["identifier"] <- fabric@timeList
  input_list <- list()
  input_list <- list(list(input_identifier = "catalog-url",
                          input_literal_data_element = url(fabric)),
                     list(input_identifier = "grid",
                          input_literal_data_element = variables(fabric)[1]),
                     list(input_identifier = "allow-cached-response",
                          input_literal_data_element = "false"))
  getgtr_list <- c(getgtr_list, inputs = list(input_list))
  getgtr_list["rawoutput"] <- list(list(result_name = "result_as_xml"))
  return(whisker::whisker.render(readLines(system.file(
    "templates/utility_execute_template.xml", package = "geoknife")), 
    getgtr_list))
}

context("test email xml templating")

test_that("basic email template works", {
  wp <- readRDS("data/test_email_wp.rds")
  gj <- readRDS("data/test_email_gj.rds")
  xml <- geoknife:::make_email_execute_xml(gj, wp)
  
  fn <- "data/test_email.xml"
  expect_equal(xml, gsub("\r", "", readChar(fn, file.info(fn)$size)))
})

context("test XML method templating")

test_that("basic XML creation works", {
  wd <- readRDS("data/test_webdata_prism_year.rds")
  wg <- readRDS("data/test_webgeom_WI.rds")
  wp <- readRDS("data/test_webprocess_knife_prod.rds")
  xml <- XML(wg, wd, wp)
  fn <-"data/test_XML_wg_xml.xml"
  expect_equal(xml, gsub("\r", "", readChar(fn, file.info(fn)$size)))
  sg <- simplegeom(c(-89,45))
  xml <- XML(sg, wd, wp)
  fn <-"data/test_XML_sg_xml.xml"
  expect_equal(nchar(xml), nchar(gsub("\r", "", readChar(fn, file.info(fn)$size))))
}) 

test_that("Execute XML creation with two points works", {
  wd <- readRDS("data/test_webdata_fabric.rds")
  wg <- readRDS("data/test_simplegeom_two_points.rds")
  wp <- readRDS("data/test_webprocess_knife.rds")
  xml <- XML(wg, wd, wp)
  fn <- "data/test_XML_two_points_xml.xml"
  expect_equal(nchar(xml), nchar(gsub("\r", "", readChar(fn, file.info(fn)$size))))
})

test_that("Execute XML works with no gmlids and multiple variables", {
  # This examples was grabbed from the custom dataset vignette.
  wd <- readRDS("data/test_XML_no_gmlid_wd.rds") 
  wg <- readRDS("data/test_XML_no_gmlid_wg.rds") 
  wp <- readRDS("data/test_webprocess_knife_prod.rds")
  xml <- XML(wg, wd, wp)
  fn <- "data/test_XML_no_gmlid_xml.xml"
  expect_equal(xml, gsub("\r", "", readChar(fn, file.info(fn)$size)))
})

test_that("you can set TAB delimited and get back the right XML", {
  wp <- readRDS("data/test_webprocess_knife_prod.rds")
  inputs(wp, "DELIMITER") <- "TAB"
  xml <- XML(stencil = readRDS("data/test_webgeom_WI.rds"),
             fabric = readRDS("data/test_webdata_prism_year.rds"), 
             knife = wp)
  expect_true(grepl('mimeType="text/tab-separated-values"', xml))
})

test_that("you can set output_type geotiff and get back the right XML", {
  wp <- readRDS("data/test_XML_wp_opendapsubset.rds")
  xml <- XML(stencil = readRDS("data/test_webgeom_WI.rds"),
             fabric = readRDS("data/test_webdata_prism_year.rds"), 
             knife = wp)
  expect_true(grepl('mimeType="application/zip"', xml))
})

test_that("execute XML for getgridtimerange works", {
  wd <- readRDS("data/test_webdata_fabric.rds")
  wp <- readRDS("data/test_webprocess_knife_prod.rds")
  xml <- geoknife:::make_listopendapgrids_execute_xml(wd, wp)
  
  fn <- "data/test_listopendapgrids.xml"
  expect_equal(xml, gsub("\r", "", readChar(fn, file.info(fn)$size)))
})

test_that("execute XML for getgridtimerange works", {
  wd <- readRDS("data/test_webdata_fabric.rds")
  wp <- readRDS("data/test_webprocess_knife_prod.rds")
  xml <- geoknife:::make_getgridtimerange_execute_xml(wd, wp)
  
  fn <- "data/test_getgridtimerange.xml"
  expect_equal(xml, gsub("\r", "", readChar(fn, file.info(fn)$size)))
})

pkg.env <- new.env()

pkg.env$urls <- list(geoserver_base = "https://labs.waterdata.usgs.gov/gdp_web/geoserver",
                     process_base = "https://labs.waterdata.usgs.gov/gdp-process-wps/WebProcessingService",
                     csw_url = "https://www.sciencebase.gov/catalog/item/62844f66d34e3bef0c9a48f9/csw",
                     draw_schema = "https://code.usgs.gov/wma/nhgf/geo-data-portal/geoknife/-/raw/v1.6.7/inst/draw.xsd")

pkg.env$gconfig <- list('wps.url'= pkg.env$urls$process_base,
                        'sleep.time' = 5, 
                        'wait' = FALSE,
                        'email' = as.character(NA),
                        'algorithm' = list('Area Grid Statistics (weighted)' = 
                                             "gov.usgs.cida.gdp.wps.algorithm.FeatureWeightedGridStatisticsAlgorithm"),
                        'verbose' = FALSE,
                        'retries' = 1,
                        'version' = '1.0.0',
                        'show.progress' = TRUE)

pkg.env$NAMESPACES <- c(wps = 'http://www.opengis.net/wps/1.0.0',
                        xsi = 'http://www.w3.org/2001/XMLSchema-instance',
                        xlink = 'http://www.w3.org/1999/xlink',
                        ogc = 'http://www.opengis.net/ogc',
                        ows = 'http://www.opengis.net/ows/1.1',
                        gml = 'http://www.opengis.net/gml',
                        wfs = 'http://www.opengis.net/wfs')

pkg.env$SCHEMA_LOCATIONS <- c(WPS_SCHEMA_LOCATION = 'http://schemas.opengis.net/wps/1.0.0/wpsExecute_request.xsd',
                              XSI_SCHEMA_LOCATION = 'http://www.opengis.net/wfs ../wfs/1.1.0/WFS.xsd',
                              GML_SCHEMA_LOCATION = 'http://schemas.opengis.net/gml/3.1.1/base/feature.xsd')

#' @importFrom utils lsf.str packageName
.onLoad <- function(libname, pkgname){
  setJobState()
  funs <- unclass(lsf.str(envir = asNamespace(packageName()), all = TRUE))
  pkg.env$private.funs <- funs[substr(funs,1,1) == '.']
  rm(funs)
}

library(methods)

#' configure geoknife settings
#' 
#' access and set defaults for geoknife configuration
#' 
#' @param \dots values for gconfig
#' @param no.readonly currently not implemented for \code{TRUE}
#' @return Borrowed text and functionality from \code{\link[graphics]{par}}. 
#' When parameters are set, their previous values are returned in an invisible named list. 
#' Such a list can be passed as an argument to par to restore the parameter values. Use gconfig(no.readonly = TRUE) 
#' for the full list of parameters that can be restored. When just one parameter is queried, the value of that 
#' parameter is returned as (atomic) vector. When two or more parameters are queried, their values are returned 
#' in a list, with the list names giving the parameters. Note the inconsistency: setting one parameter returns a list, 
#' but querying one parameter returns a vector.
#' @export
#' @examples 
#' gconfig # all config
#' gconfig('wait')
#' gconfig('sleep.time' = 10)
#' gconfig('sleep.time' = 8, wait=TRUE)
#' gconfig('progress' = FALSE)
gconfig <- function(..., no.readonly = FALSE){
  
  .gconfig.readonly <- c('version') 
  args <- list(...)
  if (length(names(args) %in% .gconfig.readonly) > 0 && any(names(args) %in% .gconfig.readonly)){
    stop('read only argument(s) ',
         paste(names(args)[names(args) %in% .gconfig.readonly], collapse = ', '), 
         " can't be set", call. = FALSE)
  }
  single <- FALSE
  
  if (length(args) == 0) {
    if (no.readonly) 
      return(pkg.env$gconfig[-match(.gconfig.readonly,names(pkg.env$gconfig))])
    else
      return(pkg.env$gconfig)
  } else {
    if (all(unlist(lapply(args, is.character)))) 
      args <- as.list(unlist(args))
    if (length(args) == 1) {
      if (is.list(args[[1L]]) | is.null(args[[1L]])) 
        args <- args[[1L]]
      else if (is.null(names(args))) 
        single <- TRUE
    }
  }
  
  if (single) 
    value <- pkg.env$gconfig[args[[1L]]][[1L]]
  if (!is.null(names(args))){
    pkg.env$gconfig[c(names(args))] <- args
    invisible(pkg.env$gconfig[c(names(args))])
  }
  else value
  
}

context('test modifying webprocess object')

test_that("webprocess object is modified correctly", {
  testthat::skip("no public qa")
  testthat::skip_on_cran()
  wp <- readRDS("data/test_webprocess_knife.rds")
  # test setting url also changes util
  url(wp) <- 'https://cida-test.er.usgs.gov/gdp/process/WebProcessingService'
  expect_equal(slot(wp, 'UTILITY_URL'), "https://cida-test.er.usgs.gov/gdp/utility/WebProcessingService")
  url(wp) <- 'https://labs.waterdata.usgs.gov/gdp-process-wps/WebProcessingService'
  expect_equal(url(wp), url(wp <- webprocess(url = 'https://labs.waterdata.usgs.gov/gdp-process-wps/WebProcessingService')))

})

context('test get and set webprocess object')
test_that("webprocess object get and set", {
  testthat::skip_on_cran()
  wp <- readRDS("data/test_webprocess_knife.rds")
  expect_is(url(wp),'character')
  expect_is(version(wp), 'character')
  expect_is(slot(wp, "processInputs"), 'list')
  
  
})

context('test pass through of webprocess')

context('test pass through of webprocess inputs')
test_that('test pass through of webprocess inputs', {
  testthat::skip_on_cran()
  wp = webprocess(algorithm = list('OPeNDAP Subset'="gov.usgs.cida.gdp.wps.algorithm.FeatureCoverageOPeNDAPIntersectionAlgorithm"), REQUIRE_FULL_COVERAGE = 'false')
  wp = initialize(wp)
  expect_equal(inputs(wp,'REQUIRE_FULL_COVERAGE')[[1]], 'false')
  wp = initialize(wp, OUTPUT_TYPE='geotiff', wait=TRUE)
  expect_equal(inputs(wp,'OUTPUT_TYPE')[[1]], 'geotiff')
  expect_true(wp@wait)
})

context("valid wps url")

test_that("error is thrown for non-WPS", {
  expect_warning(webprocess(url='http://www.google.com'))
})

context("can't set read only process inputs")

test_that("error is thrown read-only set on initialize", {
  skip_on_cran()
  expect_null(webprocess(TIME_START='1990-01-01T00:00:000Z'))
})

test_that("error is thrown read-only set on initialize w/ multiple vars", {
  skip_on_cran()
  expect_null(webprocess(TIME_START='1990-01-01T00:00:000Z', wait=TRUE))
})

test_that("error is thrown on job start for read only vars", {
  skip_on_cran()
  expect_null(job <- geoknife(stencil = c(-89,42), fabric = 'prism', TIME_START='1990-01-01T00:00:000Z', wait=TRUE))
  expect_null(job <- geoknife(stencil = c(-89,42), fabric = 'prism', TIME_START='1990-01-01T00:00:000Z'))
})

context("create webprocess from geojob")
# gconfig(wps.url = "https://cida-test.er.usgs.gov/gdp/process/WebProcessingService")
test_that("given a geojob, we can create a webprocess", {
  testthat::skip_on_cran()
  xml <- system.file("extdata/state_webgeom_post.xml", 
                               package = "geoknife")
  geojob <- geojob(xml=xml)
  webprocess <- webprocess(geojob)
  expect_equal(algorithm(webprocess), list("Area Grid Statistics (weighted)"="gov.usgs.cida.gdp.wps.algorithm.FeatureWeightedGridStatisticsAlgorithm"))
  expect_equal(version(webprocess), "1.0.0")
  # expect_equal(url(webprocess), "https://cida-test.er.usgs.gov/gdp/process/WebProcessingService")
  expect_equal(length(inputs(webprocess)), 11)
  expect_equal(inputs(webprocess)$`DATASET_ID`, "ppt")
})

# Run this script in the testthat directory to refresh all the rds files loaded by tests.
# Try to use RDS files when static objects can be used to keep chattyness of tests down.
test_that("test data can be created", {
  testthat::skip_on_cran()
  library(geoknife)
  
  if(!"geoknife/tests/testthat" == substr(getwd(), nchar(getwd())-22, nchar(getwd()))) {
    warning("this script assumes it is in the testthat directory of the geoknife package!!!")
  }
  # gconfig(wps.url = "https://cida-test.er.usgs.gov/gdp/process/WebProcessingService")
  fabric <- webdata('prism')
  times(fabric)[2] <- "1895-01-01"
  saveRDS(fabric, "data/test_webdata_fabric.rds")
  wp <- webprocess()
  saveRDS(wp, "data/test_webprocess_knife.rds")
  
  default.sleep <- geoknife:::gconfig('sleep.time')
  saveRDS(webprocess(sleep.time = default.sleep+5), "data/test_webprocess_sleep-plus-five.rds")
  saveRDS(query(wp, 'algorithms'), "data/test_webprocess_algorithms.rds")
  
  saveRDS(webprocess(DELIMITER = 'TAB'), "data/test_webprocess_tab.rds")
  
  gconfig('wps.url'="https://labs.waterdata.usgs.gov/gdp-process-wps/WebProcessingService")
  wp <- webprocess()
  saveRDS(wp, "data/test_webprocess_knife_prod.rds")
  saveRDS(query(wp, 'algorithms'), "data/test_webprocess_algorithms_prod.rds")
  
  saveRDS(webgeom('HUC8::09020306'), "data/test_webgeom_huc08.rds")
  saveRDS(webgeom('state::Wisconsin'), "data/test_webgeom_WI.rds")
  saveRDS(simplegeom(data.frame(point1 = c(-48.6, 45.2), point2=c(-88.6, 45.2))),
          "data/test_simplegeom_two_points.rds")
  
  saveRDS(webdata('prism',times = as.POSIXct(c('2001-01-01','2002-02-05'))),
          "data/test_webdata_prism_year.rds")
  
  # from custom data source vignette
  wg <- webgeom(url="https://www.sciencebase.gov/catalogMaps/mapping/ows/54296bf0e4b0ad29004c2fbb")
  geom(wg) <- "sb:Yahara_River_HRUs_alb_eq"
  attribute(wg) <- "GRIDCODE"
  
  wd <- webdata(url = 'https://cida.usgs.gov/thredds/dodsC/prism_v2', 
                variables = c('tmx', 'tmn', 'ppt'),
                times = as.POSIXct(c('2000-01-01', '2010-01-01')))
  
  saveRDS(wg, "data/test_XML_no_gmlid_wg.rds")
  saveRDS(wd, "data/test_XML_no_gmlid_wd.rds")
  
  wp <- webprocess(algorithm = list('OPeNDAP Subset'="gov.usgs.cida.gdp.wps.algorithm.FeatureCoverageOPeNDAPIntersectionAlgorithm"))
  inputs(wp, "OUTPUT_TYPE") <- "geotiff"
  saveRDS(wp, "data/test_XML_wp_opendapsubset.rds")
  
  webdata <- query("webdata")
  saveRDS(webdata, "data/test_query_webdata.rds")
  expect_gt(length(list.files('data')), 1)
})

context("Test sleep params")
test_that("Test sleep params", {
  testthat::skip_on_cran()
  default.sleep <- geoknife:::gconfig('sleep.time')
  wd <- readRDS("data/test_webprocess_knife.rds")
  expect_equal(wd@sleep.time, default.sleep)
  wd <- readRDS("data/test_webprocess_sleep-plus-five.rds")
  expect_false(wd@sleep.time == default.sleep)
})

test_that("Test set sleep global and param", {
  testthat::skip_on_cran()
  default.sleep <- geoknife:::gconfig('sleep.time')
  geoknife:::gconfig('sleep.time'=default.sleep+5)
  wd <- webprocess() # tests on init.
  expect_equal(wd@sleep.time, default.sleep+5)
  wd <- webprocess(sleep.time = default.sleep)
  expect_equal(wd@sleep.time, default.sleep)
})

context("gconfig")


test_that("can get read.only variables", {
  # expect_equal(gconfig("wps.url"), "https://cida-test.er.usgs.gov/gdp/process/WebProcessingService")
  expect_equal(gconfig(no.readonly = FALSE), gconfig())
  expect_false(length(gconfig(no.readonly = TRUE)) == length(gconfig()))
})

test_that("can't set read.only variables", {
  expect_error(gconfig('version'='2.0.0'))
  expect_error(gconfig('version'='2.0.0', 'wait'=TRUE))
})

test_that("can set !read.only variables", {
  expect_false(gconfig('wait'))
  gconfig('wait'=TRUE)
  expect_true(gconfig('wait'))
  gconfig('wait'=FALSE)
  expect_false(gconfig('wait'))
})

test_that("can set !read.only variables on webprocess()", {
  testthat::skip_on_cran()
  gconfig('email'='none@gmail.com')
  wp <<-webprocess()
  expect_equal(wp@email, 'none@gmail.com')
  expect_is(webprocess(), "webprocess")
  expect_is(wp@processInputs, "list")
})

library(geoknife)

fabric <- webdata(url = 'https://cida.usgs.gov/thredds/dodsC/prism')
fabric
query(fabric, 'variables')
variables(fabric) <- 'ppt'

query(fabric, 'times')
times(fabric) <- as.POSIXct(c("1985-01-01","1992-01-01"))

# use ALL variables
variables(fabric) <- query(fabric, 'variables')

stencil <- simplegeom(data.frame('point1'=c(-89, 46), 'point2'=c(-78.6, 42.2)))

knife = webprocess(algorithm = list('OPeNDAP Subset'="gov.usgs.cida.gdp.wps.algorithm.FeatureCoverageOPeNDAPIntersectionAlgorithm"))

job <- geoknife(stencil,fabric, knife, wait = TRUE, OUTPUT_TYPE="netcdf")
file <- download(job, destination = '../prism_data.nc')

knife = webprocess(algorithm = list('OPeNDAP Subset'="gov.usgs.cida.gdp.wps.algorithm.FeatureCoverageOPeNDAPIntersectionAlgorithm"))
job <- geoknife(stencil,fabric, knife, wait = TRUE, OUTPUT_TYPE="geotiff")
file <- download(job, destination = '../prism_data.zip')

#'@details bufferPoint is a function that takes a longitude and latitude pair and creates
#' a buffered ring (i.e., a feature with non-zero area) centered.
#'
#'@param point A vector of longitude and latitude values
#'@return A linear ring (with closure) as a numeric vector 
#'
#'@keywords methods internal
#'@description Buffer ring creation from point
#'@title Create linear ring from point
#'@author Jordan S. Read
#'@seealso \linkS4class{simplegeom}
#'@examples linearRing = bufferPoint(c(-111.48, 36.95))
#'@export
bufferPoint	<-	function(point){
	offset	<-	0.0001
	
  if (length(point) != 2){
    stop('only a single pair point is currently supported. This function is not yet vectorized.')
  }
  
	if (length(point) %% 2 != 0){
		stop('point must be latitude and longitude pairs')
	}
	
	tp.lat	<-	point[2]+offset
	md.lat	<-	point[2]
	bt.lat	<-	point[2]-offset
	rt.lon	<-	point[1]+offset
	md.lon	<-	point[1]
	lf.lon	<-	point[1]-offset
	LinearRing	<-	c(lf.lon,md.lat, md.lon,tp.lat, rt.lon,md.lat, md.lon,bt.lat, lf.lon,md.lat)
	return(LinearRing)
	
}

#' @title set job state at package level for outgoing requests
#' @description this function keeps the package from rifling off multiple requests 
#' while another is still pending. Package variable \code{jobState} is set with 
#' direct calls to this private function, or as part of any \code{status} type 
#' method for geojob
#' @keywords internal
#' @param state the state (as a character) to set \code{jobState} to. 
#' @return invisible return of \code{jobState} package variable
setJobState <- function(state = 'none'){
  if (!state %in% c('none',"ProcessStarted",'Process successful',"ProcessFailed",'unknown')){
    state = "ProcessFailed"
  } 
  pkg.env$jobState <- state
  
  invisible(pkg.env$jobState)
}

#' @title get job state 
#' @description convenience function for retrieving package-level \code{jobState}
#' @keywords internal
#' @return \code{jobState} package variable
getJobState <- function(){
  pkg.env$jobState
}

#' can start a new job?
#' 
#' checks package job state and returns a boolean for whether a new job can be started
#' 
#' @return TRUE or FALSE
#' @keywords internal
#' 
canStart <- function(){
  state <- getJobState()

  if (state %in% c('none',"ProcessFailed",'Process successful','unknown')){
    return(TRUE)
  } else {  
    return(FALSE)
  }
    
}

context("Test setting of geoknife algorithms and process inputs")


test_that("webprocess can set algorithms", {
  testthat::skip_on_cran()
  wp <- readRDS("data/test_webprocess_knife.rds")
  algs <- readRDS("data/test_webprocess_algorithms.rds")
  expect_error(algorithm(wp)<-'bad.char')
  expect_error(algorithm(wp)<-NULL)
  expect_error(suppressWarnings(algorithm(wp)<-list('junk'='will break process')))
  
  algorithm(wp) <- algs[1]
  # test that it properly sets
  expect_equal(algorithm(wp), algs[1])
  
})

context("Test setting of webgeom simple sets")
test_that("webgeom can set states", {
  testthat::skip_on_cran()
  states <- c("Colorado","Oregon","Wisconsin")
  wg <- webgeom(paste0('state::',paste(states,collapse = ',')))
  expect_equal(length(values(wg)), length(states))
})

context("geoknife sets stencil correctly")
test_that("geoknife sets stencil correctly", {
  testthat::skip_on_cran()
  job <- geoknife('HUC8::09020306', 'prism')
  expect_is(job, 'geojob')
  cancel(job)
  job <- geoknife(data.frame('point1'=c(-89, 46), 'point2'=c(-88.6, 45.2)), 'prism')
  expect_is(job, 'geojob')
  cancel(job)
})

library(sp)
Sr1 <- Polygon(cbind(c(-89.0001,-89,-88.9999,-89,-89.0001),c(46,46.0001,46,45.9999,46)))
Sr2 <- Polygon(cbind(c(-88.6,-88.5999,-88.5999,-88.6,-88.6),c(45.2,45.2,45.1999,45.1999,45.2)))
Srs1 <- Polygons(list(Sr1), "s1")
Srs2 <- Polygons(list(Sr2), "s2")
test_that("geoknife converts SpatialPolygons to simplegeoms correctly", {
  
  SP <- SpatialPolygons(list(Srs1,Srs2), proj4string = CRS("+proj=longlat +datum=WGS84"))
  suppressWarnings(expect_is(simplegeom(SP), 'simplegeom'))
  expect_error(simplegeom(SpatialPolygons(list(Srs1,Srs2))))
})

test_that("data.frame includes names in simplegeom", {
  df <- structure(list(mn_washington = c(-93.4785963708254, 45.0159250122303), 
                      mn_hennepin = c(-92.889497952532, 45.0392357530942)), 
                 class = "data.frame", row.names = c("X", "Y"))
  sg <- simplegeom(df)
  
  expect_equal(names(sg@sp@polygons), names(df))
  
  testthat::skip_on_cran()
  job <- geoknife(sg, 'prism', wait = TRUE)
  
  data_out <- result(job)
  
  expect_equal(names(data_out), 
              c("DateTime", "mn_hennepin", "mn_washington", "variable", "statistic"))
})

context("geoknife w/ knife modified in line")
test_that("geoknife sets knife correctly", {
  testthat::skip_on_cran()
  job <- geoknife('HUC8::09020306', 'prism', wait=TRUE)
  expect_true(geoknife:::canStart())
  cancel(job)
})

context("setting webgeom values")
test_that("NULL results in error", {
  testthat::skip_on_cran()
  wg_c <- webgeom(geom = 'derivative:US_Counties', attribute = 'COUNTY')
  expect_silent(values(wg_c) <- "Belmont County")
  # expect_error(values(wg_c) <- "foo") 
})

test_that("we can set attributes on a webgeom", {
  testthat::skip_on_cran()
  stencil <- webgeom()
  geom(stencil) <- "sample:CONUS_states"
  attribute(stencil) <- "STATE"
  expect_equal(stencil@attribute, "STATE")
  stencil_attribute <- attribute(stencil)
  expect_equal(stencil_attribute, "STATE")
})

context("basics of geoknife processing job are as expected")

test_that("algorithm version works", {
  testthat::skip_on_cran()
  fabric <- webdata('prism')
  times(fabric)[2] <- as.POSIXct('1895-01-01', tz = "UTC")
  job <- geoknife(stencil = c(-89,42), fabric = fabric)
  expect_equal(job@algorithm.version, "1.0.0")
  cancel(job)
})

test_that("version method works", {
  testthat::skip_on_cran()
  stencil <- webgeom()
  version(stencil) <- "2.0.0"
  expect_equal(version(stencil), "2.0.0")
})

context("Test wait until finished")

default.sleep <- geoknife:::gconfig('sleep.time')
geoknife:::gconfig(sleep.time=0.1)

test_that("creating simple job", {
  testthat::skip_on_cran()
  stencil <- readRDS("data/test_webgeom_WI.rds")
  fabric <- readRDS("data/test_webdata_fabric.rds")
  geoknife:::setJobState('none')
  geoknife(stencil, fabric, wait = TRUE)
  
  expect_equal(geoknife:::getJobState(), "Process successful")
  expect_true(geoknife:::canStart())
  geoknife(stencil, fabric, wait = FALSE)
  expect_false(geoknife:::getJobState() == "Process successful")
  cancel()
})

context("Test re-enter wait loop")
test_that("creation of webprocess object", {
  testthat::skip_on_cran()
  fabric <- webdata('prism',times <- c('1895-01-01T00:00:00Z', '1895-01-01T00:00:00Z')) # should take longer than a re-check
  cancel()
  job <- geoknife(stencil = c(-89,42), fabric, wait=FALSE)
  expect_equal(2+2, 4)
  expect_true(running(job))
  m <- capture_messages(wait(job, show.progress = TRUE))
  expect_false(running(job))
  
  expect_equal(m, "Process Accepted\n")

})

geoknife:::gconfig(sleep.time=default.sleep)

context("Test set job state")


test_that("creating simple job", {
  cancel()
  testthat::skip_on_cran()
  stencil <- webgeom('state::Wisconsin')
  fabric <- webdata('prism')
  expect_equal(geoknife:::getJobState(), 'none')
})

test_that("can start first job",{
  testthat::skip_on_cran()
  stencil <- webgeom('state::Wisconsin')
  fabric <- webdata('prism')
  job <- geoknife(stencil, fabric)
  expect_true(geoknife:::getJobState() %in% c("ProcessStarted","Process successful"))
  
})

test_that("fail for second job",{
  testthat::skip_on_cran()
  stencil <- webgeom('state::Wisconsin')
  fabric <- webdata('prism')
  geoknife:::setJobState("ProcessStarted")
  expect_error(geoknife(stencil, fabric)) #because is running.
  cancel()
  expect_is(geoknife(stencil, fabric),'geojob') #expect no error
  
})

context("test failing request")




test_that("java stack failure", {
  testthat::skip_on_cran()
  cancel()
  stencil <- webgeom('state::Wisconsin')
  fabric <- webdata('prism', variables = 'wrong')
  job <- geoknife(stencil, fabric, wait = TRUE)
  expect_equal(geoknife:::getJobState(), "ProcessFailed")
})

context("testing required field as NA in webdata")


test_that("required field as NA in webdata", {
  testthat::skip_on_cran()
  cancel()
  stencil <- webgeom('state::Wisconsin')
  fabric <- webdata('prism', variables = 'wrong')
  variables(fabric) <- as.character(NA)
  expect_error(geoknife(stencil, fabric))
})

#' the attribute of an webgeom object
#'
#' get or set the attribute of a webgeom object. 
#'
#'@param .Object a \linkS4class{webgeom} object
#'@param value a attribute
#'@rdname attribute
#'@aliases
#'attribute
#'attribute<-
#'@export
setGeneric(name="attribute<-",def=function(.Object, value){standardGeneric("attribute<-")})

#'@aliases attribute
#'@rdname attribute
#'@export
setGeneric(name="attribute",def=function(.Object){standardGeneric("attribute")})


#'@aliases attribute
#'@rdname attribute
setMethod(f = "attribute<-",signature(.Object = "webgeom"), definition = function(.Object, value){
  .Object <- initialize(.Object, attribute = value)
  return(.Object)})

#'@aliases attribute
#'@rdname attribute
setMethod(f = "attribute",signature(.Object = "webgeom"), 
          definition = function(.Object){
            return(.Object@attribute)
            })

#' parse timeseries file into R environment
#'
#' a function for loading data into R from a file (or URL) from a completed processing request
#'
#' @param file a \linkS4class{geojob} timeseries processing result file location
#' (See \code{\link{download}}).
#' @param delim the file delimiter
#' @param with.units boolean for including a units column in returned data.frame (default = \code{FALSE})
#' @return a data.frame of timeseries values.
#' @keywords methods
#' @author Luke A. Winslow, Jordan S. Read
#' @export
#' @seealso \code{\link{check}}, \code{\link{download}}, \code{\link{parseCategorical}}
#' @importFrom utils read.table
#' @examples
#' local_file <- system.file('extdata','tsv_linear_ring.tsv', package = 'geoknife')
#' output <- parseTimeseries(local_file, delim = '\t')
parseTimeseries <- function(file, delim, with.units = FALSE){
  
  config = parseTimeseriesConfig(file, delim)
  
  if(!is.na(config[['features']][1]) && config[['features']][1]=="") {
    config[['features']]<-config[['features']][-1]
  }
  
  dataOut <- data.frame(
    row.names = c('TIMESTEP',config[['features']], 'variable', 'statistic'))
  
  for (blk in 1:length(config[['vars']])){
    blockData <- read.table(file, sep = delim, 
                  header = TRUE, 
                  nrows = config[['nrows']][blk], 
                  skip = config[['skip']][blk], 
                  as.is=TRUE, check.names = FALSE, stringsAsFactors = FALSE)
    #parse the date into POSIXct format
    blockData$TIMESTEP = as.POSIXct(blockData$TIMESTEP, "%Y-%m-%dT%H:%M:%S", tz="UTC")
    if(any(grepl("threshold",names(blockData)))){
      replace.name <- names(blockData)[grepl("threshold",names(blockData))]
      startCol<-3
    } else if (any(grepl("time",names(blockData)))){
      replace.name <- names(blockData)[grepl("time",names(blockData))]
      startCol<-3
    } else {
      startCol<-2
    }
    statNames <- unique(names(blockData)[startCol:ncol(blockData)])
    for (st in 1:length(statNames)){
      # select data columns based on stat code
      statI <- which(names(blockData) == statNames[st])
      statData <- blockData[, c(1,statI)]
      
      tryCatch({
        names(statData)[-1] <- config[['features']]
      }, warning = function(w) {
        stop('Delimiter parse fail.')
      }, error = function(e) {
        stop('Delimiter parse fail.')
        }
      )
      
      #remove units from stats names
      statSplit = strsplit(x = statNames[st], split = '[()]')[[1]]
      cleanStat <- statSplit[1]
      units <- statSplit[2]
      
      statData = cbind(statData, data.frame(
        'variable' = rep(as.character(config[['vars']][blk]), length.out = nrow(statData)),
        'statistic' = rep(cleanStat, length.out = nrow(statData)), stringsAsFactors = FALSE)
      )
      if (startCol==3) {
      	names(blockData)[2] <- replace.name
        statData=cbind(statData,blockData[2])
      }
      if (with.units){
        statData = cbind(statData, data.frame('units'=rep(units, length.out = nrow(statData)), stringsAsFactors = FALSE))
      }
      tryCatch({
        dataOut <- rbind(dataOut, statData)
      }, warning = function(w) {
        stop(paste('Variable',as.character(config[['vars']][blk]),'had a problem being added to the data frame.'))
      }, error = function(e) {
        stop(paste('Variable',as.character(config[['vars']][blk]),'had a problem being added to the data frame.'))
        }
      )
    }
  }

  names(dataOut)[1] = 'DateTime'

  return(dataOut)
}

parseTimeseriesConfig = function(file, delim){
    featureLine = 2 # Line containing unique IDs of features (stencil) that were processed
    skipHead = 1 # Number of lines to skip past the variable marker header?
    varMarker = '# ' # Symbol that denotes a variable identifier and a new block of output.
    c <- file(file,"r") 
    fileLines <- readLines(c) # This concerns me!!!
    close(c)
    nRead <- length(fileLines)
    blockStart <- grep(varMarker, fileLines) # Lines containing variable IDs.
    skips = blockStart+skipHead 
    blockEnd = c(blockStart[-1] - 1, nRead) # End of blocks
    nrows = blockEnd - skips - 1 # Number of ros per block.
    features = unique(strsplit(fileLines[featureLine], split = delim)[[1]][-1]) # Parsing out feature identifiers
    vars = sub(varMarker,"",fileLines[blockStart]) # Getting the variable names from the block starts.
    vars = gsub(delim,'',vars)
    config = list(vars = vars, features = features, skip = skips, nrows = nrows) # Return all the good stuff!
  return(config)
}
parseChunk = function(lines, delim, use_cols){
  # won't know var name, will return d.f
  
  df <- data.frame()
  return(df)
}

context("Test output file parsing")



test_that("timeseries parser works on multi feature, single variable", {
  local_file <- system.file('extdata','tsv_multi_feature.tsv', package = 'geoknife')
  output <- parseTimeseries(local_file, delim = '\t', with.units = T)
  expect_is(output, "data.frame")
  expect_true('units' %in% names(output))
  output <- parseTimeseries(local_file, delim = '\t', with.units = F)
  expect_false('units' %in% names(output))
})

test_that("timeseries parser works on linear ring, single variable", {
  local_file <- system.file('extdata','tsv_linear_ring.tsv', package = 'geoknife')
  output <- parseTimeseries(local_file, delim = '\t')
  expect_is(output, "data.frame")
})

test_that("timeseries parser works on linear ring, comma delimited", {
  local_file <- system.file('extdata','csv_linear_ring.csv', package = 'geoknife')
  output <- parseTimeseries(local_file, delim = ',')
  expect_is(output, "data.frame")
  expect_error(parseTimeseries(local_file, delim = '\t'))
})

test_that("timeseries parser works on complex output tsv", {
  local_file <- system.file('extdata','tsv_multi_var_feature_stat.tsv', package = 'geoknife')
  output <- parseTimeseries(local_file, delim = '\t')
  expect_is(output, "data.frame")
  expect_error(parseTimeseries(local_file, delim = ','))
  expect_equal(output$Alabama[output$variable == 'Prcp' & output$statistic == 'MEAN'][6], 25.76490800)
  expect_equal(output$Connecticut[output$variable == 'Prcp' & output$statistic == 'MEAN'][6], 12.5118475)
  expect_equal(output$Alabama[output$variable == 'Tmin' & output$statistic == 'MEAN'][1], 7.776923)
  expect_equal(output$Idaho[output$variable == 'Wind' & output$statistic == 'VARIANCE'][2], 1.8166552)
  expect_equal(output$DateTime[output$variable == 'Wind' & output$statistic == 'VARIANCE'][2], as.POSIXct('1950-01-02 00:00', tz = 'UTC'))
})

test_that("timeseries parser works on complex output csv", {
  local_file <- system.file('extdata','csv_multi_feature_stat.csv', package = 'geoknife')
  output <- parseTimeseries(local_file, delim = ',')
  expect_is(output, "data.frame")
  expect_error(parseTimeseries(local_file, delim = ' '))
})

test_that("timeseries parser works on multi var multi feature", {
  local_file <- system.file('extdata','tsv_multi_feature_var.tsv', package = 'geoknife')
  output <- parseTimeseries(local_file, delim = '\t')
  expect_is(output, "data.frame")
  expect_error(parseTimeseries(local_file, delim = ' '))
})

test_that("timeseries parser works on multi threshold output",{
  local_file <- system.file('extdata','csv_multi_threshold.csv', package = 'geoknife')
  output <- parseTimeseries(local_file, delim = ',')
  expect_is(output, "data.frame")
  expect_equivalent(names(output)[1],'DateTime')
  expect_equivalent(names(output)[length(output)],'threshold(C)')
  expect_equal(output[['threshold(C)']][1],32)
  expect_equivalent(output$variable[1],'MIROC-ESM-CHEM_rcp26_r1i1p1-longest_run_tmax_abv')
})

test_that("timeseries parser works on multi feature w/ second time dimension", {
  local_file <- system.file('extdata','csv_time_dimension_parse.csv', package = 'geoknife')
  output <- parseTimeseries(local_file, delim = ',')
  expect_is(output, "data.frame")
})

library(geoknife)

stencil <- webgeom('ecoregion::Colorado Plateaus,Driftless Area,Wyoming Basin')
stencil

#see what other ecoregions are available:
query(stencil, 'values')

fabric <- webdata(url = 'https://cida.usgs.gov/thredds/dodsC/iclus/hc') #, variables = 

#see what variables are available:
query(fabric, 'variables')
variables(fabric) <- c('housing_classes_iclus_a1_2010', 'housing_classes_iclus_a1_2100')

knife <- webprocess(algorithm = list('Categorical Coverage Fraction'="gov.usgs.cida.gdp.wps.algorithm.FeatureCategoricalGridCoverageAlgorithm"))
job <- geoknife(stencil, fabric, knife, email = 'your.email.here@gardenmail.com')

check(job)
# wait, or check your email inbox for the result when it has finished

## ----setup, include=FALSE---------------------------------
library(rmarkdown)
options(continue=" ")
options(width=60)
library(knitr)
library(geoknife)
knitr::opts_chunk$set(eval=FALSE)

## ---- warning=FALSE, message=FALSE------------------------
#  library(geoknife)

## ---- warning=FALSE, message=FALSE------------------------
#  knife <- webprocess(algorithm = list('OPeNDAP Subset' = "gov.usgs.cida.gdp.wps.algorithm.FeatureCoverageOPeNDAPIntersectionAlgorithm"))
#  
#  fabric <- webdata(url='https://cida.usgs.gov/thredds/dodsC/ssebopeta/monthly',
#                    variable="et", #Monthly evapotranspiration
#                    times=c('2014-07-15','2014-07-15'))
#  
#  stencil <- simplegeom(data.frame('point1' = c(-76,49), 'point2' = c(-93,40)))
#  job <- geoknife(stencil, fabric, knife, wait = TRUE, OUTPUT_TYPE = "geotiff")

## ---- warning=FALSE, message=FALSE------------------------
#  dest <- file.path(tempdir(), 'et_data.zip')
#  
#  file <- download(job, destination = dest, overwrite = TRUE)
#  
#  unzip(file, exdir=file.path(tempdir(),'et'))
#  
#  tiff.dir <- file.path(tempdir(),'et')

## ---- warning=FALSE, message=FALSE------------------------
#  library(rasterVis)
#  library(raster)
#  
#  et <- raster(file.path(tiff.dir , dir(tiff.dir)))
#  NAvalue(et) <- -1

## ---- warning=FALSE, message=FALSE------------------------
#  library(ggmap)
#  library(ggplot2)
#  
#  gplot(et, maxpixels = 5e5) +
#    geom_tile(aes(fill = value), alpha=1) +
#    scale_fill_gradientn("Actual ET (mm)", colours=rev(heat.colors(5))) +
#    coord_equal() +
#    theme_classic() +
#    theme(axis.line = element_blank(), axis.text.x = element_blank(), axis.text.y = element_blank(),
#          axis.ticks = element_blank(), axis.title.x = element_blank(), axis.title.y = element_blank()) +
#    scale_y_continuous(limits=c(et@extent@ymin, et@extent@ymax)) +
#    scale_x_continuous(limits=c(et@extent@xmin, et@extent@xmax))

#' the url of an object
#'
#' get or set the url of an object 
#' 
#' @param .Object a \linkS4class{webgeom}, \linkS4class{webdata}, 
#' @param \dots additional arguments that would be passed to the masked base::url function.  
#' These are only used when the .Object argument is character or missing
#' \linkS4class{geojob}, or \linkS4class{webprocess} object
#' @param value a url
#' @rdname url
#' @aliases
#' url
#' url<-
#' @export
setGeneric(name="url<-",def=function(.Object, value){standardGeneric("url<-")})

#' @aliases url
#' @rdname url
#' @export
setGeneric(name="url",def=function(.Object, ...){standardGeneric("url")})


#' @aliases url
#' @rdname url
setMethod(f = "url<-",signature(.Object = "ANY"), definition = function(.Object, value){
  if (length(value) != 1){
    stop('url must be a single character string')
  }
  .Object@url <- value
  return(.Object)})

# special method because other slots depend on value of \code{url} for webprocess object
#' @aliases url
#' @rdname url
setMethod(f = "url<-",signature(.Object = "webprocess"), definition = function(.Object, value){
  if (length(value) != 1){
    stop('url must be a single character string')
  }
  .Object <- new(Class = "webprocess", url = value)
  return(.Object)})

#'@aliases url
#'@rdname url
setMethod(f = "url",signature(.Object = "character"),
          definition = function(.Object, ...){
            return(base::url(.Object, ...))
          })

#'@aliases url
#'@rdname url
setMethod(f = "url",signature(.Object = "missing"),
          definition = function(.Object, ...){
            return(base::url(...))
          })

#'@aliases url
#'@rdname url
setMethod(f = "url",signature(.Object = "datagroup"),
          definition = function(.Object, ...){
            return(sapply(.Object@group, function(x) x$url))
          })

#'@aliases url
#'@rdname url
setMethod(f = "url",signature(.Object = "ANY"),
          definition = function(.Object, ...){
            return(.Object@url)
          })

library(geoknife)

fabric <- webdata('prism')
fabric

#see what times are avaiable:
query(fabric, 'times')

#set times to a different value:
times(fabric)[2] <- '1900-01-01' 

stencil <- webgeom('state::Oregon,Colorado,Connecticut')
stencil

#see what other states are available:
query(stencil, 'values')

job <- geoknife(stencil, fabric, wait = TRUE)

prism_data <- result(job)
plot(x = prism_data[,1], y = prism_data[['Oregon']], col = 'red', pch = 15, ylab = variables(fabric), xlab = '')
points(x = prism_data[,1], y = prism_data[['Colorado']], col = 'dodgerblue', pch = 4, lwd = 2)
points(x = prism_data[,1], y = prism_data[['Connecticut']], col = 'green', pch = 2, lwd = 2)

#' the times of an webdata object
#'
#' Functions to get or set the times of a \code{\link{webdata}} object
#' 
#' @param .Object a \code{\link{webdata}} object
#' @param value a POSIXct vector
#' @examples
#' wd <- webdata('prism')
#' times(wd) <- as.POSIXct(c("2012-11-04", "2012-11-12"))
#' times(wd)[1] <- as.POSIXct("2012-11-04")
#' times(wd)
#' @rdname times-webdata
#' @aliases 
#' times
#' times<-
#' @export
setGeneric(name="times",def=function(.Object){standardGeneric("times")})

#' @rdname times-webdata
#' @aliases times
#' @export
setGeneric(name="times<-",def=function(.Object, value){standardGeneric("times<-")})

#' @rdname times-webdata
#' @aliases times
setMethod(f = "times<-",signature(.Object = "webdata"),
          definition = function(.Object, value){
            if (length(value) != 2){
              stop('times input must be a POSIXct vector of length 2', call. = FALSE)
            }
            
            if (!any(is.na(value)) && value[1] > value[2]){
              stop('time start must precede time stop in "times" slot for webdata', call. = FALSE)
            }
            .Object@times <- geotime(value)
            return(.Object)
          })

geotime <- function(value){

  if (is.character(value)){
    geotime.character(value)
  } else if ("POSIXct" %in% class(value)){
    geotime.POSIXct(value)
  } else {
    warning('no applicable geotime method for ',class(value))
  }
  
}

geotime.POSIXct = function(value){
  
  tz = "UTC"
  
  # check for tz, honor if it exists
  if (is.null(attr(value,'tzone')) ||  attr(value,'tzone') == ''){
    as.POSIXct(format(value,usetz=F), tz=tz)
  } else {
    attr(value,'tzone') <- tz
    return(value)
  }
}

geotime.character = function(value){
  geotime.POSIXct(do.call(c, lapply(value,as.POSIXct)))
}

#' @rdname times-webdata
#' @aliases times
setMethod(f = "times",signature(.Object = "webdata"),
          definition = function(.Object){
            return(.Object@times)
          })

context("Test time settings for inputs")


test_that("check using a POSIX, and that the tz is honored and converted", {
  t <- geoknife:::geotime(as.POSIXct("2012-11-04",tz="America/Chicago"))
  expect_equal(attr(t, 'tzone'), "UTC")
  expect_is(t, 'POSIXct')
})

test_that("check using a POSIX w/o tz, it gets UTC", {
  t <- geoknife:::geotime(as.POSIXct("2012-11-04"))
  expect_equal(attr(t, 'tzone'), "UTC")
  expect_is(t, 'POSIXct')
})

test_that("fails when times is more than 2 elements", {
  testthat::skip_on_cran()
  wd <- webdata('prism')
  expect_error(times(wd) <- c("2012-11-04","2012-11-05","2012-11-06"))
})

test_that("warning with geotime class", {
  expect_warning(geoknife:::geotime(3))
})

test_that("fails when start later than stop", {
  testthat::skip_on_cran()
  wd <- webdata('prism')
  expect_error(times(wd) <- c("2012-11-04","2012-11-02"))
})

test_that("check using a string, it gets UTC", {
  t <- geoknife:::geotime("2012-11-04")
  expect_equal(attr(t, 'tzone'), "UTC")
  expect_is(t, 'POSIXct')
  
  expect_equal(t, geoknife:::geotime(as.POSIXct("2012-11-04")))
  
  
})

#' the geom of an object
#' 
#' The "feature" of a webgeom. This is the key mapping to the web resource 
#' that is used as the spatial feature of reference. Other details specified in 
#' \code{\link{attribute}} and \code{\link{values}}.
#' 
#' @param .Object a \linkS4class{webgeom} object
#' @param value a geom
#' @rdname geom
#' @seealso \code{\link{attribute}} and \code{\link{values}}
#' @aliases
#' geom
#' geom<-
#' @export
setGeneric(name="geom<-",def=function(.Object, value){standardGeneric("geom<-")})

#' @aliases geom
#' @rdname geom
#' @export
setGeneric(name="geom",def=function(.Object){standardGeneric("geom")})


#' @aliases geom
#' @rdname geom
setMethod(f = "geom<-",signature(.Object = "webgeom"), definition = function(.Object, value){
  .Object <- initialize(.Object, geom = value)
  return(.Object)})

#' @rdname geom
#' @aliases geom
setMethod(f = "geom",signature="webgeom",
          definition = function(.Object){
            return(.Object@geom)
          }
)

#'@name defaultProcessInputs
#'@title Default Process Inputs
#'@param algorithm the WPS algorithm to get process inputs for
#'@param wps_url the service base URL for the WPS
#'@param wps_version the service version to use
#'@return list of default, optional, and required process inputs for use in the webprocess object.
#'@description parses DescribeProcess request
defaultProcessInputs <- function(algorithm, wps_url, wps_version){
  getCaps <- gGET(wps_url, query = list(
    'service' = 'WPS', 'version' = wps_version,'request' = 'DescribeProcess', 'identifier'=algorithm))

  
  doc = tryCatch({
    gcontent(getCaps)
  }, error = function(e) {
    warning(paste0(wps_url, ' does not seem to be a valid Web Processing Service url.'), 
            call. = FALSE)
    return(NULL)
  })

  checkException(doc)
  
  # -- get optional arguments --
  optionNd <- xml2::xml_find_all(doc,'//DataInputs/Input[@minOccurs=0]/ows:Identifier')
  optionLs <- vector("list",length(optionNd))
  optionLs[] <- NA # "NA" is the equivalent of "optional" as an input
  names(optionLs) <- xml2::xml_text(optionNd)
  
  # -- get required arguments -- (minOccurs > 0 means required)
  requirNd <- xml2::xml_find_all(doc,'//DataInputs/Input[@minOccurs>0]/ows:Identifier')
  requirLs <- vector("list",length(requirNd)) 
  names(requirLs) <- xml2::xml_text(requirNd)
  
  # -- get and set default values --
  defaultTag <- '//DataInputs/Input/LiteralData/DefaultValue'
  defaultNd <- xml2::xml_find_all(doc,paste0(defaultTag, '/parent::node()[1]/DefaultValue'))
  defaultLs <- vector("list",length(xml2::xml_text(defaultNd)))
  defaultLs[] <- xml2::xml_text(defaultNd)
  names(defaultLs) <- xml2::xml_text(xml2::xml_find_all(doc,
                                                        paste0(defaultTag, 
                                  '/parent::node()[1]/preceding-sibling::node()[3]'))) 
  
  
  # -- get and set allowed values -- ?? why isn't this set up like defaults??
  allowNd    <- xml2::xml_find_all(doc,
   '//DataInputs/Input/LiteralData//parent::node()/ows:AllowedValues/ows:Value[1]')
  allowLs <- vector("list",length(xml2::xml_text(allowNd)))
  allowLs[] <- xml2::xml_text(allowNd)
  names(allowLs) <- xml2::xml_text(
    xml2::xml_find_all(doc,
    '//DataInputs/Input/LiteralData/ows:AllowedValues/
    parent::node()[1]/preceding-sibling::node()[3]'))
  
  # add fields for optionLs and requirLs
  processInputs <- append(optionLs,requirLs)
  processInputs[names(defaultLs)] <- defaultLs
  
  # remove Feature, as it is handled elsewhere
  processInputs$FEATURE_COLLECTION <- NULL 
  return(processInputs)
}

checkException <- function(doc){
  exceptionTag <- '//ows:Exception/ows:ExceptionText'
  if(length(xml2::xml_find_all(doc, exceptionTag))>0){
    stop(xml2::xml_text(xml2::xml_find_all(doc, exceptionTag)[[1]]))
  }
}

#' geoknife 
#' 
#' Creates the processing job and allows specifying the processing details. 
#' 
#'@param stencil a \code{\link{webgeom}}, \code{\link{simplegeom}}, or any type 
#'that can be coerced into \code{\link{simplegeom}}.
#'@param fabric a dataset. A \code{\link{webdata}} or any type that 
#'can be coerced into \code{\link{webdata}}
#'@param knife (optional) a \code{\link{webprocess}} object
#'@param show.progress logical (optional) display progress bar?
#'@param ... additional arguments passed to \code{new} \code{\link{webprocess}}. 
#'Can also be used to modify the \code{knife} argument, if it is supplied.
#'@return and object of class \linkS4class{geojob}
#'@rdname geoknife-methods
#'@details
#'The \code{stencil} argument is akin to cookie cutter(s), which specify how the dataset is 
#'to be sub-sampled spatially. Supported types are all geometric in nature, be they collections 
#'of points or polygons. Because geoprocessing operations require a non-zero area for \code{stencil}, 
#'if points are used (i.e., the different point collections that can be used in \code{\link{simplegeom}}), 
#'there is a negligible automatic point buffer applied to each point to result in a non-zero area. 
#'
#'Naming of the components of the \code{stencil} will impact the formatting of the result returned by 
#'the geoknife processing job (the \code{\link{geojob}})
#'
#'geoknife will check the class of the stencil argument, and if stencil's class is not
#'\code{\link{webgeom}}, it will attempt to coerce the object into a \code{\link{simplegeom}}. 
#'If no coercion method exists, geoknife will fail. 
#'
#'The \code{fabric} argument is akin to the dough or fabric that will be subset with the \code{stencil} 
#'argument. At present, this is a web-available gridded dataset that meets a variety of formatting restrictions. 
#'Several quick start methods for creating a \code{\link{webdata}} object (only \code{\link{webdata}} or 
#'an type that can be coerced into \code{\link{webdata}} are valid arguments for \code{fabric}).
#'
#'Making concurrent requests to the Geo Data Portal will NOT result in faster overall execution times. 
#'The data backing the system is on high performance storage, but that storage is not meant to support 
#'parallelized random access and can be significantly slower under these conditions.
#'@docType methods
#'@aliases
#'geoknife
#'@examples
#'\dontrun{
#'job <- geoknife(stencil = c(-89,42), fabric = 'prism')
#'check(job)
#'
#'#-- set up geoknife to email user when the process is complete
#'
#' job <- geoknife(webgeom("state::Wisconsin"), fabric = 'prism', email = 'fake.email@@gmail.com')
#' 
#'}
#'@export
geoknife <- function(stencil, fabric, knife = webprocess(...), show.progress = TRUE, ...){
  
  if(is.null(knife)) {
    return(NULL)
  }
  
  knife <- as(knife, Class = "webprocess")
  if (!missing(...)){
    # if ... are specified, pass in additional args through ... to modify. 
    knife <- initialize(knife, ...)
  }
  
  if (!is(stencil, "webgeom")){
    stencil <- tryCatch({
      as(stencil, Class = "simplegeom")
    }, error = function(err) {
      wg <- as(stencil, Class = "webgeom")
      return(wg)
    })
  }
  
  fabric <- as(fabric, Class = "webdata")
  geojob <- geojob()
  xml(geojob) <- XML(stencil, fabric, knife)
  url(geojob) <- url(knife)
  geojob@algorithm.version <- algorithmVersion(knife)
  geojob <- start(geojob)
  if (!is.na(knife@email)) {
    email(geojob, knife)
  }
  
  if (knife@wait){
    wait(geojob, sleep.time = knife@sleep.time, show.progress = show.progress)
  }
  
  return(geojob)
}

#'@importFrom httr content_type_xml
genericExecute <- function(url,requestXML){
  
  response <- gPOST(url,content_type_xml(),
                    body = requestXML)  
  
  return(response)
  
}

parseXMLalgorithms  <-  function(xml){
  
  parentKey <- "wps:Process"
  childKey <- "ows:Identifier"
  titleKey <- "ows:Title"
  
  nodes <- xml2::xml_find_all(xml, sprintf("//%s/%s",parentKey,childKey), 
                              ns = pkg.env$NAMESPACES)
  values  <-  lapply(nodes,xml2::xml_text)
  
  nodes <- xml2::xml_find_all(xml, sprintf("//%s/%s",parentKey,titleKey),
                              ns = pkg.env$NAMESPACES)
  names(values) <- xml2::xml_text(nodes)
  
  return(values)
}

parseXMLgeoms <- function(xml){
  
  parentKey <- "FeatureTypeList"
  childKey <- "FeatureType"
  key="Name"
  # ignore namespaces
  xpath <- sprintf("//*[local-name()='%s']/*[local-name()='%s']/*[local-name()='%s']",parentKey,childKey,key)
  nodes <- xml2::xml_find_all(xml, xpath, ns = pkg.env$NAMESPACES)
  values <- xml2::xml_text(nodes)
  return(values)
}


parseXMLattributes <- function(xml,rm.duplicates = FALSE){
  parentKey  <-  "xsd:element"
  childKey <- "maxOccurs"
  key="name"
  
  nodes <- xml2::xml_find_all(xml,paste(c("//",parentKey,"[@",childKey,"]"),collapse=""))
  # will error if none found
  values <- list()
  for (i in 1:length(nodes)){
    values[[i]] <- xml2::xml_attr(nodes[[i]],key)
  }
  values <- unlist(values[values != "the_geom" & values != ""])
  if (rm.duplicates){
    values = unique(values)
  }
  return(values)
}

parseXMLvalues <- function(xml, key, rm.duplicates = FALSE){
  nodes <- xml2::xml_find_all(xml,paste0("//",key))
  # will error if none found
  values <- xml2::xml_text(nodes)
  if (rm.duplicates){
    values = unique(values)
  }
  return(values)
}

context("download and load")

test_that("download from geojob works", {
  testthat::skip_on_cran()
  cancel()
  fabric <- readRDS("data/test_webdata_fabric.rds")
  job <<- geoknife(stencil = c(-89,42), fabric = fabric, wait=TRUE)
  file = download(job)
  expect_true(file.exists(file))
})

test_that("load result works from geojob object.", {
  testthat::skip_on_cran()
  expect_is(result(job),'data.frame') 
})

test_that("load result works from job id only", {
  testthat::skip_on_cran()
  expect_is(result(id(job)),'data.frame')
})

# this test is duplicative and just takes extra time.
# test_that("download result works from job id URL", {
#   testthat::skip_on_cran()
#   expect_true(file.exists(download(id(job), overwrite = TRUE)))
# }) 

test_that("download result overwrite works", {
  testthat::skip_on_cran()
  expect_true(file.exists(download(job, overwrite = TRUE)))
})

context("Test xml parsing")

test_that("parseXMLnodes works for WFS responses", {
  testthat::skip_on_cran()
  local_file <- system.file('extdata','SB_getCapabilities.xml', package = 'geoknife')
  xml <- xml2::read_xml(local_file)
  output <- geoknife:::parseXMLgeoms(xml)
  expect_is(output, "character")
  expect_equal(output[2], "sb:WBIC_190900")
})

context("parse categorical")

test_that("internal parsing works", {
  local.file <- system.file('extdata','csv_categorical_multifeature.csv', package = 'geoknife')
  output <- parseCategorical(local.file, delim = ',')
  expect_equal(output[['Driftless Area']][output$category=='Sample Count' & output$variable == 'housing_classes_iclus_a1_2010'], 4735427)
  expect_equal(output[['Wyoming Basin']][output$category=='3' & output$variable == 'housing_classes_iclus_a1_2100'], 0.0006708306)
  expect_is(output, 'data.frame')
})

test_that('result works for categorical', {
  testthat::skip_on_cran()
  cancel()
  knife <- webprocess(algorithm = list('Categorical Coverage Fraction'="gov.usgs.cida.gdp.wps.algorithm.FeatureCategoricalGridCoverageAlgorithm"), 
                      wait=TRUE)
  
  library(sp)
  Sr1 = Polygon(cbind(c(-89,-89.2,-89.3,-89.2,-89),c(42,42.1,42,41.9,42)))
  
  Srs1 = Polygons(list(Sr1), "sample.poly")
  expect_warning(
    stencil <- simplegeom(Srl = list(Srs1), proj4string = CRS("+proj=longlat +datum=WGS84")))
  
  job <- geoknife(stencil, 'iclus', knife) # SLOW!!!
  expect_is(result(job), 'data.frame')
  cancel(job)
})

#'@importFrom httr GET verbose
#'@author Jordan S. Read
#'@rdname query
#'@aliases query,webdata-method  
#'@export
setGeneric(name="query",def=function(.Object, field, ...){standardGeneric("query")})


#' query webdata for various fields
#'
#' a method for finding possible values for a given field
#'
#' @param .Object a \code{webdata}, \code{webgeom}, or \code{webprocess} object.
#' @param field a plural parameter name for fields in .Object (e.g., 'variables', 'times')
#' @param ... additional arguments passed to methods
#' @return a character vector of values corresponding to the query field specified
#' @aliases query,webdata-method  
#' @keywords methods
#' @examples
#' \dontrun{
#' fabric <- webdata('prism')
#' query(fabric, 'variables')
#' wg <- webgeom()
#' query(wg, 'geoms')
#' geom(wg) <- "sample:CONUS_states"
#' query(wg, 'attributes')
#' attribute(wg) <- 'STATE'
#' query(wg, 'values', rm.duplicates = TRUE)
#' }
#' @rdname query
#' @aliases query,webdata-method  
setMethod(f = "query",signature("webdata",'character'),
          definition = function(.Object, field, ...){
            field <- match.arg(field, c('variables','times'))
            args <- list(fabric = .Object, ...)
            values <- do.call(paste0(field,"_query"), args)
            return(values)
          }
)
#'@rdname query 
#'@aliases query,webdata-method  
setMethod(f = "query",signature("webdata",'missing'),
          definition = function(.Object, field, ...){
            stop('specify a field to query against for webdata object')
          }
)
#'@rdname query
#'@aliases query,webdata-method  
setMethod(f = "query",signature("character",'missing'),
          definition = function(.Object, field, ...){
            field <- match.arg(.Object, c('webdata'))
            values <- do.call(paste0(field,"_query"), list(...))
            return(values)
          }
)

#' @importFrom httr content_type_xml
webdata_query <- function(csw_url = pkg.env$urls$csw_url){
  request = '<csw:GetRecords xmlns:csw="http://www.opengis.net/cat/csw/2.0.2" service="CSW" version="2.0.2" resultType="results" outputSchema="http://www.isotc211.org/2005/gmd" maxRecords="1000">
    <csw:Query typeNames="csw:Record">
    <csw:ElementSetName>full</csw:ElementSetName>
    </csw:Query>
    </csw:GetRecords>'
  xpath <- '//srv:containsOperations/srv:SV_OperationMetadata/srv:connectPoint/gmd:CI_OnlineResource/gmd:linkage/gmd:URL'
  parentxpath <- paste0(xpath,paste(rep('/parent::node()[1]',6), collapse='')) #/parent::node()[1]

  response <- gcontent(gPOST(url = csw_url, body = request, content_type_xml()))
  namespaces = xml2::xml_ns(response)
  urls <- lapply(xml2::xml_find_all(response, xpath, ns = namespaces), 
                 xml2::xml_text)
  
  abstracts = xml2::xml_text(xml2::xml_find_all(response,
                                                paste0(parentxpath,'/gmd:abstract'),
                                                ns = namespaces))
  
  titles = xml2::xml_text(xml2::xml_find_all(response,
                                      paste0(parentxpath,
    '/gmd:citation/gmd:CI_Citation/gmd:title/gco:CharacterString'), 
                                      ns = namespaces))
  
  group = list()
  sort.ix <- sort(titles, index.return = TRUE)$ix
  
  for (i in 1:length(urls)){
    group[[i]] <- list(title = titles[sort.ix[i]], url=urls[[sort.ix[i]]], abstract = abstracts[sort.ix[i]])
  }
  
  types = unname(xml2::xml_attrs(xml2::xml_find_all(response, 
                                           parentxpath, 
                                           ns = namespaces)))
  
  # removing all non-OPeNDAP endpoints
  group[which(substr(types[sort.ix],1,7) != "OPeNDAP")] <- NULL
  return(datagroup(group))
}

#'@rdname query
#'@aliases query,webprocess-method  
setMethod(f = "query",signature("webprocess",'character'),
          definition = function(.Object, field, ...){
            input_list <- list(...)
            if (field == 'algorithms'){
              url <- sprintf('%s?service=WPS&version=%s&request=GetCapabilities',
                             url(.Object), 
                             version(.Object))
            } else {
              stop('field ', field, ' not supported.')
            }
            input_list[['xml']] <- gcontent(gGET(url))
            values <- do.call(paste0('parseXML',field), input_list)
            return(values)
          })


#'@rdname query
#'@aliases query,webgeom-method  
setMethod(f = "query",signature("webgeom",'character'),
          definition = function(.Object, field, ...){
            input_list <- list(...)
            
            if (field == 'geoms'){
              
              url <- sprintf('%s?service=WFS&version=%s&request=GetCapabilities',url(.Object), version(.Object))
            } else if (field == 'attributes'){
              if (any(is.na(geom(.Object)))){
                stop('cannot query for attribute w/o geom specified.')
              }
              
              url <- sprintf('%s?service=WFS&version=%s&request=DescribeFeatureType&typename=%s',
                             url(.Object), version(.Object), geom(.Object))
            } else if (field == 'values'){
              if (is.na(.Object@attribute)){
                stop('cannot query for value w/o attribute specified.')
              }
              url <- sprintf('%s?service=WFS&version=%s&request=GetFeature&typename=%s&propertyname=%s',
                             url(.Object), version(.Object), geom(.Object), .Object@attribute)
              input_list[['key']] <- sprintf("%s/*[local-name()='%s']", geom(.Object), .Object@attribute)
            } else {
              stop('field ', field, ' not supported.')
            }
            input_list[['xml']] <- gcontent(gGET(url))
            values <- unique(do.call(paste0('parseXML',field), input_list))
            return(values)
          })

## ----init, echo=FALSE, include=FALSE------------------------------------------
library(geoknife)
knitr::opts_chunk$set(eval=FALSE)

## ----stencil, echo=T----------------------------------------------------------
#  gconfig(verbose=FALSE)
#  stencil <- webgeom(url="https://www.sciencebase.gov/catalogMaps/mapping/ows/5b68e7e3e4b006a11f75c06a")
#  
#  stencil_geoms <- query(stencil, 'geoms')
#  print(stencil_geoms)

## ----attribute, echo=T--------------------------------------------------------
#  geom(stencil) <- stencil_geoms[2]
#  
#  stencil_attributes <- query(stencil, 'attributes')
#  print(stencil_attributes)

## ----value, echo=T------------------------------------------------------------
#  attribute(stencil) <- stencil_attributes[2]
#  
#  print(query(stencil, 'values'))

## ----fabric, echo=T-----------------------------------------------------------
#  fabric <- webdata(url = 'https://cida.usgs.gov/thredds/dodsC/prism_v2',
#                    variables = c('tmx', 'tmn', 'ppt'),
#                    times = as.POSIXct(c('2000-01-01', '2010-01-01')))
#  print(fabric)

## ----query_fabric, echo=T, warning=F------------------------------------------
#  fabric_variables <- query(fabric, "variables")
#  fabric_times <- query(fabric, "times")
#  
#  print(paste(fabric@url, "has",
#              paste(fabric_variables, collapse = ", "),
#              "variables for the time range", fabric_times[1],
#              "to", fabric_times[2]))

## ----execute, echo=T----------------------------------------------------------
#  prism_yahara_result <- result(geoknife(stencil, fabric, wait = TRUE))

## ----print_execute, echo=F----------------------------------------------------
#  print(paste0("The returned dataframe has ",
#               ncol(prism_yahara_result),
#               " columns with names '",
#               paste(names(prism_yahara_result), collapse = "', '"),
#               "' and ", nrow(prism_yahara_result),
#               " rows from ",
#               prism_yahara_result[1,1],
#               " to ",
#               prism_yahara_result[nrow(prism_yahara_result), 1]))

#'@rdname XML-method
#'@aliases XML,webgeom-method
#'@export
setGeneric(name="XML",def=function(stencil, fabric, knife){standardGeneric("XML")})

#' XML from set of objects
#' 
#' Extract important parts of stencil, fabric, and knife into POST XML
#' 
#'@param stencil a \code{\link{webdata}} OR \code{\link{simplegeom}} object
#'@param fabric a \code{\link{webdata}} object
#'@param knife a \code{\link{webprocess}} object
#'@return XML as ?string?
#'
#'@examples
#'wd <- webdata('prism',times = as.POSIXct(c('2001-01-01','2002-02-05')))
#'wg <- webgeom('state::Wisconsin')
#'\dontrun{
#'XML(wg, wd, webprocess())
#'sg <- simplegeom(c(-89,45))
#'XML(sg, wd, webprocess())
#'}
#'@rdname XML-method
#'@export
setMethod(f = "XML",signature = c("ANY","webdata","webprocess"), 
          definition = function(stencil, fabric, knife){
            #stencil can be webgeom OR simplegeom 
            
  knife <- .setProcessInputs(webprocess = knife, 
                             stencil = stencil, 
                             fabric = fabric)
  
  whisker_list <- get_wps_execute_attributes(knife)
  
  whisker_list["identifier"] <- knife@algorithm[[1]]
  
  input_list <- list() # unnamed list for {{#inputs}}
  
  for (i in 1:length(knife@processInputs)){
    input_identifier	<-	names(knife@processInputs[i])
    input_literal_data <- knife@processInputs[input_identifier]
    
    if (!is.na(input_literal_data)){
      
      data_element_list <- list() # unnamed list for {{#data_elements}}
      
      for (j in 1:length(unlist(input_literal_data))){
        input_literal_data_element <- 
          unlist(knife@processInputs[input_identifier])[[j]]
        
        if (is.null(input_literal_data_element)) {
          stop(input_identifier, ' cannot be NULL. it is required') }
        
        input_list <- c(input_list,
                        list(list(input_identifier = input_identifier,
                                  input_literal_data_element = input_literal_data_element)))
      }
    }
    
  }
  
  whisker_list["inputs"] <- list(input_list)
  
  whisker_list["feature_collection"] <- "FEATURE_COLLECTION"

  whisker_list <- c(whisker_list, suppressWarnings(addGeom(stencil)))
  
  whisker_list <- c(whisker_list, addResponse(knife))
  
  return(whisker::whisker.render(readLines(system.file(
    "templates/execute_template.xml", package = "geoknife")), whisker_list))
  
})

addResponse <- function(.Object){
  
  response_list <- list()
  
  # Store the response document on the server to download later?
  response_list["storeExecuteResponse"] <- "true"
  
  # Return a status document or just return the result?
  response_list["status"] <- "true"

  # include the response as a url reference or in line?
  response_list["asReference"] <- "true"
  
  #if text/tab-separated-values" or output_type
  if (!is.null(.Object@processInputs$DELIMITER) && 
      .Object@processInputs$DELIMITER=="TAB"){
    response_list["output_mimetype"] <- ' mimeType="text/tab-separated-values"'
  } else if (!is.null(.Object@processInputs$OUTPUT_TYPE) && 
             .Object@processInputs$OUTPUT_TYPE=="geotiff") {
    response_list["output_mimetype"] <- ' mimeType="application/zip"'
  }

  response_list["output_identifier"] <- "OUTPUT"
  
  return(response_list)
}

setGeneric(name="addGeom",def=function(stencil, xmlNodes){standardGeneric("addGeom")})

setMethod(f = "addGeom",signature = c("webgeom","ANY"), 
          definition = function(stencil){
            
  geom_list <- list()
  
  # This is the WFS service base URL
  geom_list["wps_reference_href"]  <- url(stencil)
  
  # These could / should be hard coded in the template.
  geom_list["wfs_namespace"] <- stencil@WFS_NAMESPACE
  geom_list["gml_namespace"] <- stencil@GML_NAMESPACE
  geom_list["wfs_version"] <- version(stencil)
  geom_list["wfs_service"] <- "WFS"
  
  # This is the format required by the GDP.
  geom_list["wfs_outputformat"] <- "text/xml; subtype=gml/3.1.1"

  # This is the WFS layer/typename
  geom_list["wfs_typename"] <- as.character(stencil@geom)
  
  # This is what the WFS layer calls its geometry property
  geom_list["wfs_geom_property"] <- "the_geom" # this is only valid for geoserver
  
  # This is the attribute property that the GDP will use to label output
  geom_list["wfs_attribute_property"] <- stencil@attribute
  
  if(!is.na(stencil@values[1])) {
    properties <- list()
    for (val in values(stencil)){
      properties <- c(properties,
                      list(list(match_case = "true",
                                property_name = stencil@attribute,
                                property_literal = val)))
    }
    
    geom_list["filter_properties"] <- list(list(properties = properties))
  }
  
  return(list(wfs_reference = list(geom_list)))
})

setMethod(f = "addGeom",signature = c("ANY","ANY"),
          definition = function(stencil, xmlNodes){
            stencil <- simplegeom(stencil)
            return(addGeom(stencil, xmlNodes))
})

setMethod(f = "addGeom",signature = c("simplegeom","ANY"),
          definition = function(stencil, xmlNodes){
            
  simplegeom_list <- list()
  
  simplegeom_list["simplegeo_mimetype"] <- "text/xml" # "encoding"="UTF-8"?
  simplegeom_list["simplegeo_schema"] <- 
    "http://schemas.opengis.net/gml/3.1.1/base/feature.xsd"
  simplegeom_list["gml_namespace"] <- "http://www.opengis.net/gml"
  simplegeom_list["draw_namespace"] <- stencil@DRAW_NAMESPACE
  simplegeom_list["draw_schema_location"] <- paste(c(stencil@DRAW_NAMESPACE,
                                                     stencil@DRAW_SCHEMA),
                                                   collapse=' ')
  
  # loop this section for multiple polygons:
  
  geom <- stencil@sp
  poly_list <- list()
  for (j in seq_along(geom)){
    
    geom_list <- list(poly_id = sprintf("poly.%s",j))
    geom_list["geom_property"] <- "the_geom"
    
    ringCoords <- geom@polygons[[j]]@Polygons[[1]]@coords
    
    ring = vector(length = 2*nrow(ringCoords))
    ring[seq(from = 1,by = 2,length.out = nrow(ringCoords))] <- ringCoords[,2]
    ring[seq(from = 2,by = 2,length.out = nrow(ringCoords))] <- ringCoords[,1]
    ring.val	<-	paste(ring,collapse = ' ')
    
    if(is.null(drawID <- names(geom@polygons)[j])) 
      drawID <- paste0("point", as.character(j))
    

    geom_list["filter_id"] <- .FEATURE_ATTRIBUTE_NAME(stencil)
    geom_list["ID_property"] <- drawID
    geom_list["srsDimension"] <- "2"
    geom_list["srsName"] <- "urn:x-ogc:def:crs:EPSG:4326" # FROM CRS in the future!!!
    
    geom_list["poslist"] <- ring.val
    
    poly_list <- c(poly_list,
                   list(geom_list))
  }
  simplegeom_list["polys"] <- list(poly_list)

  return(list(simple_geometry = list(simplegeom_list)))
  
})

#' the version of an object
#' 
#' get the version of webgeom or webprocess
#' 
#' @param .Object a \linkS4class{webgeom} or \linkS4class{webprocess} object
#' @param value a version
#' @rdname version
#' @aliases
#' version
#' version<-
#' @export
setGeneric(name="version<-",def=function(.Object, value){standardGeneric("version<-")})

#' @aliases version
#' @rdname version
#' @export
setGeneric(name="version",def=function(.Object){standardGeneric("version")})


#' @aliases version
#' @rdname version
setMethod(f = "version<-",signature(.Object = "ANY"), definition = function(.Object, value){
  .Object <- initialize(.Object, version = value)
  return(.Object)})

#' @aliases version
#' @rdname version
setMethod(f = "version",signature="ANY",
          definition = function(.Object){
            return(.Object@version)
          }
)

#'@rdname email-method
#'@aliases email,geojob-method
#'@export
setGeneric(name="email",def=function(geojob, knife){standardGeneric("email")})

#' email user when processing job is complete
#' 
#' configure job to send an email when complete (success or failure)
#'
#'@param email a character for email address to use
#'
#'@rdname email-method
#'@aliases email,geojob-method
#'@keywords internal
#'@export
setMethod(f = "email",signature = c("geojob",'webprocess'), 
          definition = function(geojob, knife){

            response <- genericExecute(knife@UTILITY_URL,
                                       make_email_execute_xml(geojob, knife))
            #return boolean?
          })

make_email_execute_xml <- function(geojob, knife) {
  email_list <- get_wps_execute_attributes(knife)
  email_list["identifier"] <- knife@emailK
  input_list <- list()
  input_list <- list(list(input_identifier = "wps-checkpoint",
                          input_literal_data_element = id(geojob)),
                     list(input_identifier = "email",
                          input_literal_data_element = knife@email),
                     list(input_identifier = "filename",
                          input_literal_data_element = "geoknife_output"))
  email_list <- c(email_list, inputs = list(input_list))
  email_list["responsedocument"] <- list(list(result_name = "result"))
  return(whisker::whisker.render(readLines(system.file(
    "templates/utility_execute_template.xml", package = "geoknife")), 
                                 email_list))
}

#' the algorithm of a webprocess object
#' 
#' Functions to get or set the algorithm of a \linkS4class{webprocess} object. 
#' The algorithm is the type of process that will be used, and can be accessed 
#' or modified using the algorithm method. 
#' 
#'@param .Object a \linkS4class{webprocess} object
#'@param value a list with name of algorithm and relative url endpoint
#'@examples
#'\dontrun{
#'wp <- webprocess()
#'algorithm(wp)
#'}
#'@aliases 
#'algorithm
#'algorithm<-
#'@rdname algorithm-webprocess
#'@export
setGeneric(name="algorithm",def=function(.Object){
  standardGeneric("algorithm")
})

#'@rdname algorithm-webprocess
#'@aliases algorithm
#'@export
setGeneric(name="algorithm<-",def=function(.Object, value){
  standardGeneric("algorithm<-")
})

#' @rdname algorithm-webprocess
#' @aliases algorithm
setMethod(f = "algorithm",signature="webprocess",
          definition = function(.Object){
            return(.Object@algorithm)
          }
)

#'@rdname algorithm-webprocess
#'@aliases algorithm
setMethod(f = "algorithm<-",signature = "webprocess",
          definition = function(.Object,value){
            .Object <- initialize(.Object, algorithm = value)
            return(.Object)
          }
)

#'@rdname algorithm-webprocess
#'@aliases algorithm
setMethod(f = "algorithm",signature="xml_document",
          definition = function(.Object){
            xpath <- "//wps:Execute/ows:Identifier"
            algo <- xml2::xml_find_all(.Object, xpath, ns = pkg.env$NAMESPACES)
            if (length(algo) != 1) {
              stop("Invalid XML, algorithm must be defined (or only once)")
            }
            algo <- xml2::xml_text(algo[[1]])
            
            # want friendly names for algorithms
            if (sum(grepl(algo, getKnives())) == 1) {
              result <- getKnives()[[grep(algo, getKnives())]][[1]]
            } else {
              result <- list(algo)
            }
            return(result)
          }
)

#' parse categorical coverage file into R environment
#'
#' a function for loading data into R from a file (or URL) from a completed processing request
#'
#' @param file a \linkS4class{geojob} categorical processing result file location
#' (See \code{\link{download}}).
#' @param delim the file delimiter
#' @return a data.frame of categorical fraction (and/or count) values.
#' @keywords methods
#' @export
#' @importFrom utils read.table
#' @seealso \code{\link{check}}, \code{\link{download}}, \code{\link{parseTimeseries}}
#' @examples
#' local.file <- system.file('extdata','csv_categorical_multifeature.csv', package = 'geoknife')
#' output <- parseCategorical(local.file, delim = ',')
parseCategorical <- function(file, delim){

  config = parseCategoricalConfig(file, delim)
  
  if(!is.na(config[['features']][1]) && config[['features']][1]=="") {
    config[['features']]<-config[['features']][-1]
  }
  
  dataOut <- data.frame(c())
  
  for (blk in 1:length(config[['vars']])){
    blockData <- read.table(file, sep = delim, 
                            header = TRUE, 
                            nrows = config[['nrows']][blk], 
                            skip = config[['skip']][blk], 
                            as.is=TRUE, check.names = FALSE, stringsAsFactors = FALSE)
    startCol<-2
    catNames <- unique(names(blockData)[startCol:ncol(blockData)])
    for (cat in seq_along(catNames)){
      # select data columns based on stat code
      cat.i <- which(names(blockData) == catNames[cat])
      cat.data <- matrix(blockData[, cat.i], nrow=1)
      cat.name <- catNames[cat]
      
      cat.data = data.frame(cat.name, cat.data, as.character(config[['vars']][blk]), stringsAsFactors = FALSE)
      names(cat.data) <- c('category', blockData[, 1], 'variable')

      tryCatch({
        dataOut <- rbind(dataOut, cat.data)
      }, warning = function(w) {
        stop(paste('Variable',as.character(config[['vars']][blk]),'had a problem being added to the data frame.'))
      }, error = function(e) {
        stop(paste('Variable',as.character(config[['vars']][blk]),'had a problem being added to the data frame.'))
      }
      )
    }
  }
  return(dataOut)
  
}

parseCategoricalConfig = function(file, delim){
  skipHead = 1 # Number of lines to skip past the variable marker header?
  vals.start = 3 #lines after blockStart when the data begin
  varMarker = '# ' # Symbol that denotes a variable identifier and a new block of output.
  c <- file(file,"r") 
  fileLines <- readLines(c) # This concerns me!!!
  close(c)
  nRead <- length(fileLines)
  blockStart <- grep(varMarker, fileLines) # Lines containing variable IDs.
  skips = blockStart+skipHead 
  blockEnd = c(blockStart[-1] - 1, nRead) # End of blocks
  nrows = blockEnd - skips - 1 # Number of ros per block.
  data.lines <- unlist(lapply(seq_along(blockStart), function(x) (blockStart[x]+vals.start):blockEnd[x]))
  features = unique(unlist(lapply(fileLines[data.lines], function(x) strsplit(x, split = delim)[[1]][1]))) # Parsing out feature identifiers
  vars = sub(varMarker,"",fileLines[blockStart]) # Getting the variable names from the block starts.
  config = list(vars = vars, features = features, skip = skips, nrows = nrows) # Return all the good stuff!
  return(config)
}

#' the values of a webgeom
#' 
#' The values of a webgeom are the values of the attributes used in the geometries. 
#' For example, if the webgeom's "geom" field is a feature collection containing states 
#' and counties, and the "attributes" are the states, then the values would be the 
#' specific states. 
#' 
#' @param .Object a \linkS4class{webgeom} object
#' @param value a values
#' @rdname values
#'
#' @examples 
#' wg <- webgeom('state::Wisconsin')
#' values(wg)
#' values(wg) <- c('Wisconsin','New Hampshire')
#' @aliases
#' values
#' values<-
#' @export
setGeneric(name="values<-",def=function(.Object, value){standardGeneric("values<-")})

#' @aliases values
#' @rdname values
#' @export
setGeneric(name="values",def=function(.Object){standardGeneric("values")})


#'@aliases values
#'@rdname values
setMethod(f = "values<-",signature(.Object = "webgeom"), definition = function(.Object, value){
  
  .Object@values <- as.character(value)

  return(.Object)})

#'@aliases values
#'@rdname values
setMethod(f = "values",signature="webgeom",
          definition = function(.Object){
            return(.Object@values)
          }
)

# knife = NULL for backward compatibility
wfsFilterFeatureXML <- function(.Object, knife=NULL, match.case = TRUE){
  match.case.char <- ifelse(match.case, 'true','false')
  
  wfs_list <- list()
  
  wfs_list["service"] <- "WFS"
  wfs_list["version"] <- version(.Object)
  wfs_list["schema_location"] <- paste(c(.Object@WFS_NAMESPACE,
                                         pkg.env$SCHEMA_LOCATIONS[['WPS_SCHEMA_LOCATION']]),
                                       collapse=" ")
  wfs_list["wfs"] <- .Object@WFS_NAMESPACE
  wfs_list["gml"] <- .Object@GML_NAMESPACE
  wfs_list["ows"] <- pkg.env$NAMESPACES[['ows']]
  wfs_list["ogc"] <- pkg.env$NAMESPACES[['ogc']]
  wfs_list["xsi"] <- pkg.env$NAMESPACES[['xsi']]
  
  wfs_list["query_typename"] <- geom(.Object)
  
  wfs_list["attribute_property"] <- .Object@attribute
  
  properties <- list()
  for (val in values(.Object)){
    properties <- c(properties,
                    list(list(match_case = match.case.char,
                              property_name = .Object@attribute,
                              property_literal = val)))
  }
  
  wfs_list["properties"] <- list(properties)
  
  return(whisker::whisker.render(readLines(system.file(
    "templates/getfeature_template.xml", package = "geoknife")), 
    wfs_list))
}

context("query webgeom")


test_that("query geoms", {
  testthat::skip_on_cran()
  expect_is(query(webgeom(), 'geoms'),'character')
  wg <- webgeom(geom = "sample:CONUS_states",
                attribute = "STATE",
                values = "New Hampshire")
  expect_is(query(wg, 'geoms'),'character')
  expect_error(query(webgeom(), 'attributes'))
  expect_error(query(webgeom(), 'values'))
})

test_that("query attributes", {
  testthat::skip_on_cran()
  wg <- webgeom(geom = "sample:CONUS_states",
              attribute = "STATE",
              values = "New Hampshire")
  expect_is(query(wg, 'attributes'),'character')
})

test_that("query values", {
  testthat::skip_on_cran()
  wg <- webgeom(geom = "sample:CONUS_states",
                attribute = "STATE",
                values = "New Hampshire")
  expect_is(query(wg, 'values'),'character')
})

test_that("query values returns only unique", {
  testthat::skip_on_cran()
  expect_false(any(
    duplicated(
      query(webgeom(geom="sample:Counties" , attribute = "STATE_FIPS"), 'values'))
    )
  )
})

context("Create WFS post XML works")
test_that("two states", {
  wg <- readRDS("data/test_wfsgetfeature_wg.rds")
  xml <- geoknife:::wfsFilterFeatureXML(wg)

  fn <- "data/test_wfsgetfeature.xml"
  expect_equal(xml, gsub("\r", "", readChar(fn, file.info(fn)$size)))
})

#'@rdname variables_query-method
#'@aliases variables_query,webdata-method
#'@export
setGeneric(name="variables_query",def=function(fabric, knife){standardGeneric("variables_query")})

#' variables query
#' 
#' find possible variables in a webdata dataset
#' 
#' 
#'@param variables
#'
#'@rdname variables_query-method
#'@aliases variables_query,webdata-method
#'@keywords internal
#'@export
setMethod(f = "variables_query",signature = c("webdata","missing"), 
          definition = function(fabric, knife){
            knife <- webprocess()
            variables_query(fabric, knife)
          })

#'@rdname variables_query-method
#'@aliases variables_query,webdata-method
#'@keywords internal
#'@export
setMethod(f = "variables_query",signature = c("webdata","webprocess"), 
          definition = function(fabric, knife){
            if (is.na(url(fabric))){
              stop('url cannot be NA for fabric argument when querying for available variables', call. = FALSE)
            } 

            response <- genericExecute(knife@UTILITY_URL,
                                       make_listopendapgrids_execute_xml(fabric, knife))

            # will error if none found
            values <- xml2::xml_text(
              xml2::xml_find_all(gcontent(response),'//gdp:shortname'),)
            return(values)
          })

make_listopendapgrids_execute_xml <- function(fabric, knife) {
  getgtr_list <- get_wps_execute_attributes(knife)
  getgtr_list["identifier"] <- fabric@dataList
  input_list <- list()
  input_list <- list(list(input_identifier = "catalog-url",
                          input_literal_data_element = url(fabric)),
                     list(input_identifier = "allow-cached-response",
                          input_literal_data_element = "false"))
  getgtr_list <- c(getgtr_list, inputs = list(input_list))
  getgtr_list["rawoutput"] <- list(list(result_name = "result_as_xml"))
  return(whisker::whisker.render(readLines(system.file(
    "templates/utility_execute_template.xml", package = "geoknife")), 
    getgtr_list))
}

#'@title cancel a geo-web processing request
#'@details cancel is a method for cancelling a geo-web processing request.
#'
#'@param .Object a \linkS4class{geojob} object with an active geo-web processing request.
#'@return A \linkS4class{geojob} object with no active job
#'
#'@docType methods
#'@keywords methods
#'@description Cancel process for \code{geojob}
#'@seealso \code{check}, \code{start}
#'@aliases cancel
#'@docType methods
#'@export
#'@rdname cancel-methods
#'@examples 
#'wd <- webdata('prism')
#'wg <- webgeom('state::New Hampshire')
#'wp <- webprocess()
#'
#'\dontrun{
#'if(!any(is.null(wp), is.null(wg), is.null(wd))) {
#'  gj <- geojob()
#'  xml(gj) <- XML(wg, wd, wp)
#'  url(gj) <- url(wp)
#'}
#'
#'gj <- start(gj)
#'gj <- cancel(gj)
#'}
setGeneric(name="cancel",def=function(.Object){standardGeneric("cancel")})

#'@rdname cancel-methods
#'@export
setMethod(f = "cancel",signature(.Object = "geojob"),definition = function(.Object){
  setJobState()
  .Object@id <- "<no active job>"
  return(.Object)
})

#'@rdname cancel-methods
#'@export
setMethod(f = "cancel",signature(.Object = "missing"),definition = function(.Object){
  setJobState()
})

setMethod("show", "geojob", function(object){
  cat('An object of class "geojob":\n')
  cat('url:',url(object),'\n')
  cat('xml:\n', xml(object),'\n')
  cat(getPackageName(), 'version:', object@package.version,'\n')
  cat('algorithm version:', object@algorithm.version,'\n')
  cat('id:', id(object))
})

setMethod("show", "datagroup", function(object){
  cat('An object of class "datagroup":\n')
  for (i in 1:length(object@group)){
    cat(paste0('[',i,'] '))
    cat(object@group[[i]]$title,'\n')
    cat('  url:',object@group[[i]]$url,'\n')
  }
  
})

setMethod("show", "webdata", function(object){
  cat('An object of class "webdata":\n')
  cat(paste0('times: ',
             strftime(times(object)[1] ,format = "%Y-%m-%dT%H:%M:%SZ", tz='UTC'),
             ', ', strftime(times(object)[2] ,format = "%Y-%m-%dT%H:%M:%SZ", tz='UTC'),'\n'))
  cat('url:',url(object),'\n')
  cat('variables:', paste(variables(object), collapse=', '))
})

setMethod("show", "webgeom", function(object){
  cat('An object of class "webgeom":\n')
  cat('url:',url(object),'\n')
  cat('geom:',geom(object),'\n')
  cat('attribute:',object@attribute,'\n')
  cat('values:', paste(values(object), collapse=', '),'\n')
  cat('wfs version:', version(object))
})

setMethod("show", "webprocess", function(object){
  cat('An object of class "webprocess":\n')
  cat('url:',url(object),'\n')
  cat('algorithm:', names(algorithm(object)),'\n')
  cat('web processing service version:', version(object),'\n')
  cat('process inputs: \n')
  inputs <- inputs(object)
  inputs <- inputs[!paste0('.',names(inputs)) %in% pkg.env$private.funs]
  for (i in 1:length(inputs)){
    cat(paste0('   ',names(inputs)[i],": ",inputs[[i]], '\n'))
  }
  cat('wait:', object@wait, '\n')
  cat('email:', object@email, '\n' )
})

#' inputs of webprocess
#' 
#' The webprocess inputs are a list of parameter names and their associated values.  
#' These inputs are specific to an individual \code{algorithm} used by the webprocess, 
#' and are pulled in from the web with defaults. An NA value in an input field means that 
#' this parameter will be left out of the web processing request. NULL values are required fields 
#' for the post and must be populated. For some values, there are defaults used if NULL (e.g.,
#' the mean for 'STATISTIC' is "mean"). Only characters can be used in input fields, but 
#' booleans are changed to characters as 'true' and 'false'. 
#' 
#' @param .Object a webprocessing object
#' @param \dots arguments matching fields in .Object's processInputs slot
#' @param value a field pair for .Object processInputs
#' @rdname inputs-webprocess
#'@aliases
#'inputs<-
#'@examples
#'\dontrun{
#'wp <- webprocess(DELIMITER = 'TAB')
#'inputs(wp)
#'
#'inputs(wp) <- list(DELIMITER = 'COMMA', SUMMARIZE_FEATURE_ATTRIBUTE = 'false')
#'inputs(wp)
#'inputs(wp, "DELIMITER")
#'inputs(wp, "DELIMITER") <- "TAB"
#'}
#'@export
#'@keywords internal
setGeneric(name="inputs<-",def=function(.Object, ..., value){
  standardGeneric("inputs<-")
})

#'@title inputs of webprocess
#'@description access or set the inputs of a webprocess
#'@param .Object a webprocessing object
#'@rdname inputs-webprocess
#'@aliases inputs
#'@export
#'@keywords internal
setGeneric(name="inputs",def=function(.Object, ..., value){standardGeneric("inputs")})

#'@rdname inputs-webprocess
#'@aliases inputs
setMethod(f = "inputs",signature = "webprocess",
          definition = function(.Object, ..., value){
            if (missing(...)){
              return(.Object@processInputs)
            } else {
              ret_idx <- which(names(.Object@processInputs) %in% as.character(expand.grid(...,stringsAsFactors = F)))
              return(.Object@processInputs[ret_idx])
            }
          })

setOldClass("xml_document")

#'@rdname inputs-webprocess
#'@aliases inputs
setMethod(f = "inputs",signature = "xml_document",
          definition = function(.Object, ...){
            inputXpath <- "//wps:Execute/wps:DataInputs/wps:Input"

            inputs <- xml2::xml_find_all(.Object, inputXpath, ns = pkg.env$NAMESPACES)
            results <- list()
            names <- c()
            for (i in 1:length(inputs)) {
              xmlList <- xml2::as_list(inputs[[i]])
              # only extract literal data
              if (!is.null(xmlList$Data) && !is.null(xmlList$Data$LiteralData)) {
                results <- c(results, xmlList$Data$LiteralData)
                names <- c(names, xmlList$Identifier)
              }
            }
            names(results) <- names
            
            return(results)
          })

#'@rdname inputs-webprocess
#'@aliases inputs<-
setMethod(f = "inputs<-",signature = c("webprocess",'missing'),
          definition = function(.Object, ..., value){

            args <- expand.grid(..., stringsAsFactors = FALSE)
            for (i in seq_len(ncol(args))){
              .Object <- .setInput(.Object, names(args)[i], args[[i]])
            }
            return(.Object)

          })

#'@rdname inputs-webprocess
#'@aliases inputs<-
setMethod(f = "inputs<-",signature = c("webprocess",'character'),
          definition = function(.Object, ..., value){
            name <- as.character(expand.grid(..., stringsAsFactors = FALSE))
            .Object <- .setInput(.Object, name, value)
            return(.Object)
            
          })

#'@rdname inputs-webprocess
#'@aliases inputs<-
setMethod(f = "inputs<-",signature = c("webprocess",'list'),
          definition = function(.Object, ..., value){

            for (i in seq_len(length(value))){
              .Object <- .setInput(.Object, names(value)[i], value[[i]])
            }
            inputs(.Object, ...)
            return(.Object)
          })

.setInput <- function(.Object, name, arg){
  
  if (is.logical(arg)){
    arg <- ifelse(isTRUE(arg),'true','false')
  }
  
  if (!is.character(arg))
    stop('Process inputs values must be characters.')
  if (!name %in% names(.Object@processInputs))
    stop(name,' not found in ', paste(c('url', 'algorithm', 'version', 'email', 'wait', names(inputs(.Object))), collapse = ', '), call. = FALSE)
  .Object@processInputs[[name]] <- arg
  return(.Object)
}

#' @title webprocess class
#' @description A class representing geoknife web processing specifications
#' @slot url URL for webprocessing service. 
#' Can be set or accessed using \code{\link[geoknife]{url}}
#' @slot algorithm a list for algorithm used. 
#' Can be set or accessed using \code{\link{algorithm}}
#' @slot version a character specifying the wep processing service version to use. 
#' Can be set or accessed using \code{\link[geoknife]{version}}
#' @slot email an email to send finished process alert to
#' @slot wait boolean for wait until complete (hold up R until processing is complete)
#' @slot sleep.time numeric for time to wait in between calls to \code{\link{check}}. Only used if \code{wait=TRUE}
#' @slot processInputs (_private) a list of required and options process inputs, and their 
#' default values (if specified). This is populated (or repopulated) whenever \code{algorithm} is set.
#' @slot WPS_SCHEMA_LOCATION (_private) location for web processing service schema
#' @slot WPS_NAMESPACE (_private) location for web processing service namespace
#' @slot OWS_NAMESPACE (_private) namespace web location 
#' @slot XSI_SCHEMA_LOCATION (_private) schema web location
#' @slot XSI_NAMESPACE (_private) namespace web location
#' @slot XLINK_NAMESPACE (_private) namespace web location
#' @slot UTILITY_URL (_private) web processing service utility url. Uses same base url as
#' public slot \code{url}
#' @slot OGC_NAMESPACE (_private) namespace web location
#' @slot emailK (_private) relative url for email when complete utility. 
#' @rdname webprocess-class
#' @seealso \code{\link{webprocess}}, \code{\link[geoknife]{url}}, 
#' \code{\link{algorithm}}, \code{\link[geoknife]{version}}
#' @aliases
#' webprocess-class
#' @exportClass webprocess
setClass(
  Class = "webprocess",
  prototype = prototype(
    version = gconfig('version'),
    WPS_SCHEMA_LOCATION = pkg.env$SCHEMA_LOCATIONS[['WPS_SCHEMA_LOCATION']],
    WPS_NAMESPACE = pkg.env$NAMESPACES[['wps']],
    XSI_SCHEMA_LOCATION = pkg.env$SCHEMA_LOCATIONS[['XSI_SCHEMA_LOCATION']],
    XSI_NAMESPACE = pkg.env$NAMESPACES[['xsi']],
    OGC_NAMESPACE = pkg.env$NAMESPACES[['ogc']],
    XLINK_NAMESPACE = pkg.env$NAMESPACES[['xlink']],
    OWS_NAMESPACE = pkg.env$NAMESPACES[['ows']],
    emailK = 'gov.usgs.cida.gdp.wps.algorithm.communication.EmailWhenFinishedAlgorithm'
  ),
  representation = representation(
    url="character",
    algorithm="list",
    version="character",
    email = "character",
    wait = 'logical',
    sleep.time = "numeric",
    processInputs="list",
    WPS_SCHEMA_LOCATION="character",
    WPS_NAMESPACE="character",
    OWS_NAMESPACE="character",
    XSI_SCHEMA_LOCATION="character",
    XSI_NAMESPACE = "character",
    XLINK_NAMESPACE = "character",
    UTILITY_URL = "character",
    OGC_NAMESPACE="character",
    emailK="character")
)

setMethod(f="initialize",signature="webprocess",
          definition=function(
            .Object, 
            url = .Object@url, 
            algorithm = .Object@algorithm,
            version = .Object@version,
            email = .Object@email,
            wait = .Object@wait, 
            sleep.time = .Object@sleep.time, ...)
            {
          
            # // -- supporting pass through of existing inputs arguments *when* they are applicable.
            old.algorithm <- if(length(.Object@algorithm) > 0) .Object@algorithm else gconfig('algorithm')
            old.inputs = inputs(.Object)
            
            #things that use package variables:
            .Object@url <- if(length(url) > 0) url else gconfig('wps.url')
            .Object@sleep.time <- if(length(sleep.time) > 0) sleep.time else gconfig('sleep.time')
            .Object@wait <- if(length(wait) > 0) wait else gconfig('wait')
            .Object@email <- if(length(email) > 0) email else gconfig('email')
            .Object@algorithm <- if(length(algorithm) > 0) algorithm else gconfig('algorithm') # will need to do this differently...
            
            .Object@UTILITY_URL <- gsub('process','utility', .Object@url)
            
            processInputs <- defaultProcessInputs(algorithm = .Object@algorithm[[1]], .Object@url, .Object@version)
            
            if(is.null(processInputs)) return(NULL)
            
            if (length(old.inputs) > 0 && old.algorithm[[1]] == algorithm[[1]]){
              which.replace <- unlist(unname(lapply(old.inputs, function(x) !is.null(x[[1]]) && !is.na(x[[1]])))) & names(old.inputs) %in% names(processInputs)
              which.to.rplc <- names(processInputs) %in% names(old.inputs[which.replace])
            } else {
              which.to.rplc <- which.replace <- FALSE
            }
            
            .Object@processInputs  <-	processInputs
            .Object@processInputs[which.to.rplc] <- old.inputs[which.replace]
            
            other.inputs <- list(...)
            if (any(paste0('.',names(other.inputs)) %in% pkg.env$private.funs))
              stop('read only variables in webprocess cannot be set', call. = FALSE)
            inputs(.Object) <- other.inputs
            
            return(.Object)
          })

#' create webprocess object
#'
#' @return the webprocess object
#' @author Jordan S Read
#' @rdname webprocess-methods
#' @export
setGeneric("webprocess", function(.Object, ...) {
  standardGeneric("webprocess")
})

#'@param .Object any object that can be coerced into \linkS4class{webprocess}
#'@param ... additional arguments passed initialize method (e.g., \code{url}, \code{version})
#'@aliases webprocess
#'@rdname webprocess-methods
setMethod("webprocess", signature('missing'), function(.Object, ...) {
  ## create new webprocess object
  webprocess <- try(new("webprocess",...), silent = TRUE)
  
  if(inherits(webprocess, "try-error")) {
    return(NULL)
  }
  return(webprocess)
})

#'@aliases webprocess
#'@rdname webprocess-methods
setMethod("webprocess", signature("character"), function(.Object=c("summary","unweighted summary","coverage summary","subset","coverage subset" ), ...) {
  ## create new webprocess object
  webprocess <- as(.Object, "webprocess")
  if (!missing(...)){
    webprocess <- initialize(webprocess, ...)
  }
  return(webprocess)
})

#'@aliases webprocess
#'@rdname webprocess-methods
setMethod("webprocess", signature("ANY"), function(.Object,...) {
  ## create new webprocess object
  webprocess <- as(.Object, "webprocess")
  if (!missing(...)){
    webprocess <- initialize(webprocess, ...)
  }
  return(webprocess)
})

getKnives <- function(){
  list('summary' =
         list(algorithm=
                list('Area Grid Statistics (weighted)' =
                       "gov.usgs.cida.gdp.wps.algorithm.FeatureWeightedGridStatisticsAlgorithm")),
       'unweighted summary' =
         list(algorithm=
                list('Area Grid Statistics (unweighted)' =
                       "gov.usgs.cida.gdp.wps.algorithm.FeatureGridStatisticsAlgorithm")),
       'coverage summary' = 
         list(algorithm=
                list('Categorical Coverage Fraction'=
                       "gov.usgs.cida.gdp.wps.algorithm.FeatureCategoricalGridCoverageAlgorithm")),
       'subset' = 
         list(algorithm=
                list('OPeNDAP Subset' =
                       "gov.usgs.cida.gdp.wps.algorithm.FeatureCoverageOPeNDAPIntersectionAlgorithm")))
}
setAs("character", "webprocess", function(from){
  ## create new webdata object with a character input (for dataset matching)
  knives <- getKnives()
                   
  from <- match.arg(arg = from, names(knives))
  
  .Object<- do.call(webprocess, args = knives[[from]])
  return(.Object)
})

setAs("geojob", "webprocess", function(from) {
  .Object <- webprocess(url = from@url, version = from@version)
  
  xmlDoc <- xml2::read_xml(xml(from))
  algorithm(.Object) <- algorithm(xmlDoc)
  inputs(.Object) <- inputs(xmlDoc)
  
  return(.Object)
})

context("shorthand webprocess()")


test_that("character to knife", {
  testthat::skip_on_cran()
  expect_is(webprocess('subset'), 'webprocess')
  expect_error(webprocess('not a knife'))
  
})

test_that("built in knifes are algorithms on prod", {
  testthat::skip_on_cran()
  web.knives <- unname(unlist(readRDS("data/test_webprocess_algorithms_prod.rds")))
  pkg.knives <- unlist(unname(lapply(geoknife:::getKnives(),function(x) x[[1]][[1]])))
  
  expect_true(all(pkg.knives %in% web.knives))
})

test_that('multi-args work with shorthand knife',{
  testthat::skip_on_cran()
  wp <- webprocess('subset', OUTPUT_TYPE='geotiff') # this makes two describe process requests!!! HUH?
  expect_is(wp, 'webprocess')
  expect_equal(inputs(wp)$OUTPUT_TYPE, 'geotiff')
  
})

#' start a geo-web processing request
#'
#'  start is a method for submitting a geo-web processing request.
#'
#' @param .Object a \linkS4class{geojob} object
#' @return A \linkS4class{geojob} object with an active GDP process request.
#'
#' @docType methods
#' @description Start process for \code{\link{geojob}}
#' @title Submit a GDP web processing request
#' @seealso \code{\link{check}}
#' @aliases start
#' @docType methods
#' @export
#' @rdname start-methods
#' @examples 
#' wd <- webdata('prism')
#' wg <- webgeom('state::New Hampshire')
#' wp <- webprocess()
#' gj <- geojob()
#' \dontrun{
#' xml(gj) <- XML(wg, wd, wp)
#' url(gj) <- url(wp)
#' gj <- start(gj)
#' }
setGeneric(name="start",def=function(.Object){standardGeneric("start")})

#'@rdname start-methods
#'@export
setMethod(f = "start",signature(.Object = "geojob"),definition = function(.Object){
	
  if (!canStart()){
    stop('Cannot start a new geojob until a previous one is completed or is error. ',
         'See "check(geojob)"', call.=FALSE)
  }
	requestXML <- xml(.Object)
	data <- genericExecute(url = url(.Object), requestXML)

	xmltext <- gcontent(data)
	response <- xml2::xml_root(xmltext)
	
	if(xml2::xml_name(response) == "ExceptionReport") {
	  cancel(.Object)
	  stop(cat(xml2::xml_text(response)))
	} else {
	  processID <- xml2::xml_attr(response,"statusLocation")
	}
	
	id(.Object)	<-	processID
  setJobState("ProcessStarted")
	return(.Object)
})

#' download output from geojob
#' 
#' download the result of a processing job to a local destination. 
#' 
#'@param .Object a \code{\link{geojob}} or job id that has completed 
#'@param destination a file destination. If missing, a temp directory will be used
#'@param ... additional arguments passed to \code{\link[httr]{write_disk}}, such as overwrite = TRUE
#'@return the location of the downloaded file
#'@author Jordan S Read
#'@rdname download
#'@importFrom httr write_disk progress
#'@export
setGeneric("download", function(.Object, destination, ...) {
  standardGeneric("download")
})

#'@rdname download
#'@aliases download
setMethod("download", signature("geojob",'missing'), function(.Object, destination, ...) {
  download(id(.Object), ...)
})

#'@rdname download
#'@aliases download
setMethod("download", signature("character",'missing'), function(.Object, destination, ...) {
  
  status <- check(.Object)
  if (is.null(status)) stop('geojob must be completed for download. See "check(geojob)"')
  
  filename <- strsplit(status$URL, '?id=')[[1]][2]
  destination = file.path(tempdir(), filename)
  
  download(.Object, destination, ...)
})

#'@rdname download
#'@aliases download
setMethod("download", signature("geojob",'character'), function(.Object, destination, ...) {
  download(id(.Object), destination, ...)
})

#'@rdname download
#'@aliases download
setMethod("download", signature("character",'character'), function(.Object, destination, ...) {
  
  status <- check(.Object)
  gGET(url=status$URL, write_disk(destination, ...))
  return(destination)
})

#' 
#' webdata class
#' 
#' a class for specifying details of web datasets (webdata!). These datasets have to be  
#' accessible through the OPeNDAP protocol. 
#' 
#' @slot times vector of POSIXct dates (specifying start and end time of processing)
#' @slot url URL of web data
#' @slot variables variable(s) used for processing from dataset
#' @rdname webdata-class
#' @import methods
setClass(
  Class = "webdata",
  prototype = prototype(
    times = as.POSIXct(c(NA,NA)),
    url = as.character(NA),
    variables = as.character(NA)),
  representation = representation(
    times = 'POSIXct',
    url = "character",
    variables = "character",
    dataList = "character",
    timeList = "character")
)


setMethod("initialize", signature = "webdata", 
          definition = function(.Object, times = .Object@times, url = .Object@url, variables = .Object@variables){
            .Object@times <- geotime(times)
            .Object@url <- url
            .Object@variables <- variables
            .Object@dataList <- 'gov.usgs.cida.gdp.wps.algorithm.discovery.ListOpendapGrids'
            .Object@timeList <- 'gov.usgs.cida.gdp.wps.algorithm.discovery.GetGridTimeRange'
            return(.Object)
          })

#' @title create webdata object
#' @description A class representing a web dataset.
#'
#' @slot times value of type \code{"POSIXct"}, start and stop dates for data
#' @slot url value of type \code{"character"}, the web location for the dataset
#' @slot variable value of type \code{"character"}, the variable(s) for data
#'
#' @return the webdata object representing a dataset and parameters
#' @author Jordan S Read
#' @rdname webdata-methods
#' @docType methods
#' @aliases 
#' webdata
#' @export
setGeneric("webdata", function(.Object,...) {
  standardGeneric("webdata")
})

#'@param .Object any object that can be coerced into \linkS4class{webdata} 
#'  (currently \code{character}, \code{webdata}, and \code{list})
#'@param ... additional arguments passed initialize method (e.g., times, or any other 
#'in the \linkS4class{webdata} object. 
#'@examples
#'webdata('prism')
#'webdata('prism', times=as.POSIXct(c('1990-01-01', '1995-01-01')))
#'webdata(list(times = as.POSIXct(c('1895-01-01 00:00:00','1899-01-01 00:00:00')),
#'  url = 'https://cida.usgs.gov/thredds/dodsC/prism',
#'  variables = 'ppt'))
#'@rdname webdata-methods
#'@aliases webdata
setMethod("webdata", signature("missing"), function(.Object,...) {
  ## create new webdata object
  webdata <- new("webdata",...)
  return(webdata)
})
#'@rdname webdata-methods
#'@aliases webdata
setMethod("webdata", signature("character"), function(.Object=c("prism",  "iclus",  "daymet", "gldas",  "nldas",  "topowx", "solar",  "metobs"),...) {
  ## create new webdata object
  webdata <- as(.Object, "webdata")
  if (!missing(...)){
    webdata <- initialize(webdata, ...)
  }
  return(webdata)
})

#' @rdname webdata-methods
#' @aliases webdata
setMethod("webdata", signature("geojob"), function(.Object, ...) {
  xmlVals <- inputs(xml2::read_xml(xml(.Object)))
  url <- xmlVals[["DATASET_URI"]]
  times <- c(start = xmlVals[["TIME_START"]], end = xmlVals[["TIME_END"]])
  if(is.null(times[['start']])) {times[['start']] <- NA}
  if(length(times) == 1) {times[['end']] <- NA}
  times <- c(times[['start']], times[['end']])#could get out of order with one missing
  times <- as.POSIXct(times, format = '%Y-%m-%dT%H:%M:%S')
  
  variables <- xmlVals[names(xmlVals) %in% c("OBSERVED_PROPERTY", "DATASET_ID")]
  webdata <- webdata(url = url, times = times, 
                        variables = unlist(variables), ...)
  return(webdata) 
})

#'@rdname webdata-methods
#'@aliases webdata
setMethod("webdata", signature("ANY"), function(.Object, ...) {
  ## create new webdata object
  webdata <- as(.Object, "webdata")
  if (!missing(...)){
    webdata <- initialize(webdata, ...)
  }
  return(webdata)
})

getPkgData <- function(){
  list('prism' = 
         list(times = as.POSIXct(c('1895-01-01 00:00:00','1899-01-01 00:00:00')),
              url = 'https://cida.usgs.gov/thredds/dodsC/prism_v2',
              variables = 'ppt'),
       'iclus' = 
         list(url = 'https://cida.usgs.gov/thredds/dodsC/iclus/hc',
              variables = 'housing_classes_iclus_a1_2010'),
       'daymet' = 
         list(times = as.POSIXct(c('2000-01-01 00:00:00','2001-01-01 00:00:00')),
              url = 'https://thredds.daac.ornl.gov/thredds-daymet/dodsC/daymet-v3-agg/na.ncml',
              variables = 'prcp'),
       'stageiv' = 
         list(times = as.POSIXct(c('2010-01-01 00:00:00','2010-01-05 00:00:00')),
              url = 'dods://cida.usgs.gov/thredds/dodsC/stageiv_combined',
              variables = "Total_precipitation_surface_1_Hour_Accumulation"),
       'topowx' = 
         list(times = as.POSIXct(c('2010-01-01 00:00:00','2010-02-01 00:00:00')),
              url = 'https://cida.usgs.gov/thredds/dodsC/topowx',
              variables = 'tmax'),
       'solar' = 
         list(times = as.POSIXct(c('1980-01-01 00:00:00','1980-12-01 00:00:00')),
              url = 'https://cida.usgs.gov/thredds/dodsC/mows/sr',
              variables = 'sr'),
       'metobs' = 
         list(times = as.POSIXct(c('2010-01-01 00:00:00','2010-01-02 00:00:00')),
              url = 'https://cida.usgs.gov/thredds/dodsC/new_gmo',
              variables = 'tas'))
}

setAs("character", "webdata", function(from){
  ## create new webdata object with a character input (for dataset matching)
  
  datasets <- getPkgData()
  
  from <- match.arg(arg = from, names(datasets))
  
  .Object<- do.call(webdata, args = datasets[[from]])
  return(.Object)
})

setAs('list', 'webdata', function(from){
  
  .Object <- do.call(what = "webdata", args = from)
  return(.Object)
})

context("Test create webdata object")
test_that("creation of webdata object", {
  testthat::skip_on_cran()
  expect_is(webdata(), "webdata")
  expect_is(webdata('prism'), "webdata")
  wd <- webdata('prism',times = as.POSIXct(c('2001-01-01','2002-02-05')))
  expect_is(wd, "webdata")
  times(wd)[1] <- as.POSIXct('2000-01-01')
  expect_is(wd, "webdata")
})

test_that("create webdata from geojob", {
  xml <- system.file("extdata/state_webgeom_post.xml", 
                               package = "geoknife")
  geojob <- geojob(xml=xml)
  wd <- webdata(geojob)
  expect_equal(length(times(wd)), 2)
  expect_is(url(wd), "character")
  expect_is(variables(wd), "character")
  expect_gt(length(variables(wd)), 0)
  
  #test XML missing time slots
  testthat::skip_on_cran()
  noTimesJob <- geojob("data/test_notimesjob.xml")
  wd <- webdata(noTimesJob)
  expect_equal(length(times(wd)), 2)
  expect_is(times(wd), "POSIXct")
  
  #make sure times aren't dropped
  wd <- webdata(geojob(xml = "data/test_keeptimes.xml"))
  n <- nchar(as.character(times(wd)))
  expect_true(all(n > 10))
})

context("Test getting fields of webdata object")
test_that("getters work", {
  testthat::skip_on_cran()
  wd <- webdata('prism',times = as.POSIXct(c('2001-01-01','2002-02-05')))
  expect_is(times(wd), "POSIXct")
  expect_is(url(wd), "character")
})

context("Test setting fields of webdata object")
test_that("setters work", {
  testthat::skip_on_cran()
  wd <- webdata('prism',times = as.POSIXct(c('2001-01-01','2002-02-05')))
  times(wd)[1] <- as.POSIXct('2000-01-01')
  expect_equal(as.numeric(times(wd)[1]-as.POSIXct('2000-01-01')), 0)
  url(wd) <- 'www.badurlppppp.com'
  expect_is(url(wd), "character")
})

context("query for variables")

test_that("can't query for variables w/o a url", {
  testthat::skip_on_cran()
  expect_error(query(webdata(), 'variables'), 'url cannot be NA for fabric argument when querying for available variables')
})

context("query for times")

test_that("can't query for times w/o a variable", {
  testthat::skip_on_cran()
  wd <- readRDS("data/test_webdata_fabric.rds")
  variables(wd) <- NA
  expect_error(query(wd, 'times'), "variables cannot be NA for fabric argument when querying for available time range")
})

test_that("query for times warns w/ multiple variables", {
  testthat::skip_on_cran()
  wd <- readRDS("data/test_webdata_fabric.rds")
  variables(wd) <- query(wd, 'variables')
  expect_true(length(variables(wd)) > 1) # make sure this is actually being tested
  expect_warning(query(wd, 'times'), 'variables is > 1, using ')
})

test_that("query works for times with base dataset", {
  testthat::skip_on_cran()
  wd <- readRDS("data/test_webdata_fabric.rds")
  times.out <- query(wd, 'times')
  expect_is(times.out, "POSIXct")
  expect_false(any(is.na(times.out)))
})

test_that("bad url query returns NAs", {
  testthat::skip_on_cran()
  wd <- webdata('prism', url='https://cida.usgs.gov/')
  suppressWarnings(times.out <- query(wd, 'times'))
  expect_true(all(is.na(times.out)))
})

context("using query for webdata")


test_that("webdata query returns a datagroup", {
  testthat::skip_on_cran()
  datasets <<- query('webdata')
  expect_is(datasets, 'datagroup')
})

test_that("webdata query returns a list", {
  testthat::skip_on_cran()
  wd <- webdata(datasets[4])
  expect_is(query(wd,'variables'), 'character')
})

test_that("webdata title returns a title", {
  testthat::skip_on_cran()
  expect_is(title(datasets[4]), 'character')
})

test_that("webdata url returns a url", {
  testthat::skip_on_cran()
  expect_is(url(datasets[4]), 'character')
  expect_is(url(datasets[4:5]), 'character')
})


test_that("webdata abstract returns an abstract", {
  testthat::skip_on_cran()
  expect_is(url(datasets[4]), 'character')
})

context("show object methods")

test_that("show webdata", {
  expect_output(show(readRDS("data/test_webdata_fabric.rds")))
})

test_that("show webgeom", {
  expect_output(show(readRDS("data/test_webgeom_WI.rds")))
})

test_that("show simplegeom", {
  expect_output(show(readRDS("data/test_simplegeom_two_points.rds")))
  expect_error(simplegeom(c(-88.6, 45.2,99)))
})

test_that("show datagroup", {
  testthat::skip_on_cran()
  expect_output(show(readRDS("data/test_query_webdata.rds")))
})

test_that("show geojob", {
  expect_output(show(readRDS("data/test_email_gj.rds")))
})

test_that("show webprocess", {
  testthat::skip_on_cran()
  expect_output(show(readRDS("data/test_webprocess_knife.rds")))
})

---
title: "geoknife package"
author: "Jordan Read"
date: "`r format(Sys.time(), '%d %B, %Y')`"
output: 
  rmarkdown::html_vignette:
    toc: true
    fig_width: 7
    fig_height: 6
vignette: >
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteIndexEntry{geoknife package guide}
  \usepackage[utf8]{inputenc}
---


```{r setup, include=FALSE}
library(rmarkdown)
options(continue=" ")
options(width=60)
library(knitr)
library(geoknife)
query <- geoknife::query
`values<-` <- geoknife::`values<-`
id <- geoknife::id

```


##Introduction

The **geoknife** package was created to support web-based geoprocessing of large gridded datasets according to their overlap with landscape (or aquatic/ocean) features that are often irregularly shaped. geoknife creates data access and subsequent geoprocessing requests for the USGS's Geo Data Portal to carry out on a web server. The results of these requests are available for download after the processes have been completed. This type of workflow has three main advantages: 1) it allows the user to avoid downloading large datasets, 2) it avoids reinventing the wheel for the creation and optimization of complex geoprocessing algorithms, and 3) computing resources are dedicated elsewhere, so geoknife operations do not have much of an impact on a local computer.

Because communication with web resources are central to geoknife operations, users must have an active internet connection. geoknife interacts with a remote server to discover processing capabilities, find already available geospatial areas of interest (these are normally user-uploaded shapefiles), get gridded dataset characteristics, execute geoprocessing requests, and get geoprocessing results. 

The main elements of setting up and carrying out a geoknife 'job' (a `geojob` object) include defining the feature of interest 'stencil' (a `webgeom` or `simplegeom` object), the gridded web dataset 'fabric' to be processed (a webdata object), and the the processing algorithm 'knife' parameters (a `webprocess` object). The status of the geojob can be checked with `check`, and output can be loaded into a data.frame with `results`. See below for more details.

##Installation
To install the stable version of **geoknife** package with dependencies:
```{r, eval=FALSE}
install.packages("geoknife", 
    repos = c("https://cran.rstudio.com/"),
    dependencies = TRUE)
```
Or to install the current development version of the package:
```{r, eval=FALSE}
install.packages("devtools")
devtools::install_github('DOI-USGS/geoknife')
```

## getting started
The `geoknife` package was created to support web-based geoprocessing of large gridded datasets according to their overlap with landscape (or aquatic/ocean) features that are often irregularly shaped. geoknife creates data access and subsequent geoprocessing requests for the USGS's Geo Data Portal to carry out on a web server. 

### geoknife concepts
geoknife has abstractions for web-available gridded data, geospatial features, and geoprocessing details. These abstractions are the basic geoknife arguments of `fabric`, `stencil` and `knife`.  
* `fabric` defines the web data that will be accessed, subset, and processed (see [the fabric section](#gridded-data-fabric) for more details). These data are limited to gridded datasets that are web-accessible through the definitions presented in [the OPeNDAP section](#opendap). Metadata for `fabric` include time, the URL for the data, and variables.  
* `stencil` is the geospatial feature (or set of features) that will be used to delineate specific regions of interest on the fabric (see [the stencil section](#spatial-features-stencil) for more details). `stencil` can include point or polygon groupings of various forms (including classes from the sp R package).  
* `knife` defines the way the analysis will be performed, including the algorithm and version used, the URL that receives the processing request, the statistics returned, and the format of the results (see [the knife section](#web-processing-details-knife) for more details).  
* The `geoknife()` function takes the `fabric`, `stencil`, and `knife`, and returns a `geojob`, which is a live geoprocessing request that will be carried out on a remote web server (see [the geojob section](#geojob-details) for more details). The `geojob` can be checked by users, and results can be parsed and loaded into the R environment for analyses. 

### remote processing basics
Because `geoknife` executes geospatial computations on a remote webserver, the workflow for to execute geoprocessing operations may feel a bit foreign to users who usually performing their analyses on a local computer. To find available datasets and their details (variables, time range, etc.), `geoknife` must query remote servers because data for use with `geoknife` is typically hosted on open access servers near the processing service. These operations are covered in detail below, but this section is designed to provide a quick overview. 

Interactions with web resources may take on the following forms, and each involve separate requests to various webservers:

(@) Using the `query` function to figure out what data exist for `fabric`. This function will request data from a CSW (catalog service for the web) resource and return results, or, if a dataset is already specified, it can be used to query for the variables or time dimension.
(@) Using the `query` function to use a web resource for the geometry of `stencil`, including a US State, Level III Ecoregion, and many others. 
(@) Submitting a `geojob` to be processed externally
(@) Checking the status of a `geojob`
(@) Loading the results from a successful `geojob`

### quick start guide
There are various ways to get up and running quickly with `geoknife`. See sections below for additional details on any of the following operations. As mentioned above, `geoknife` has the basic arguments of `fabric`, `stencil` and `knife`. `knife` is an optional argument, and if not used, a default `knife` will be used to specify the processing details. 

#### define a stencil that represents the geographic region to slice out of the data
There are many different ways to specify geometry (`stencil`) for `geoknife`. The two basic functions that support building `stencil` objects are `simplegeom` and `webdata`:

```{r}
library(geoknife)
```
Use a single longitude latitude pair as the geometry with the `simplegeom` function:
```{r}
stencil <- simplegeom(c(-89, 46.23))
```
Or specify a collection of named points in a `data.frame` (note that naming is important for multi-features because it specifies how the results are filtered):
```{r}
stencil <- simplegeom(data.frame(
              'point1' = c(-89, 46), 
              'point2' = c(-88.6, 45.2)))
```

Use a web-available geometry dataset with the `webgeom` function to specify state boundaries:
```{r, eval=FALSE}
stencil <- webgeom('state::New Hampshire')
stencil <- webgeom('state::New Hampshire,Wisconsin,Alabama')
```
or HUC8s (hydrologic unit code):
```{r, eval=FALSE}
stencil <- webgeom('HUC8::09020306,14060009')
```
```{r, echo=FALSE}
load(system.file('extdata', 'HUC8_stencil.RData', package = 'geoknife'))
```
display stencil:
```{r}
stencil
```
see what other HUCs could be used via the `query` function:
```{r, eval=FALSE}
HUCs <- query(stencil, 'values')
```
```{r, echo=FALSE}
load(system.file('extdata', 'HUC8_query.RData', package = 'geoknife'))
```
there are thousands of results, but `head()` will only display a few of them
```{r}
head(HUCs) 
```

#### define a fabric that represents the underlying data
The Geo Data Portal's web data catalog is quite extensive, and includes many datasets that can all be processed with `geoknife`. Check it out at labs.waterdata.usgs.gov/gdp_web. This is not a complete list of all relevant datasets that can be accessed and processed. The `geoknife` package has a number of quick access datasets build in (similar to quick start `webgeom` objects). 

An example of a quick start dataset:
```{r}
fabric <- webdata('prism')
fabric
```
which can be a starting point for the PRISM dataset, as the fields can be modified:
```{r}
times(fabric) <- c('2002-01-01','2010-01-01')
variables(fabric) <- c('tmx')
fabric
```


#### create the processing job that will carry out the subsetting/summarization task

```{r, eval=FALSE}
job <- geoknife(stencil, fabric)
```

use convienence functions to check on the job:
```{r, eval=FALSE}
check(job)
running(job)
error(job)
successful(job)
```

Cancel a running job:
```{r, eval=FALSE}
job <- cancel(job)
```

Run the job again, but have R wait until the process is finished:
```{r, eval=FALSE}
job <- geoknife(stencil, fabric, wait = TRUE)
```

Load up the output and plot it
```{r, fig.height=3.5, fig.width=7, eval=FALSE}
data <- result(job)
plot(data[,1:2], ylab = variables(fabric))
```
```{r, fig.height=3.5, fig.width=7, echo=FALSE}
load(system.file('extdata', 'prism_job.RData', package = 'geoknife'))
plot(data[,1:2], ylab = variables(fabric))
```

For long running processes, it often makes sense to use an email listener:
```{r, eval=FALSE}
job <- geoknife(webgeom('state::Wisconsin'), fabric = 'prism', email = 'fake.email@gmail.com')
```

## spatial features (`stencil`)
The `stencil` concept in `geoknife` represents the area(s) of interest for geoprocessing. `stencil` can be represented by two classes in `geoknife`: `simplegeom` and `webdata`. Any other classes can also be used that can be coerced into either of these two classes (such as `data.frame`). 

### `simplegeom` object
The `simplegeom` class is designed to hold spatial information from the R environment and make it available to the processing engine. `simplegeom` is effectively a wrapper for the `sp` package's `SpatialPolygons` class, but also coerces a number of different other types into this class. For example:  

Points can be specified as longitude latitude pairs:
```{r}
stencil <- simplegeom(c(-89, 45.43))
```
or as a data.frame:
```{r}
stencil <- simplegeom(data.frame(
              'point1' = c(-89, 46), 
              'point2' = c(-88.6, 45.2)))
```
Also, a `SpatialPolygons` object can be used as well (example from `sp` package): 
```{r}
library(sp)
Sr1 = Polygon(cbind(c(2,4,4,1,2),c(2,3,5,4,2)))
Sr2 = Polygon(cbind(c(5,4,2,5),c(2,3,2,2)))
Sr3 = Polygon(cbind(c(4,4,5,10,4),c(5,3,2,5,5)))
Sr4 = Polygon(cbind(c(5,6,6,5,5),c(4,4,3,3,4)), hole = TRUE)

Srs1 = Polygons(list(Sr1), "s1")
Srs2 = Polygons(list(Sr2), "s2")
Srs3 = Polygons(list(Sr3, Sr4), "s3/4")
stencil <- simplegeom(Srl = list(Srs1,Srs2,Srs3), proj4string = CRS("+proj=longlat +datum=WGS84"))
```

### `webgeom` object
The `webgeom` class is designed to hold references to web feature service (WFS) details and make it available to the processing engine.  

Similar to `webdata` (see below), the `webgeom` class has public fields that can be set and accessed using simple methods. Public fields in `webgeom`:  

 * `url`: the WFS endpoint to use for the data
 * `geom`: the feature collection name (can be namespaced shapefile names)
 * `attribute`: the attribute of the feature collection to be use 
 * `values`: the values of the chosen attribute to use (or `NA` for all)
 * `version`: the WFS version to use. 

To create a default `webgeom` object:
```{r}
stencil <- webgeom()
```
The user-level information in webgeom is all available with the webgeom "show" method (or print). 
```{r}
stencil
```
The public fields can be accessed in by using the field name:
```{r, eval=FALSE}
geom(stencil) <- "sample:CONUS_states"
attribute(stencil) <- "STATE"
values(stencil) <- c("Wisconsin","Maine")
```

### quick access to web available data for webgeoms
There are some built in `webgeom` templates that can be used to figure out the pattern, or to use these datasets for analysis. Currently, the package only supports US States, Level III Ecoregions, or HUC8s:
```{r, eval=FALSE}
stencil <- webgeom('state::Wisconsin')
webgeom('state::Wisconsin,Maine')
webgeom('HUC8::09020306,14060009')
webgeom('ecoregion::Colorado Plateaus,Driftless Area')
```

### query function for `webgeom`
The `query` function on `webgeom` can be used to find possible inputs for each public field (other than `version` and `url` currently):
```{r, eval=FALSE}
query(stencil, 'geoms')
```
```
##  [1] "sample:Alaska"                  
##  [2] "upload:CIDA_TEST_"              
##  [3] "sample:CONUS_Climate_Divisions" 
##  [4] "sample:CONUS_states"        
##  [5] "sample:CONUS_states"            
##  [6] "sample:CSC_Boundaries"          
##  [7] "sample:Landscape_Conservation_Cooperatives"             
##  [8] "sample:FWS_LCC"                 
##  [9] "sample:simplified_huc8"     
## [10] "sample:Ecoregions_Level_III"
## [12] "sample:Counties"         
## [13] "sample:nps_boundary_2013"       
## [14] "upload:nrhu_selection"          
## [15] "upload:nrhu_selection_Gallatin" 
## [16] "sample:simplified_HUC8s"        
## [17] "draw:test"
```
```{r, eval=FALSE}
query(stencil, 'attributes')
```
```
## [1] "STATE"
```


## gridded data (`fabric`)
The `fabric` concept in `geoknife` represents the gridded dataset that will be operated on by the tool. `fabric` can be a time-varying dataset (such as PRISM) or a spatial snapshot coverage dataset (such as the NLCD). At present, `fabric` is limited to datasets that can be accessed using the OPeNDAP protocol or WMS (web map service). Most helper functions in geoknife, including `query(fabric,'variables')` tend to work better for OPeNDAP datasets. 

### `webdata` object
The `webdata` class holds all the important information for webdatasets in order to make them available for processing by geoknife's outsourced geoprocessing engine, the Geo Data Portal. Public fields in `webdata`:

 * `times`: a POSIXct vector of length 2. This specifies the start and end time of the process request. If `times()[1]` is `NA`, the start time will be the beginning of the dataset. If `times()[2]` is `NA` the end time will be the end of the dataset. `times` must be `as.POSIXct(c(NA,NC))` for datasets without a time dimension. 
 * `url`: a character for the location of a web available dataset. This URL will be queried for data access and used for the processing task.
 * `variables`: a character vector for the variables of the dataset to use. Must be valid variables that exist within the dataset specified with `url`.

To create a default `webdata` object:
```{r}
fabric <- webdata()
```
The user-level information in webdata is all available with the webdata "show" method (or print). 
```{r}
fabric
```
The public fields can be accessed in by using the field name:
```{r}
times(fabric)
url(fabric) <- 'https://cida.usgs.gov/thredds/dodsC/prism'
variables(fabric) <- 'tmx'

times(fabric)[1] <- as.POSIXct('1990-01-01')
```

### find data that is indexed by the Geo Data Portal catalog
The `fabric` is specified using the `webdata` function. `geoknife` can access a catalog of webdata by using the `query` function:
```{r, eval=FALSE}
webdatasets = query('webdata')
length(webdatasets)
```
```{r, echo=FALSE}
load(system.file('extdata', 'webdata_query.RData', package = 'geoknife'))
length(webdatasets)
```
Interrogating datasets can be done by printing the returned dataset list, which displays the title and the url of each dataset by default (this example truncates the `r length(webdatasets)` datasets to display 5):
```{r}
webdatasets[61:65]
```

Finding additional information about a particular dataset is supported by `title()` and `abstract()`, which return the dataset titles and abstracts respectively:
```{r}
title(webdatasets[87])
abstract(webdatasets[87])
```

indexing datasets based on order or title are equivalent  
```{r}
fabric <- webdata(webdatasets[99])
evapotran <- webdata(webdatasets['Monthly Conterminous U.S. actual evapotranspiration data'])
```

To modify the times in `fabric`, use `times()`:
```{r}
times(fabric) <- c('1990-01-01','2005-01-01')
```
Similar to `webgeom`, the query method can be used on `webdata` objects:
```{r, eval=FALSE}
query(fabric, 'times')
query(fabric, 'variables')
```

### find data that is *not* indexed by the Geo Data Portal catalog
There are hundreds (or potentially thousands) of additional OPeNDAP datasets that will work with geoknife, but need to be found through web searches or catalogs (e.g., www.esrl.noaa.gov/psd/thredds/dodsC/Datasets, apdrc.soest.hawaii.edu/data/data.php). One such example is Sea Surface Temperature from the Advanced Very High Resolution Radiometer (AVHRR) temperature sensing system. Specifying datasets such as this requires finding out the OPeNDAP endpoint (URL) for the dataset, and specifying it as the `url` to webdata (we found this example in the extensive apdrc.soest.hawaii.edu/data/data.php catalog):
```{r}
fabric = webdata(url='dods://apdrc.soest.hawaii.edu/dods/public_data/satellite_product/AVHRR/avhrr_mon')
```
`query` for `variables` doesn't work for this dataset, because it actually doesn't have units and therefore "valid" variables are not returned (instead you get an empty list). From the OPeNDAP endpoint, it is clear that this dataset has one variable of interest, which is called 'sst':
```{r, eval=FALSE}
variables(fabric) <- 'sst'
query(fabric, 'times')
```
```
[1] "1985-01-01 UTC" "2003-05-01 UTC"
```
```{r}
times(fabric) <- c('1990-01-01','1999-12-31')
```

plotting the July surface temperature of a spot on the Caspian Sea is done by:
```{r, eval=FALSE}
sst = result(geoknife(data.frame('caspian.sea'=c(51,40)), fabric, wait = TRUE))
head(sst)
july.idx <- months(sst$DateTime) == 'July'
plot(sst$DateTime[july.idx], sst$caspian.sea[july.idx], type='l', lwd=2, col='dodgerblue', ylab='Sea Surface Temperature (degC)',xlab=NA)
```
```{r, echo=FALSE, fig.height=4, fig.width=6}
load(system.file('extdata', 'sst_result.RData', package = 'geoknife'))
head(sst)
july.idx <- months(sst$DateTime) == 'July'
plot(sst$DateTime[july.idx], sst$caspian.sea[july.idx], type='l', lwd=2, col='dodgerblue', ylab='Sea Surface Temperature (degC)',xlab=NA)
```

### query function for `webdata`
The `query` function works on `webdata`, similar to how it works for `webgeom` objects. For the PRISM dataset specified above, the time range of the dataset can come from `query` with `times`:
```{r, eval=FALSE}
fabric = webdata('prism')
variables(fabric) <- 'ppt'
query(fabric, 'times')
```
```
## [1] "1895-01-01 UTC" "2013-02-01 UTC"
```
likewise, variables with `variables`:
```{r, eval=FALSE}
query(fabric, 'variables')
```
Note that a variable has to be specified to use the `times` query:
```{r}
variables(fabric) <- NA
```
```
## [1] "ppt" "tmx" "tmn"
```
This will fail:
```{r,eval=FALSE}
query(fabric, 'times')
```
```
 Error in times_query(fabric, knife) : 
  variables cannot be NA for fabric argument 
```
At present, the `geoknife` package does not have a query method for dataset urls.

## `knife` object
The `webprocess` class holds all the important information for geoknife processing details for the outsourced geoprocessing engine, the Geo Data Portal. Public fields in `webprocess`:

 * `url`: a character for the location of the web processing service to be used.
 * `algorithm`: a list specifying the algorithm to be used for processing. Defaults to `r names(algorithm(webprocess()))`.
 * `version`: a character specifying the version of the web processing service to be used. Defaults to `r version(webprocess())`.
 * `processInputs`: a list of processing details for the specified `algorithm`. These details vary depending on `algorithm` and are this field is automatically reset when the `algorithm` field is set. 
 * `wait`: a boolean that specifies whether to have R wait until the process is finished. Defaults to `FALSE`
 * `email`: a character that species an email address to send the finished process result to. 
 
### query function for `webprocess`
The `query` function works on `webprocess`, similar to how it works for `webgeom` and `webdata` objects. For a default `webprocess` object, the available algorithms can be queried by:
```{r, eval=FALSE}
knife <- webprocess()
query(knife, 'algorithms')
```
```
## $`Categorical Coverage Fraction`
## [1] "gov.usgs.cida.gdp.wps.algorithm.FeatureCategoricalGridCoverageAlgorithm"
## 
## $`OPeNDAP Subset`
## [1] "gov.usgs.cida.gdp.wps.algorithm.FeatureCoverageOPeNDAPIntersectionAlgorithm"
## 
## $`Area Grid Statistics (unweighted)`
## [1] "gov.usgs.cida.gdp.wps.algorithm.FeatureGridStatisticsAlgorithm"
## 
## $`Area Grid Statistics (weighted)`
## [1] "gov.usgs.cida.gdp.wps.algorithm.FeatureWeightedGridStatisticsAlgorithm"
```
Changing the `webprocess` url will modify the endpoint for the query, and different algorithms may be available:
```{r,eval=FALSE}
url(knife) <- 'https://labs.waterdata.usgs.gov/gdp-process-wps/WebProcessingService'
query(knife, 'algorithms')
```
```
## $`Categorical Coverage Fraction`
## [1] "gov.usgs.cida.gdp.wps.algorithm.FeatureCategoricalGridCoverageAlgorithm"
## 
## $`OPeNDAP Subset`
## [1] "gov.usgs.cida.gdp.wps.algorithm.FeatureCoverageOPeNDAPIntersectionAlgorithm"
## 
## $`Area Grid Statistics (unweighted)`
## [1] "gov.usgs.cida.gdp.wps.algorithm.FeatureGridStatisticsAlgorithm"
## 
## $`Area Grid Statistics (weighted)`
## [1] "gov.usgs.cida.gdp.wps.algorithm.FeatureWeightedGridStatisticsAlgorithm"
```

### algorithm
As noted above, the `algorithm` field in `webprocess` is a list, specifying the algorithm name and relative path to the algorithm endpoint. To access or change the algorithm:
```{r, eval=FALSE}
knife <- webprocess()
algorithm(knife) <- query(knife, 'algorithms')[1]
# -- or --
algorithm(knife) <- list('Area Grid Statistics (weighted)' = 
                           "gov.usgs.cida.gdp.wps.algorithm.FeatureWeightedGridStatisticsAlgorithm")
```
### inputs
getting and setting `processInputs` for `geoknife` is currently in. Check back later.

### url
The `url` field in `webprocess` can be accessed and set as expected:
```{r, eval=FALSE}
url(knife) <- 'https://labs.waterdata.usgs.gov/gdp-process-wps/WebProcessingService'
```

### `wait`
The `wait` boolean in `webprocess` can set during creation:
```{r, eval=FALSE}
knife <- webprocess(wait = TRUE)
knife
```
```
## An object of class "webprocess":
## url: https://labs.waterdata.usgs.gov/gdp-process-wps/WebProcessingService 
## algorithm: Area Grid Statistics (weighted) 
## web processing service version: 1.0.0 
## process inputs: 
##    SUMMARIZE_FEATURE_ATTRIBUTE: false
##    SUMMARIZE_TIMESTEP: false
##    REQUIRE_FULL_COVERAGE: true
##    DELIMITER: COMMA
##    STATISTICS: 
##    GROUP_BY: 
## wait: TRUE 
## email: NA
```

### `email`
The `email` field in `webprocess` can be accessed and set as expected:
```{r, eval=FALSE}
knife <- webprocess(email = 'fake.email@gmail.com')
knife
```
```
## An object of class "webprocess":
## url: https://labs.waterdata.usgs.gov/gdp-process-wps/WebProcessingService 
## algorithm: Area Grid Statistics (weighted) 
## web processing service version: 1.0.0 
## process inputs: 
##    SUMMARIZE_FEATURE_ATTRIBUTE: false
##    SUMMARIZE_TIMESTEP: false
##    REQUIRE_FULL_COVERAGE: true
##    DELIMITER: COMMA
##    STATISTICS: 
##    GROUP_BY: 
## wait: FALSE 
## email: fake.email@gmail.com
```

## `geojob` details
The `geojob` in the `geoknife` package contains all of the processing configuration details required to execute a processing request to the Geo Data Portal and check up on the state of that request. A `geojob` object is created using the high-level function `geoknife()` with the `stencil`, `fabric` and optional `knife` arguments as described above.

### `geojob` class and details
The `geojob` public fields include:  
 
 * `url`: the url where the processing job was sent to. Is defined by the `url` field of the `knife` argument used to create the job
 * `xml`: the XML used in the POST to the web geoprocessing service. This XML includes configurations set up by the `fabric`, `stencil`, and `knife` arguments.
 * `id`: the url of the process that is currently running, or `r id(geojob())` for no job.
 
### `check` and related functions
The status of a `geojob` can be checked with the `check` function:
```{r, eval=FALSE}
job <- geoknife(stencil, fabric = 'prism', wait = FALSE)
check(job)
```
```
## $status
## [1] "Process Started"
## 
## $URL
## NULL
## 
## $statusType
## [1] "ProcessStarted"
```

use other convenience functions related to `check` to return boolean (`TRUE` or `FALSE`) responses
```{r, eval=FALSE}
running(job)
error(job)
successful(job)
```

### `cancel` geojob
The `geoknife` package currently limits the user processing requests to single-running processes, so as to avoid creating thousands of requests in error, which could overwhelm the processing resources. If there is a reason to support additional jobs at one time, please email the package maintainers with your query.  

To cancel and existing job:
Cancel a running job but retain the details:
```{r, eval=FALSE}
id(job)
```
```
## [1] "https://https://labs.waterdata.usgs.gov/gdp-process-wps/RetrieveResultServlet?id=a264a88c-9672-4029-915b-a09b1403d26a"
```
```{r, echo=FALSE}
job <- geojob()
```
```{r}
job <- cancel(job)
id(job)
```

To cancel any running job without specifying the `geojob` reference:
```{r}
cancel()
```

## geoknife web resources
geoknife outsources all major geospatial processing tasks to a remote server. Because of this, users must have an active internet connection. Problems with connections to datasets or the processing resources are rare, but they do happen. When experiencing a connectivity problem, the best approach is often to try again later or email gdp@usgs.gov with any questions. The various web dependencies are described below. 

### Geo Data Portal
The U.S. Geological Survey's "Geo Data Portal" (GDP) provides the data access and processing services that are leveraged by the `geoknife` package. See [labs.waterdata.usgs.gov/gdp_web](https://labs.waterdata.usgs.gov/gdp_web) for the GDP user interface.  

---
title: "subset gridded data as geotiff and plot"
author: "Jordan Read, Alison Appling, David Blodgett"
date: "`r format(Sys.time(), '%d %B, %Y')`"
output: 
  rmarkdown::html_vignette:
    toc: true
    fig_width: 7
    fig_height: 6
vignette: >
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteIndexEntry{geoknife plot geotiff}
  \usepackage[utf8]{inputenc}
---


```{r setup, include=FALSE}
library(rmarkdown)
options(continue=" ")
options(width=60)
library(knitr)
library(geoknife)
knitr::opts_chunk$set(eval=FALSE)
```

*Service is no longer working. This vignette will not be built.*

`geoknife` has a number of output formats, but a new one that was added in version 1.1.0 of the package (after the initial release to CRAN) is the ability to output results as a zip file that contains a series of geotiffs for each timestep requested. This vignette is a brief introduction on how to do this using a few additional packages that are in the `Suggests` field in the description. 

## get the data
see the `geoknife` getting started vignette for more details, but for the purposes of this vignette, we need to get some data first and then plot it up.  
First things first, load up the `geoknife` package
```{r, warning=FALSE, message=FALSE}
library(geoknife)
```
For this example, I am going to use a dataset that is hosted by the USGS, and includes an estimate of actual evapotranspiration. There is a lot of data here, but I am just going to pluck a subset in time (one timepoint for the month of July of one year) and a fairly large spatial subset. I am going to use the `OUTPUT_TYPE='geotiff'` argument that was added in version 1.1.0 of `geoknife`.

```{r, warning=FALSE, message=FALSE}
knife <- webprocess(algorithm = list('OPeNDAP Subset' = "gov.usgs.cida.gdp.wps.algorithm.FeatureCoverageOPeNDAPIntersectionAlgorithm"))

fabric <- webdata(url='https://cida.usgs.gov/thredds/dodsC/ssebopeta/monthly', 
                  variable="et", #Monthly evapotranspiration
                  times=c('2014-07-15','2014-07-15'))

stencil <- simplegeom(data.frame('point1' = c(-76,49), 'point2' = c(-93,40)))
job <- geoknife(stencil, fabric, knife, wait = TRUE, OUTPUT_TYPE = "geotiff")
```
now that the job is complete (because `wait=TRUE` was used), we can download the result and unzip it:
```{r, warning=FALSE, message=FALSE}
dest <- file.path(tempdir(), 'et_data.zip')

file <- download(job, destination = dest, overwrite = TRUE)

unzip(file, exdir=file.path(tempdir(),'et'))

tiff.dir <- file.path(tempdir(),'et')
```

## plot the data
using the `rasterVis` package, read this in and create a raster object:
```{r, warning=FALSE, message=FALSE}
library(rasterVis)
library(raster)

et <- raster(file.path(tiff.dir , dir(tiff.dir)))
NAvalue(et) <- -1
```
Now, use `ggplot2` and `ggmap` to plot this as a map:
```{r, warning=FALSE, message=FALSE}
library(ggmap)
library(ggplot2)

gplot(et, maxpixels = 5e5) + 
  geom_tile(aes(fill = value), alpha=1) +
  scale_fill_gradientn("Actual ET (mm)", colours=rev(heat.colors(5))) +
  coord_equal() + 
  theme_classic() + 
  theme(axis.line = element_blank(), axis.text.x = element_blank(), axis.text.y = element_blank(),
        axis.ticks = element_blank(), axis.title.x = element_blank(), axis.title.y = element_blank()) +
  scale_y_continuous(limits=c(et@extent@ymin, et@extent@ymax)) + 
  scale_x_continuous(limits=c(et@extent@xmin, et@extent@xmax))
```

---
title: "Using `geoknife` with a custom webgeom and/or webdata"
author: "David Blodgett"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Using `geoknife` with a custom webgeom and/or webdata}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---
```{r init, echo=FALSE, include=FALSE}
library(geoknife)
knitr::opts_chunk$set(eval=FALSE)
```

*Sciencebase WFS is offline at this time and this vignette will not be built.*

This vignette shows how to use a custom Web Feature Service with `geoknife`. In this case, we are using a WFS from [ScienceBase](https://www.sciencebase.gov/catalog/item/5b68e7e3e4b006a11f75c06a). The url used for the WFS can be found in the "Spatial Services" section of the sciencebase item. If the WFS url you have has parameters included, remove them when passing them to `geoknife`.  
e.g. this: `https://www.sciencebase.gov/catalogMaps/mapping/ows/5b68e7e3e4b006a11f75c06a`  
not this: `https://www.sciencebase.gov/catalogMaps/mapping/ows/5b68e7e3e4b006a11f75c06a?service=wfs&request=getcapabilities&version=1.0.0`

For advanced users, it may be interesting to see what `geoknife` is doing behind the scences. Switch `verbose=FALSE` to `verbose=TRUE` to see the web service request being made when you execute this vignette.

```{r stencil, echo=T}
gconfig(verbose=FALSE)
stencil <- webgeom(url="https://www.sciencebase.gov/catalogMaps/mapping/ows/5b68e7e3e4b006a11f75c06a")

stencil_geoms <- query(stencil, 'geoms')
print(stencil_geoms)
```

Now we can select a WFS geometry layer (`geom`) and query for its attributes. 
```{r attribute, echo=T}
geom(stencil) <- stencil_geoms[2]

stencil_attributes <- query(stencil, 'attributes')
print(stencil_attributes)
```

Now we can select an attribute and query for the values of that attribute. For this demo, we won't set the values, but rather just move forward using all polygons in this geom
```{r value, echo=T}
attribute(stencil) <- stencil_attributes[2]

print(query(stencil, 'values'))
```

Now we'll set up our webdata with an OPeNDAP service as its url. Note that this can be any OPeNDAP service compatible with `geoknife` and the Geo Data Portal. What datasets are compatible is beyond the scope of this vignette. The OPeNDAP dataset used here is from the [main USGS THREDDS archive](https://cida.usgs.gov/thredds/) and is one included in `geoknife` but many other OPeNDAP datasets could be used by entering their OPeNDAP service base URL in the same way. 

```{r fabric, echo=T}
fabric <- webdata(url = 'https://cida.usgs.gov/thredds/dodsC/prism_v2', 
                  variables = c('tmx', 'tmn', 'ppt'),
                  times = as.POSIXct(c('2000-01-01', '2010-01-01')))
print(fabric)
```

Note that if you don't know the valid variables and times for an OPeNDAP URL, you can use `query` to find them like this.
```{r query_fabric, echo=T, warning=F}
fabric_variables <- query(fabric, "variables")
fabric_times <- query(fabric, "times")

print(paste(fabric@url, "has", 
            paste(fabric_variables, collapse = ", "), 
            "variables for the time range", fabric_times[1], 
            "to", fabric_times[2]))
```

Now we can execute the `geoknife` job for the specified fabric and stencil. Note that we set `wait = TRUE` here so we can just wait for the result of the process.

```{r execute, echo=T}
prism_yahara_result <- result(geoknife(stencil, fabric, wait = TRUE))
```

```{r print_execute, echo=F}
print(paste0("The returned dataframe has ", 
             ncol(prism_yahara_result), 
             " columns with names '", 
             paste(names(prism_yahara_result), collapse = "', '"), 
             "' and ", nrow(prism_yahara_result), 
             " rows from ", 
             prism_yahara_result[1,1], 
             " to ", 
             prism_yahara_result[nrow(prism_yahara_result), 1]))
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util-setJobState.R
\name{getJobState}
\alias{getJobState}
\title{get job state}
\usage{
getJobState()
}
\value{
\code{jobState} package variable
}
\description{
convenience function for retrieving package-level \code{jobState}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util-setJobState.R
\name{setJobState}
\alias{setJobState}
\title{set job state at package level for outgoing requests}
\usage{
setJobState(state = "none")
}
\arguments{
\item{state}{the state (as a character) to set \code{jobState} to.}
}
\value{
invisible return of \code{jobState} package variable
}
\description{
this function keeps the package from rifling off multiple requests 
while another is still pending. Package variable \code{jobState} is set with 
direct calls to this private function, or as part of any \code{status} type 
method for geojob
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/07-datagroup-obj.R
\name{abstract}
\alias{abstract}
\alias{title}
\alias{abstract,datagroup-method}
\alias{title,datagroup-method}
\title{get abstract from a datagroup}
\usage{
abstract(.Object)

\S4method{abstract}{datagroup}(.Object)

title(.Object)

\S4method{title}{datagroup}(.Object)
}
\arguments{
\item{.Object}{a datagroup object}
}
\description{
extracts the abstract information from a datagroup object
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util-geoknife.R
\name{gcontent}
\alias{gcontent}
\title{xml2 version of gcontent}
\usage{
gcontent(response)
}
\arguments{
\item{response}{the result of httr::GET(url)}
}
\description{
xml2 version of gcontent
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check-geojob.R
\name{check}
\alias{check}
\alias{check,geojob-method}
\alias{check,character-method}
\title{Check status of processing request}
\usage{
check(.Object)

\S4method{check}{geojob}(.Object)

\S4method{check}{character}(.Object)
}
\arguments{
\item{.Object}{a \linkS4class{geojob} object with an active GDP process request, 
or a \code{character} URL of an existing job}
}
\value{
\code{process}, a list containing
\code{status} and \code{URL}.
}
\description{
Check status of processing request
}
\details{
check is a method for checking the process status of an active (executed)
\linkS4class{geojob} object. The method returns \code{process}, which is a list containing
two fields: \code{status} and \code{URL}. If the \linkS4class{geojob} object has not been executed
(see \code{\link{start}}), this method returns \code{status}='none' and \code{URL}=NULL.
}
\examples{
gj <- geojob() # create geojob object
check(gj) # no process for empty geojob object
}
\seealso{
\code{\link{start}}
}
\author{
Jordan S. Read
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/03-webdata-obj.R
\docType{class}
\name{webdata-class}
\alias{webdata-class}
\title{webdata class}
\description{
a class for specifying details of web datasets (webdata!). These datasets have to be  
accessible through the OPeNDAP protocol.
}
\section{Slots}{

\describe{
\item{\code{times}}{vector of POSIXct dates (specifying start and end time of processing)}

\item{\code{url}}{URL of web data}

\item{\code{variables}}{variable(s) used for processing from dataset}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/geom-webgeom.R
\name{geom<-}
\alias{geom<-}
\alias{geom}
\alias{geom<-,webgeom-method}
\alias{geom,webgeom-method}
\title{the geom of an object}
\usage{
geom(.Object) <- value

geom(.Object)

\S4method{geom}{webgeom}(.Object) <- value

\S4method{geom}{webgeom}(.Object)
}
\arguments{
\item{.Object}{a \linkS4class{webgeom} object}

\item{value}{a geom}
}
\description{
The "feature" of a webgeom. This is the key mapping to the web resource 
that is used as the spatial feature of reference. Other details specified in 
\code{\link{attribute}} and \code{\link{values}}.
}
\seealso{
\code{\link{attribute}} and \code{\link{values}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util-initializeProcessInputs.R
\name{defaultProcessInputs}
\alias{defaultProcessInputs}
\title{Default Process Inputs}
\usage{
defaultProcessInputs(algorithm, wps_url, wps_version)
}
\arguments{
\item{algorithm}{the WPS algorithm to get process inputs for}

\item{wps_url}{the service base URL for the WPS}

\item{wps_version}{the service version to use}
}
\value{
list of default, optional, and required process inputs for use in the webprocess object.
}
\description{
parses DescribeProcess request
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/08-geoknife-function.R
\docType{methods}
\name{geoknife}
\alias{geoknife}
\title{geoknife}
\usage{
geoknife(stencil, fabric, knife = webprocess(...), show.progress = TRUE, ...)
}
\arguments{
\item{stencil}{a \code{\link{webgeom}}, \code{\link{simplegeom}}, or any type 
that can be coerced into \code{\link{simplegeom}}.}

\item{fabric}{a dataset. A \code{\link{webdata}} or any type that 
can be coerced into \code{\link{webdata}}}

\item{knife}{(optional) a \code{\link{webprocess}} object}

\item{show.progress}{logical (optional) display progress bar?}

\item{...}{additional arguments passed to \code{new} \code{\link{webprocess}}. 
Can also be used to modify the \code{knife} argument, if it is supplied.}
}
\value{
and object of class \linkS4class{geojob}
}
\description{
Creates the processing job and allows specifying the processing details.
}
\details{
The \code{stencil} argument is akin to cookie cutter(s), which specify how the dataset is 
to be sub-sampled spatially. Supported types are all geometric in nature, be they collections 
of points or polygons. Because geoprocessing operations require a non-zero area for \code{stencil}, 
if points are used (i.e., the different point collections that can be used in \code{\link{simplegeom}}), 
there is a negligible automatic point buffer applied to each point to result in a non-zero area. 

Naming of the components of the \code{stencil} will impact the formatting of the result returned by 
the geoknife processing job (the \code{\link{geojob}})

geoknife will check the class of the stencil argument, and if stencil's class is not
\code{\link{webgeom}}, it will attempt to coerce the object into a \code{\link{simplegeom}}. 
If no coercion method exists, geoknife will fail. 

The \code{fabric} argument is akin to the dough or fabric that will be subset with the \code{stencil} 
argument. At present, this is a web-available gridded dataset that meets a variety of formatting restrictions. 
Several quick start methods for creating a \code{\link{webdata}} object (only \code{\link{webdata}} or 
an type that can be coerced into \code{\link{webdata}} are valid arguments for \code{fabric}).

Making concurrent requests to the Geo Data Portal will NOT result in faster overall execution times. 
The data backing the system is on high performance storage, but that storage is not meant to support 
parallelized random access and can be significantly slower under these conditions.
}
\examples{
\dontrun{
job <- geoknife(stencil = c(-89,42), fabric = 'prism')
check(job)

#-- set up geoknife to email user when the process is complete

job <- geoknife(webgeom("state::Wisconsin"), fabric = 'prism', email = 'fake.email@gmail.com')

}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/version-generic.R
\name{version<-}
\alias{version<-}
\alias{version}
\alias{version<-,ANY-method}
\alias{version,ANY-method}
\title{the version of an object}
\usage{
version(.Object) <- value

version(.Object)

\S4method{version}{ANY}(.Object) <- value

\S4method{version}{ANY}(.Object)
}
\arguments{
\item{.Object}{a \linkS4class{webgeom} or \linkS4class{webprocess} object}

\item{value}{a version}
}
\description{
get the version of webgeom or webprocess
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/url-generic.R
\name{url<-}
\alias{url<-}
\alias{url}
\alias{url<-,ANY-method}
\alias{url<-,webprocess-method}
\alias{url,character-method}
\alias{url,missing-method}
\alias{url,datagroup-method}
\alias{url,ANY-method}
\title{the url of an object}
\usage{
url(.Object) <- value

url(.Object, ...)

\S4method{url}{ANY}(.Object) <- value

\S4method{url}{webprocess}(.Object) <- value

\S4method{url}{character}(.Object, ...)

\S4method{url}{missing}(.Object, ...)

\S4method{url}{datagroup}(.Object, ...)

\S4method{url}{ANY}(.Object, ...)
}
\arguments{
\item{.Object}{a \linkS4class{webgeom}, \linkS4class{webdata},}

\item{value}{a url}

\item{\dots}{additional arguments that would be passed to the masked base::url function.
These are only used when the .Object argument is character or missing
\linkS4class{geojob}, or \linkS4class{webprocess} object}
}
\description{
get or set the url of an object
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/01-geojob-obj.R
\docType{class}
\name{geojob-class}
\alias{geojob-class}
\title{geojob class}
\description{
contains the information for processing the job, and the versions 
of the resources used.
}
\section{Slots}{

\describe{
\item{\code{url}}{URL of web processing endpoint}

\item{\code{xml}}{XML character for post}

\item{\code{id}}{job identifier}

\item{\code{package.version}}{the version of the geoknife package}

\item{\code{algorithm.version}}{the version of the algorithm used for processing}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wait-geojob.R
\name{wait}
\alias{wait}
\alias{wait,geojob-method}
\alias{wait,character-method}
\title{hold up R while GDP is processing}
\usage{
wait(.Object, ...)

\S4method{wait}{geojob}(
  .Object,
  sleep.time = gconfig("sleep.time"),
  show.progress = gconfig("show.progress")
)

\S4method{wait}{character}(
  .Object,
  sleep.time = gconfig("sleep.time"),
  show.progress = gconfig("show.progress")
)
}
\arguments{
\item{.Object}{a geojob}

\item{...}{other arguments passed to methods}

\item{sleep.time}{numeric (optional) a number of seconds to wait in 
between checking the process}

\item{show.progress}{logical (optional) show progress bar or not}
}
\value{
invisible return of .Object, unaltered
}
\description{
keeps R in a loop while GDP works on the request. Checks \code{\link{running}}. 
Will drop out of loop whenever !running(geojob)
}
\examples{
\dontrun{
job <- geoknife(stencil = c(-89,42), fabric = 'prism')
2+2
wait(job, show.progress = TRUE)
check(job) # should be complete
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/processInputsToXML.R
\name{XML}
\alias{XML}
\alias{XML,webgeom-method}
\alias{XML,ANY,webdata,webprocess-method}
\title{XML from set of objects}
\usage{
XML(stencil, fabric, knife)

\S4method{XML}{ANY,webdata,webprocess}(stencil, fabric, knife)
}
\arguments{
\item{stencil}{a \code{\link{webdata}} OR \code{\link{simplegeom}} object}

\item{fabric}{a \code{\link{webdata}} object}

\item{knife}{a \code{\link{webprocess}} object}
}
\value{
XML as ?string?
}
\description{
Extract important parts of stencil, fabric, and knife into POST XML
}
\examples{
wd <- webdata('prism',times = as.POSIXct(c('2001-01-01','2002-02-05')))
wg <- webgeom('state::Wisconsin')
\dontrun{
XML(wg, wd, webprocess())
sg <- simplegeom(c(-89,45))
XML(sg, wd, webprocess())
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/query.R
\name{query}
\alias{query}
\alias{query,webdata-method}
\alias{query,webdata,character-method}
\alias{query,webdata,missing-method}
\alias{query,character,missing-method}
\alias{query,webprocess,character-method}
\alias{query,webprocess-method}
\alias{query,webgeom,character-method}
\alias{query,webgeom-method}
\title{query webdata for various fields}
\usage{
query(.Object, field, ...)

\S4method{query}{webdata,character}(.Object, field, ...)

\S4method{query}{webdata,missing}(.Object, field, ...)

\S4method{query}{character,missing}(.Object, field, ...)

\S4method{query}{webprocess,character}(.Object, field, ...)

\S4method{query}{webgeom,character}(.Object, field, ...)
}
\arguments{
\item{.Object}{a \code{webdata}, \code{webgeom}, or \code{webprocess} object.}

\item{field}{a plural parameter name for fields in .Object (e.g., 'variables', 'times')}

\item{...}{additional arguments passed to methods}
}
\value{
a character vector of values corresponding to the query field specified
}
\description{
a method for finding possible values for a given field
}
\examples{
\dontrun{
fabric <- webdata('prism')
query(fabric, 'variables')
wg <- webgeom()
query(wg, 'geoms')
geom(wg) <- "sample:CONUS_states"
query(wg, 'attributes')
attribute(wg) <- 'STATE'
query(wg, 'values', rm.duplicates = TRUE)
}
}
\author{
Jordan S. Read
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/result.R
\docType{methods}
\name{result}
\alias{result}
\alias{result,geojob-method}
\alias{result,character-method}
\title{parse process output into R environment}
\usage{
result(.Object, ...)

\S4method{result}{geojob}(.Object, ...)

\S4method{result}{character}(.Object, ...)
}
\arguments{
\item{.Object}{a \code{\link{geojob}} object with a successful processID,
or a \code{character} URL of a completed job.
(See \code{\link{check}}).}

\item{...}{additional arguments passed to parsers (e.g., with.units = TRUE)}
}
\value{
data.frame of timeseries values.
}
\description{
a \code{geojob} method for loading data into R from a completed processing request
}
\examples{
\dontrun{
job <- geoknife(stencil = c(-89,42), fabric = 'prism', wait = TRUE)
result(job, with.units = TRUE) # load and print output

# or use the job id:
id <- id(job)
result(id, with.units = TRUE) # load and print output
}

}
\author{
Jordan S. Read
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/query-webdata-variables.R
\name{variables_query}
\alias{variables_query}
\alias{variables_query,webdata-method}
\alias{variables_query,webdata,missing-method}
\alias{variables_query,webdata,webprocess-method}
\title{variables query}
\usage{
variables_query(fabric, knife)

\S4method{variables_query}{webdata,missing}(fabric, knife)

\S4method{variables_query}{webdata,webprocess}(fabric, knife)
}
\arguments{
\item{variables}{}
}
\description{
find possible variables in a webdata dataset
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/algorithm-webprocess.R
\name{algorithm}
\alias{algorithm}
\alias{algorithm<-}
\alias{algorithm,webprocess-method}
\alias{algorithm<-,webprocess-method}
\alias{algorithm,xml_document-method}
\title{the algorithm of a webprocess object}
\usage{
algorithm(.Object)

algorithm(.Object) <- value

\S4method{algorithm}{webprocess}(.Object)

\S4method{algorithm}{webprocess}(.Object) <- value

\S4method{algorithm}{xml_document}(.Object)
}
\arguments{
\item{.Object}{a \linkS4class{webprocess} object}

\item{value}{a list with name of algorithm and relative url endpoint}
}
\description{
Functions to get or set the algorithm of a \linkS4class{webprocess} object. 
The algorithm is the type of process that will be used, and can be accessed 
or modified using the algorithm method.
}
\examples{
\dontrun{
wp <- webprocess()
algorithm(wp)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cancel-geojob.R
\docType{methods}
\name{cancel}
\alias{cancel}
\alias{cancel,geojob-method}
\alias{cancel,missing-method}
\title{cancel a geo-web processing request}
\usage{
cancel(.Object)

\S4method{cancel}{geojob}(.Object)

\S4method{cancel}{missing}(.Object)
}
\arguments{
\item{.Object}{a \linkS4class{geojob} object with an active geo-web processing request.}
}
\value{
A \linkS4class{geojob} object with no active job
}
\description{
Cancel process for \code{geojob}
}
\details{
cancel is a method for cancelling a geo-web processing request.
}
\examples{
wd <- webdata('prism')
wg <- webgeom('state::New Hampshire')
wp <- webprocess()

\dontrun{
if(!any(is.null(wp), is.null(wg), is.null(wd))) {
 gj <- geojob()
 xml(gj) <- XML(wg, wd, wp)
 url(gj) <- url(wp)
}

gj <- start(gj)
gj <- cancel(gj)
}
}
\seealso{
\code{check}, \code{start}
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/start-geojob.R
\docType{methods}
\name{start}
\alias{start}
\alias{start,geojob-method}
\title{Submit a GDP web processing request}
\usage{
start(.Object)

\S4method{start}{geojob}(.Object)
}
\arguments{
\item{.Object}{a \linkS4class{geojob} object}
}
\value{
A \linkS4class{geojob} object with an active GDP process request.
}
\description{
Start process for \code{\link{geojob}}
}
\details{
start a geo-web processing request

 start is a method for submitting a geo-web processing request.
}
\examples{
wd <- webdata('prism')
wg <- webgeom('state::New Hampshire')
wp <- webprocess()
gj <- geojob()
\dontrun{
xml(gj) <- XML(wg, wd, wp)
url(gj) <- url(wp)
gj <- start(gj)
}
}
\seealso{
\code{\link{check}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/attribute-webgeom.R
\name{attribute<-}
\alias{attribute<-}
\alias{attribute}
\alias{attribute<-,webgeom-method}
\alias{attribute,webgeom-method}
\title{the attribute of an webgeom object}
\usage{
attribute(.Object) <- value

attribute(.Object)

\S4method{attribute}{webgeom}(.Object) <- value

\S4method{attribute}{webgeom}(.Object)
}
\arguments{
\item{.Object}{a \linkS4class{webgeom} object}

\item{value}{a attribute}
}
\description{
get or set the attribute of a webgeom object.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/email-geojob.R
\name{email}
\alias{email}
\alias{email,geojob-method}
\alias{email,geojob,webprocess-method}
\title{email user when processing job is complete}
\usage{
email(geojob, knife)

\S4method{email}{geojob,webprocess}(geojob, knife)
}
\arguments{
\item{email}{a character for email address to use}
}
\description{
configure job to send an email when complete (success or failure)
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util-bufferPoint.R
\name{bufferPoint}
\alias{bufferPoint}
\title{Create linear ring from point}
\usage{
bufferPoint(point)
}
\arguments{
\item{point}{A vector of longitude and latitude values}
}
\value{
A linear ring (with closure) as a numeric vector
}
\description{
Buffer ring creation from point
}
\details{
bufferPoint is a function that takes a longitude and latitude pair and creates
a buffered ring (i.e., a feature with non-zero area) centered.
}
\examples{
linearRing = bufferPoint(c(-111.48, 36.95))
}
\seealso{
\linkS4class{simplegeom}
}
\author{
Jordan S. Read
}
\keyword{internal}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/04-webprocess-obj.R
\docType{class}
\name{webprocess-class}
\alias{webprocess-class}
\title{webprocess class}
\description{
A class representing geoknife web processing specifications
}
\section{Slots}{

\describe{
\item{\code{url}}{URL for webprocessing service. 
Can be set or accessed using \code{\link[geoknife]{url}}}

\item{\code{algorithm}}{a list for algorithm used. 
Can be set or accessed using \code{\link{algorithm}}}

\item{\code{version}}{a character specifying the wep processing service version to use. 
Can be set or accessed using \code{\link[geoknife]{version}}}

\item{\code{email}}{an email to send finished process alert to}

\item{\code{wait}}{boolean for wait until complete (hold up R until processing is complete)}

\item{\code{sleep.time}}{numeric for time to wait in between calls to \code{\link{check}}. Only used if \code{wait=TRUE}}

\item{\code{processInputs}}{(_private) a list of required and options process inputs, and their 
default values (if specified). This is populated (or repopulated) whenever \code{algorithm} is set.}

\item{\code{WPS_SCHEMA_LOCATION}}{(_private) location for web processing service schema}

\item{\code{WPS_NAMESPACE}}{(_private) location for web processing service namespace}

\item{\code{OWS_NAMESPACE}}{(_private) namespace web location}

\item{\code{XSI_SCHEMA_LOCATION}}{(_private) schema web location}

\item{\code{XSI_NAMESPACE}}{(_private) namespace web location}

\item{\code{XLINK_NAMESPACE}}{(_private) namespace web location}

\item{\code{UTILITY_URL}}{(_private) web processing service utility url. Uses same base url as
public slot \code{url}}

\item{\code{OGC_NAMESPACE}}{(_private) namespace web location}

\item{\code{emailK}}{(_private) relative url for email when complete utility.}
}}

\seealso{
\code{\link{webprocess}}, \code{\link[geoknife]{url}}, 
\code{\link{algorithm}}, \code{\link[geoknife]{version}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/04-webprocess-obj.R
\name{webprocess}
\alias{webprocess}
\alias{webprocess,missing-method}
\alias{webprocess,character-method}
\alias{webprocess,ANY-method}
\title{create webprocess object}
\usage{
webprocess(.Object, ...)

\S4method{webprocess}{missing}(.Object, ...)

\S4method{webprocess}{character}(
  .Object = c("summary", "unweighted summary", "coverage summary", "subset",
    "coverage subset"),
  ...
)

\S4method{webprocess}{ANY}(.Object, ...)
}
\arguments{
\item{.Object}{any object that can be coerced into \linkS4class{webprocess}}

\item{...}{additional arguments passed initialize method (e.g., \code{url}, \code{version})}
}
\value{
the webprocess object
}
\description{
create webprocess object
}
\author{
Jordan S Read
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/query-webdata-times.R
\name{times_query}
\alias{times_query}
\alias{times_query,webdata-method}
\alias{times_query,webdata,missing-method}
\alias{times_query,webdata,webprocess-method}
\title{times query}
\usage{
times_query(fabric, knife)

\S4method{times_query}{webdata,missing}(fabric, knife)

\S4method{times_query}{webdata,webprocess}(fabric, knife)
}
\description{
query a webdata object for the time range
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check-geojob.R
\name{successful}
\alias{successful}
\alias{running}
\alias{error}
\title{Convenience function for GDP process state}
\usage{
successful(.Object, retry)
error(.Object, retry)
running(.Object, retry)

running(.Object, retry = FALSE)

error(.Object, retry = FALSE)
}
\arguments{
\item{.Object}{a \linkS4class{geojob} object or geojob ID (character)}

\item{retry}{logical, attempt to retry again if communication failed with the server}
}
\value{
TRUE/FALSE indicating if process is in the given state (error, processing, successful)
}
\description{
Simple wrapper to check process status
}
\examples{
\dontrun{
job <- geoknife(stencil = c(-89,42), fabric = 'prism')
check(job)

running(job)
error(job)
successful(job)
}

}
\seealso{
\code{\link{check}}
}
\author{
Luke Winslow, Jordan S Read
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util-geoknife.R
\name{retryVERB}
\alias{retryVERB}
\title{simple retry for httr VERBs}
\usage{
retryVERB(VERB, url, ..., retries = gconfig("retries"))
}
\arguments{
\item{VERB}{\code{httr} function}

\item{url}{a url}

\item{\dots}{additional args passed into VERB}

\item{retries}{number of times to try before failing}
}
\description{
Useful for intermittent server issues, when a retry will get the job done
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/values-webgeom.R
\name{values<-}
\alias{values<-}
\alias{values}
\alias{values<-,webgeom-method}
\alias{values,webgeom-method}
\title{the values of a webgeom}
\usage{
values(.Object) <- value

values(.Object)

\S4method{values}{webgeom}(.Object) <- value

\S4method{values}{webgeom}(.Object)
}
\arguments{
\item{.Object}{a \linkS4class{webgeom} object}

\item{value}{a values}
}
\description{
The values of a webgeom are the values of the attributes used in the geometries. 
For example, if the webgeom's "geom" field is a feature collection containing states 
and counties, and the "attributes" are the states, then the values would be the 
specific states.
}
\examples{
wg <- webgeom('state::Wisconsin')
values(wg)
values(wg) <- c('Wisconsin','New Hampshire')
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util-parseCategorical.R
\name{parseCategorical}
\alias{parseCategorical}
\title{parse categorical coverage file into R environment}
\usage{
parseCategorical(file, delim)
}
\arguments{
\item{file}{a \linkS4class{geojob} categorical processing result file location
(See \code{\link{download}}).}

\item{delim}{the file delimiter}
}
\value{
a data.frame of categorical fraction (and/or count) values.
}
\description{
a function for loading data into R from a file (or URL) from a completed processing request
}
\examples{
local.file <- system.file('extdata','csv_categorical_multifeature.csv', package = 'geoknife')
output <- parseCategorical(local.file, delim = ',')
}
\seealso{
\code{\link{check}}, \code{\link{download}}, \code{\link{parseTimeseries}}
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/inputs-webprocess.R
\name{inputs<-}
\alias{inputs<-}
\alias{inputs}
\alias{inputs,webprocess-method}
\alias{inputs,xml_document-method}
\alias{inputs<-,webprocess,missing-method}
\alias{inputs<-,webprocess,character-method}
\alias{inputs<-,webprocess,list-method}
\title{inputs of webprocess}
\usage{
inputs(.Object, ...) <- value

inputs(.Object, ..., value)

\S4method{inputs}{webprocess}(.Object, ..., value)

\S4method{inputs}{xml_document}(.Object, ..., value)

\S4method{inputs}{webprocess,missing}(.Object, ...) <- value

\S4method{inputs}{webprocess,character}(.Object, ...) <- value

\S4method{inputs}{webprocess,list}(.Object, ...) <- value
}
\arguments{
\item{.Object}{a webprocessing object}

\item{\dots}{arguments matching fields in .Object's processInputs slot}

\item{value}{a field pair for .Object processInputs}
}
\description{
The webprocess inputs are a list of parameter names and their associated values.  
These inputs are specific to an individual \code{algorithm} used by the webprocess, 
and are pulled in from the web with defaults. An NA value in an input field means that 
this parameter will be left out of the web processing request. NULL values are required fields 
for the post and must be populated. For some values, there are defaults used if NULL (e.g.,
the mean for 'STATISTIC' is "mean"). Only characters can be used in input fields, but 
booleans are changed to characters as 'true' and 'false'.

access or set the inputs of a webprocess
}
\examples{
\dontrun{
wp <- webprocess(DELIMITER = 'TAB')
inputs(wp)

inputs(wp) <- list(DELIMITER = 'COMMA', SUMMARIZE_FEATURE_ATTRIBUTE = 'false')
inputs(wp)
inputs(wp, "DELIMITER")
inputs(wp, "DELIMITER") <- "TAB"
}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/03-webdata-obj.R
\docType{methods}
\name{webdata}
\alias{webdata}
\alias{webdata,missing-method}
\alias{webdata,character-method}
\alias{webdata,geojob-method}
\alias{webdata,ANY-method}
\title{create webdata object}
\usage{
webdata(.Object, ...)

\S4method{webdata}{missing}(.Object, ...)

\S4method{webdata}{character}(
  .Object = c("prism", "iclus", "daymet", "gldas", "nldas", "topowx", "solar", "metobs"),
  ...
)

\S4method{webdata}{geojob}(.Object, ...)

\S4method{webdata}{ANY}(.Object, ...)
}
\arguments{
\item{.Object}{any object that can be coerced into \linkS4class{webdata} 
(currently \code{character}, \code{webdata}, and \code{list})}

\item{...}{additional arguments passed initialize method (e.g., times, or any other 
in the \linkS4class{webdata} object.}
}
\value{
the webdata object representing a dataset and parameters
}
\description{
A class representing a web dataset.
}
\section{Slots}{

\describe{
\item{\code{times}}{value of type \code{"POSIXct"}, start and stop dates for data}

\item{\code{url}}{value of type \code{"character"}, the web location for the dataset}

\item{\code{variable}}{value of type \code{"character"}, the variable(s) for data}
}}

\examples{
webdata('prism')
webdata('prism', times=as.POSIXct(c('1990-01-01', '1995-01-01')))
webdata(list(times = as.POSIXct(c('1895-01-01 00:00:00','1899-01-01 00:00:00')),
 url = 'https://cida.usgs.gov/thredds/dodsC/prism',
 variables = 'ppt'))
}
\author{
Jordan S Read
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/download-geojob.R
\name{download}
\alias{download}
\alias{download,geojob,missing-method}
\alias{download,character,missing-method}
\alias{download,geojob,character-method}
\alias{download,character,character-method}
\title{download output from geojob}
\usage{
download(.Object, destination, ...)

\S4method{download}{geojob,missing}(.Object, destination, ...)

\S4method{download}{character,missing}(.Object, destination, ...)

\S4method{download}{geojob,character}(.Object, destination, ...)

\S4method{download}{character,character}(.Object, destination, ...)
}
\arguments{
\item{.Object}{a \code{\link{geojob}} or job id that has completed}

\item{destination}{a file destination. If missing, a temp directory will be used}

\item{...}{additional arguments passed to \code{\link[httr]{write_disk}}, such as overwrite = TRUE}
}
\value{
the location of the downloaded file
}
\description{
download the result of a processing job to a local destination.
}
\author{
Jordan S Read
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/02-webgeom-obj.R
\name{webgeom}
\alias{webgeom}
\alias{webgeom,missing-method}
\alias{webgeom,ANY-method}
\title{create webgeom object}
\usage{
webgeom(.Object, ...)

\S4method{webgeom}{missing}(.Object, ...)

\S4method{webgeom}{ANY}(.Object, ...)
}
\arguments{
\item{.Object}{any object that can be coerced into \linkS4class{webgeom}}

\item{\dots}{additional arguments passed initialize method (e.g., \code{\link{url}}). See 
the named slots above for arguments for \dots}
}
\value{
the webgeom object representing a dataset and parameters
}
\description{
A class representing a web available feature geometry.
}
\details{
slots can be accessed or set with methods of the same names 
(e.g., url(webgeom()))
}
\section{Slots}{

\describe{
\item{\code{url}}{value of type \code{"character"}, the web location for the web feature service}

\item{\code{geom}}{value of type \code{"character"}, the feature for webgeom}

\item{\code{attribute}}{the attribute (e.g., "State")}

\item{\code{values}}{the values of the attribute, (e.g., "Wisconsin") or NA (all)}
}}

\examples{
wg <- webgeom(geom = "sample:CONUS_states", 
 attribute = "STATE",
 values = "New Hampshire")
#-- use available state datasets:
wg <- webgeom('state::New Hampshire')
wg <- webgeom('state::New Hampshire,Wisconsin,Alabama')
#-- use available Level III Ecoregion datasets:
wg <- webgeom('ecoregion::Colorado Plateaus,Driftless Area')
#-- use available simplified HUC8s:
wg <- webgeom('HUC8::09020306,14060009')
wg <- webgeom()

\dontrun{
## Steps to find data on Howard County in Texas:
#1) locate the \code{geom} for counties by looking at the options for geoms
query(webgeom(), 'geoms') # discover sample:Counties
#2) locate the \code{attribute} for county names by looking at the options for attributes
query(webgeom(geom='sample:Counties'), 'attributes') # discover FIPS
#3) find the appropriate fip code for the county:
howard.fips <- "48227"
#4) create a webgeom for the Howard County in Texas
stencil <- webgeom(geom='sample:Counties', attribute='FIPS', values=howard.fips)
#5) get data for Howard County
fabric <- webdata(url = 'https://cida.usgs.gov/thredds/dodsC/stageiv_combined', 
variables = "Total_precipitation_surface_1_Hour_Accumulation", 
times = c(as.POSIXct("2016-06-06 05:00:00"), 
          as.POSIXct("2016-06-07 05:00:00")))
job <- geoknife(stencil, fabric, wait = TRUE)
precipData <- result(job)
head(precipData)
}
}
\seealso{
\code{\link{url}}, \code{\link{geom}}, \code{\link{attribute}}, \code{\link{values}}
}
\author{
Jordan S Read
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/06-simplegeom-obj.R
\docType{class}
\name{simplegeom-class}
\alias{simplegeom-class}
\title{simplegeom class}
\description{
The \code{simplegeom} class represents geometries that can 
be coerced into polygon features. This is one of two \code{stencil} types 
accepted by \code{\link{geoknife}} (the other being \linkS4class{webgeom}).
}
\details{
The difference between \linkS4class{webgeom} and \linkS4class{simplegeom} 
is both in the permanence and the location of the data. \linkS4class{webgeom} is 
located on a web server that offers geometries using the web feature service (WFS) 
specification. \linkS4class{simplegeom} are typically local data that can be accessed 
within an R session. Within reason, anything that can be represented as a 
\linkS4class{webgeom} (or WFS) can also be represented by a \linkS4class{simplegeom} 
For example, a state or watershed can be read in as \code{\link[sf]{read_sf}} 
object and turned into a \linkS4class{simplegeom}. IDs of a web geom are the
row order of the geometries.
}
\section{Slots}{

\describe{
\item{\code{sf}}{an sf data.frame object with polygon geometries}

\item{\code{sp}}{an sp object provided for backward compatibility}

\item{\code{DRAW_NAMESPACE}}{(_private) web location of draw namespace}

\item{\code{DRAW_SCHEMA}}{(_private) web location of draw schema}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util-parseTimeseries.R
\name{parseTimeseries}
\alias{parseTimeseries}
\title{parse timeseries file into R environment}
\usage{
parseTimeseries(file, delim, with.units = FALSE)
}
\arguments{
\item{file}{a \linkS4class{geojob} timeseries processing result file location
(See \code{\link{download}}).}

\item{delim}{the file delimiter}

\item{with.units}{boolean for including a units column in returned data.frame (default = \code{FALSE})}
}
\value{
a data.frame of timeseries values.
}
\description{
a function for loading data into R from a file (or URL) from a completed processing request
}
\examples{
local_file <- system.file('extdata','tsv_linear_ring.tsv', package = 'geoknife')
output <- parseTimeseries(local_file, delim = '\t')
}
\seealso{
\code{\link{check}}, \code{\link{download}}, \code{\link{parseCategorical}}
}
\author{
Luke A. Winslow, Jordan S. Read
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/01-geojob-obj.R
\name{geojob}
\alias{geojob}
\alias{geojob,missing-method}
\alias{geojob,geojob-method}
\alias{geojob,xml_document-method}
\alias{geojob,character-method}
\alias{xml<-}
\alias{xml<-,geojob-method}
\alias{xml}
\alias{xml,geojob-method}
\alias{id<-}
\alias{id,geojob-method}
\alias{id}
\alias{id<-,geojob-method}
\alias{id,character-method}
\title{create geojob object}
\usage{
geojob(xml, ...)

\S4method{geojob}{missing}(xml, ...)

\S4method{geojob}{xml_document}(xml, ...)

\S4method{geojob}{character}(xml, ...)

xml(.Object) <- value

xml(.Object)

id(.Object)
id(.Object) <- value

id(.Object)

\S4method{id}{geojob}(.Object) <- value

\S4method{id}{geojob}(.Object)

\S4method{id}{character}(.Object)
}
\arguments{
\item{xml}{location of xml (URL or local path)}

\item{...}{additional arguments passed to initialize method}

\item{.Object}{a \code{\link{geojob}} object}

\item{value}{a character string of xml}
}
\value{
the geojob object
}
\description{
A class representing a geoknife job (\code{geojob}).
}
\examples{
xml <- "<foo> <bar> text <baz/> </bar> </foo>"
gj <- geojob()
xml(gj) <- xml
xml(gj)
xml <- "<foo version=\"1.0.0\"> <bar> text <baz/> </bar> </foo>"
gj <- geojob(xml = xml)
xml(gj)
id(gj)
}
\author{
Jordan S Read
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00-gconfig.R
\name{gconfig}
\alias{gconfig}
\title{configure geoknife settings}
\usage{
gconfig(..., no.readonly = FALSE)
}
\arguments{
\item{\dots}{values for gconfig}

\item{no.readonly}{currently not implemented for \code{TRUE}}
}
\value{
Borrowed text and functionality from \code{\link[graphics]{par}}. 
When parameters are set, their previous values are returned in an invisible named list. 
Such a list can be passed as an argument to par to restore the parameter values. Use gconfig(no.readonly = TRUE) 
for the full list of parameters that can be restored. When just one parameter is queried, the value of that 
parameter is returned as (atomic) vector. When two or more parameters are queried, their values are returned 
in a list, with the list names giving the parameters. Note the inconsistency: setting one parameter returns a list, 
but querying one parameter returns a vector.
}
\description{
access and set defaults for geoknife configuration
}
\examples{
gconfig # all config
gconfig('wait')
gconfig('sleep.time' = 10)
gconfig('sleep.time' = 8, wait=TRUE)
gconfig('progress' = FALSE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/variables-webdata.R
\docType{methods}
\name{variables}
\alias{variables}
\alias{variables<-}
\alias{variables,webdata-method}
\alias{variables<-,webdata-method}
\title{the variables of a webdata object}
\usage{
variables(.Object)
variables(.Object) <- value

variables(.Object) <- value

\S4method{variables}{webdata}(.Object)

\S4method{variables}{webdata}(.Object) <- value
}
\arguments{
\item{.Object}{a \code{\link{webdata}} object}

\item{value}{a character vector for variables}
}
\description{
access or set the variables of a webdata object
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util-setJobState.R
\name{canStart}
\alias{canStart}
\title{can start a new job?}
\usage{
canStart()
}
\value{
TRUE or FALSE
}
\description{
checks package job state and returns a boolean for whether a new job can be started
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/06-simplegeom-obj.R
\name{simplegeom}
\alias{simplegeom}
\alias{simplegeom,missing-method}
\alias{simplegeom,ANY-method}
\title{Create simplegeom object}
\usage{
simplegeom(.Object, ...)

\S4method{simplegeom}{missing}(.Object, ...)

\S4method{simplegeom}{ANY}(.Object, ...)
}
\arguments{
\item{.Object}{any object that can be coerced into \linkS4class{simplegeom}}

\item{...}{additional arguments passed to \code{\link[sf]{st_sf}}}
}
\value{
the simplegeom object
}
\description{
A simple geom is a simple set of geometries specified locally. See 
\code{\link{webgeom}} for web features.
}
\examples{

simplegeom(c(-88.6, 45.2))

p1 <- sf::st_polygon(list(cbind(c(-89.0001,-89,-88.9999,-89,-89.0001),
                                c(46,46.0001,46,45.9999,46))))

p2 <- sf::st_polygon(list(cbind(c(-88.6,-88.5999,-88.5999,-88.6,-88.6),
                                c(45.2,45.2,45.1999,45.1999,45.2))))

P <- simplegeom(
  sf::st_sf(geo = sf::st_sfc(list(p1, p2), crs = 4326))
)

\dontrun{
result(geoknife(P, "prism", wait = TRUE))
}

simplegeom(data.frame('point1'=c(-89, 46), 'point2'=c(-88.6, 45.2)))

}
\author{
Jordan S Read
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/02-webgeom-obj.R
\docType{class}
\name{webgeom-class}
\alias{webgeom-class}
\title{webgeom class}
\description{
The \code{webgeom} class represents a web feature service (WFS) dataset.
WFS is an open geospatial consortium standard for spatial data on the web. WFS supports 
filtering of spatial elements and this object can support many of those filters.
}
\section{Slots}{

\describe{
\item{\code{url}}{URL of web feature service endpoint. 
Can be set or accessed using \code{\link[geoknife]{url}}}

\item{\code{geom}}{character for geometric feature name. 
Can be set or accessed using \code{\link[geoknife]{geom}}}

\item{\code{attribute}}{character for feature attribute (used for filtering and naming in output)
Can be set or accessed using \code{\link[geoknife]{attribute}}}

\item{\code{values}}{character vector of attribute values to be used in processing (a subset, or all if NA)
Can be set or accessed using \code{\link[geoknife]{values}}}

\item{\code{version}}{a character that specifies the web feature service (WFS) version to use.
Can be set or accessed using \code{\link[geoknife]{version}}}

\item{\code{GML_IDs}}{(_private) IDs that correspond to \code{values}. Used internally for processing.}

\item{\code{WFS_NAMESPACE}}{(_private) web location of web feature service namespace}

\item{\code{GML_NAMESPACE}}{(_private) web location of GML namespace}

\item{\code{GML_SCHEMA_LOCATION}}{(_private) web location of GML schema location}
}}

\seealso{
\code{\link{webgeom}}, \code{\link[geoknife]{url}}, \code{\link[geoknife]{geom}}, 
\code{\link[geoknife]{attribute}}, \code{\link[geoknife]{values}}, \code{\link[geoknife]{version}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/07-datagroup-obj.R
\name{datagroup}
\alias{datagroup}
\alias{datagroup,ANY-method}
\alias{datagroup,datagroup-methods}
\alias{length,datagroup-method}
\alias{[,datagroup-method}
\alias{[[,datagroup-method}
\title{create datagroup object}
\usage{
datagroup(...)

\S4method{datagroup}{ANY}(...)

\S4method{length}{datagroup}(x)

\S4method{[}{datagroup}(x, i, j, ..., drop = TRUE)

\S4method{[[}{datagroup}(x, i, j, ..., drop = TRUE)
}
\arguments{
\item{...}{additional arguments passed to initialize method}

\item{x}{a datagroup object}

\item{i}{index specifying elements to extract or replace.}

\item{j}{not implemented}

\item{drop}{not implemented}
}
\value{
the datagroup object
}
\description{
A class representing a geoknife job (\code{datagroup}).
}
\author{
Jordan S Read
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/times-webdata.R
\name{times}
\alias{times}
\alias{times<-}
\alias{times<-,webdata-method}
\alias{times,webdata-method}
\title{the times of an webdata object}
\usage{
times(.Object)

times(.Object) <- value

\S4method{times}{webdata}(.Object) <- value

\S4method{times}{webdata}(.Object)
}
\arguments{
\item{.Object}{a \code{\link{webdata}} object}

\item{value}{a POSIXct vector}
}
\description{
Functions to get or set the times of a \code{\link{webdata}} object
}
\examples{
wd <- webdata('prism')
times(wd) <- as.POSIXct(c("2012-11-04", "2012-11-12"))
times(wd)[1] <- as.POSIXct("2012-11-04")
times(wd)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/07-datagroup-obj.R
\docType{class}
\name{datagroup-class}
\alias{datagroup-class}
\title{datagroup class}
\description{
contains collections of webdata that can be processed with 
\code{\link{geoknife}}
}
\section{Slots}{

\describe{
\item{\code{group}}{a list of webdata compatible elements}
}}
